import { BFormInput as go, BFormInvalidFeedback as ht, BFormGroup as gt, BFormCheckbox as du, BFormCheckboxGroup as yu, BFormRadioGroup as mu, BFormSelect as pu, BFormTextarea as vu, BForm as Qu, BFormFloatingLabel as Ku, BFormRadio as Zu, BFormRow as Xu, BFormSelectOption as Ju, BFormSelectOptionGroup as el, BFormSpinButton as tl, BFormTag as nl, BFormTags as rl, BFormText as al, BFormValidFeedback as ol } from "bootstrap-vue-next";
import { computed as F, unref as c, defineComponent as Ee, openBlock as w, createElementBlock as E, toDisplayString as Te, createBlock as fe, normalizeClass as pe, withCtx as Q, createTextVNode as Ve, createVNode as Re, isRef as We, createElementVNode as se, renderSlot as W, createCommentVNode as x, reactive as Xt, ref as L, useSlots as bo, toRef as Gn, onMounted as at, onUnmounted as wo, watch as Dt, mergeProps as Fe, createSlots as Xe, renderList as Ae, normalizeProps as Je, guardReactiveProps as yt, Fragment as he, withKeys as me, withModifiers as mt, Transition as Ut, normalizeStyle as kt, nextTick as Yt, resolveDynamicComponent as il, withDirectives as an, vShow as on, onBeforeUpdate as ul, getCurrentScope as ll, onScopeDispose as sl } from "vue";
function Mt(e, t) {
  const n = F(() => {
    const i = c(e.showAsRequired);
    if (i === !1 || i === !0)
      return !!i;
    if (e.validation !== void 0) {
      const s = JSON.parse(JSON.stringify(e.validation));
      if (s && typeof s == "object")
        return Object.keys(s).filter((l) => !`${l}`.startsWith("$")).length > 0;
    }
    return !1;
  }), r = F(() => {
    const i = c(e.validation);
    return (i == null ? void 0 : i.$invalid) !== void 0 && i.$dirty ? i.$invalid : null;
  });
  return {
    isRequired: n,
    invalid: r,
    onEvent: function(i) {
      return (s) => {
        t(i, s);
      };
    },
    formatValue: function(i) {
      const s = c(e.formatter);
      return typeof s == "function" ? s(i) : i;
    }
  };
}
const cl = Ee({
  name: "FormInputFeedbackMessage",
  props: {
    messages: {
      type: Object,
      required: !1
    },
    validationModel: {
      type: Object,
      required: !0
    }
  },
  computed: {
    ruleNames() {
      return [
        ...new Set(
          [
            "required",
            "requiredIf",
            "requiredUnless",
            "minLength",
            "maxLength",
            "minValue",
            "maxValue",
            "between",
            "alpha",
            "alphaNum",
            "numeric",
            "integer",
            "decimal",
            "email",
            "ipAddress",
            "macAddress",
            "sameAs",
            "url",
            "validated_email"
            // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
          ].concat(this.messages ? Object.keys(this.messages) : [])
        )
      ];
    },
    message() {
      const e = Object.keys(this.validationModel).filter((t) => !`${t}`.startsWith("$"));
      for (const t of e)
        if (this.ruleNames.includes(t) && this.validationModel[t].$invalid)
          return this.messages && this.messages[t] ? this.messages[t] : this.getDefaultMessage(t, this.validationModel[t].$params || {});
      return this.getDefaultMessage();
    }
  },
  methods: {
    getDefaultMessage(e, t) {
      let n;
      if (t === void 0 && (t = {}), this.$t !== void 0 && typeof this.$t == "function")
        switch (e) {
          case "required":
          case "requiredIf":
          case "requiredUnless":
            return this.$t("vueFormInputs.feedback.required");
          case "minLength":
            return this.$t("vueFormInputs.feedback.minLength", { minLength: t.min });
          case "maxLength":
            return this.$t("vueFormInputs.feedback.maxLength", { maxLength: t.max });
          case "minValue":
            return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, this.$t("vueFormInputs.feedback.minValue", { minValue: n });
          case "maxValue":
            return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, this.$t("vueFormInputs.feedback.maxValue", { maxValue: n });
          case "between":
            return this.$t("vueFormInputs.feedback.between", { betweenMin: t.min, betweenMax: t.max });
          case "alpha":
            return this.$t("vueFormInputs.feedback.alpha");
          case "alphaNum":
            return this.$t("vueFormInputs.feedback.alphaNum");
          case "numeric":
            return this.$t("vueFormInputs.feedback.numeric");
          case "integer":
            return this.$t("vueFormInputs.feedback.integer");
          case "decimal":
            return this.$t("vueFormInputs.feedback.decimal");
          case "email":
            return this.$t("vueFormInputs.feedback.email");
          case "ipAddress":
            return this.$t("vueFormInputs.feedback.ipAddress");
          case "macAddress":
            return this.$t("vueFormInputs.feedback.macAddress");
          case "sameAs":
            return this.$t("vueFormInputs.feedback.sameAs");
          case "url":
            return this.$t("vueFormInputs.feedback.url");
          case "validated_email":
          case "validatedEmail":
            return this.$t("vueFormInputs.feedback.validatedEmail");
          default:
            return this.$t("vueFormInputs.feedback.invalidValue");
        }
      switch (e) {
        case "required":
        case "requiredIf":
        case "requiredUnless":
          return "Toto pole je nutné vyplnit.";
        case "minLength":
          return `Hodnota musí být minimálně ${t.min} znaků dlouhá.`;
        case "maxLength":
          return `Hodnota musí být maximálně ${t.max} znaků dlouhá.`;
        case "minValue":
          return n = t.min instanceof Date ? t.min.toLocaleDateString() : t.min, `Hodnota musí být minimálně ${n}.`;
        case "maxValue":
          return n = t.max instanceof Date ? t.max.toLocaleDateString() : t.max, `Hodnota musí být maximálně ${n}.`;
        case "between":
          return `Hodnota musí být mezi ${t.min} a ${t.max}.`;
        case "alpha":
          return "Jsou povoleny pouze písmena.";
        case "alphaNum":
          return "Jsou povoleny pouze písmena a čísla.";
        case "numeric":
          return "Jsou povoleny pouze čísla.";
        case "integer":
          return "Jsou povolena pouze celá čísla.";
        case "decimal":
          return "Jsou povolena pouze desetinná čísla.";
        case "email":
          return "Chybný formát emailové adresy.";
        case "ipAddress":
          return "Chybný formát IP adresy.";
        case "macAddress":
          return "Chybný formát MAC adresy.";
        case "sameAs":
          return "Hodnota není shodná.";
        case "url":
          return "Chybný formát URL adresy.";
        case "validated_email":
        case "validatedEmail":
          return "Nefunkční nebo chybná emailová adresa.";
        default:
          return "Chybně vyplněná hodnota.";
      }
    }
  }
}), fl = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
};
function dl(e, t, n, r, a, o) {
  return w(), E("span", null, Te(e.message), 1);
}
const Nt = /* @__PURE__ */ fl(cl, [["render", dl]]), yl = { class: "input-group-append" }, ml = /* @__PURE__ */ Ee({
  __name: "FormInput",
  props: {
    label: null,
    type: { default: "text" },
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    formatter: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const l = c(n.modelValue);
        if (typeof l == "string" || typeof l == "number")
          return l;
      },
      set(l) {
        t("update:modelValue", l);
        const d = c(n.validation);
        typeof (d == null ? void 0 : d.$touch) == "function" && d.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i,
      formatValue: s
    } = Mt(n, t);
    return (l, d) => {
      const g = go, y = ht, f = gt;
      return w(), fe(f, {
        description: e.hint,
        "label-for": e.id,
        class: pe({ "form-group-required": c(a) })
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          e.renderAsGroup ? (w(), E("div", {
            key: 0,
            class: pe({ "input-group": !0, "is-invalid": c(o) !== null ? !c(o) : null, "is-valid": c(o) !== null ? !!c(o) : null })
          }, [
            Re(g, {
              modelValue: c(r),
              "onUpdate:modelValue": d[0] || (d[0] = (h) => We(r) ? r.value = h : null),
              modelModifiers: { trim: !0 },
              id: e.id,
              size: e.size,
              type: e.type,
              state: c(o) !== null ? !c(o) : null,
              disabled: e.disabled,
              formatter: c(s),
              placeholder: e.placeholder,
              readonly: e.readOnly,
              "lazy-formatter": "",
              onChange: d[1] || (d[1] = (h) => c(i)("change")),
              onUpdate: d[2] || (d[2] = (h) => c(i)("update")),
              onBlur: d[3] || (d[3] = (h) => c(i)("blur"))
            }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"]),
            se("div", yl, [
              W(l.$slots, "default")
            ])
          ], 2)) : (w(), fe(g, {
            key: 1,
            modelValue: c(r),
            "onUpdate:modelValue": d[4] || (d[4] = (h) => We(r) ? r.value = h : null),
            modelModifiers: { trim: !0 },
            id: e.id,
            size: e.size,
            type: e.type,
            state: c(o) !== null ? !c(o) : null,
            disabled: e.disabled,
            formatter: c(s),
            placeholder: e.placeholder,
            readonly: e.readOnly,
            "lazy-formatter": "",
            onChange: d[5] || (d[5] = (h) => c(i)("change")),
            onUpdate: d[6] || (d[6] = (h) => c(i)("update")),
            onBlur: d[7] || (d[7] = (h) => c(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "type", "state", "disabled", "formatter", "placeholder", "readonly"])),
          c(o) && e.validation ? (w(), fe(y, { key: 2 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(l.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["description", "label-for", "class"]);
    };
  }
});
const pl = /* @__PURE__ */ Ee({
  __name: "FormInputCheckbox",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: { type: Boolean },
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    renderAsSwitch: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = c(n.modelValue);
        if (typeof s == "boolean")
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const l = c(n.validation);
        typeof (l == null ? void 0 : l.$touch) == "function" && l.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Mt(n, t);
    return (s, l) => {
      const d = du, g = ht, y = gt;
      return w(), fe(y, {
        description: e.hint,
        class: pe({ "form-group-required": c(a) })
      }, {
        default: Q(() => [
          Re(d, {
            modelValue: c(r),
            "onUpdate:modelValue": l[0] || (l[0] = (f) => We(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: c(o) !== null ? !c(o) : null,
            switch: e.renderAsSwitch === !0 ? !0 : void 0,
            disabled: e.disabled || e.readOnly,
            onChange: l[1] || (l[1] = (f) => c(i)("change")),
            onUpdate: l[2] || (l[2] = (f) => c(i)("update")),
            onBlur: l[3] || (l[3] = (f) => c(i)("blur"))
          }, {
            default: Q(() => [
              W(s.$slots, "default", {}, () => [
                Ve(Te(e.label), 1)
              ])
            ]),
            _: 3
          }, 8, ["modelValue", "id", "size", "state", "switch", "disabled"]),
          c(o) && e.validation ? (w(), fe(g, { key: 0 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 3
      }, 8, ["description", "class"]);
    };
  }
}), vl = /* @__PURE__ */ Ee({
  __name: "FormInputCheckboxGroup",
  props: {
    label: null,
    type: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    stacked: { type: Boolean, default: !0 }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = c(n.modelValue);
        if (Array.isArray(s))
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const l = c(n.validation);
        typeof (l == null ? void 0 : l.$touch) == "function" && l.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Mt(n, t);
    return (s, l) => {
      const d = yu, g = ht, y = gt;
      return w(), fe(y, {
        description: e.hint,
        class: pe({ "form-group-required": c(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          Re(d, {
            modelValue: c(r),
            "onUpdate:modelValue": l[0] || (l[0] = (f) => We(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: c(o) !== null ? !c(o) : null,
            disabled: e.disabled || e.readOnly,
            options: e.options,
            stacked: e.stacked,
            onChange: l[1] || (l[1] = (f) => c(i)("change")),
            onUpdate: l[2] || (l[2] = (f) => c(i)("update")),
            onBlur: l[3] || (l[3] = (f) => c(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
          c(o) && e.validation ? (w(), fe(g, { key: 0 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 1
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), hl = /* @__PURE__ */ Ee({
  __name: "FormInputRadioGroup",
  props: {
    label: null,
    type: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    stacked: { type: Boolean, default: !0 }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = c(n.modelValue);
        if (Array.isArray(s))
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const l = c(n.validation);
        typeof (l == null ? void 0 : l.$touch) == "function" && l.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Mt(n, t);
    return (s, l) => {
      const d = mu, g = ht, y = gt;
      return w(), fe(y, {
        description: e.hint,
        class: pe({ "form-group-required": c(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          Re(d, {
            modelValue: c(r),
            "onUpdate:modelValue": l[0] || (l[0] = (f) => We(r) ? r.value = f : null),
            id: e.id,
            size: e.size,
            state: c(o) !== null ? !c(o) : null,
            disabled: e.disabled || e.readOnly,
            options: e.options,
            stacked: e.stacked,
            onChange: l[1] || (l[1] = (f) => c(i)("change")),
            onUpdate: l[2] || (l[2] = (f) => c(i)("update")),
            onBlur: l[3] || (l[3] = (f) => c(i)("blur"))
          }, null, 8, ["modelValue", "id", "size", "state", "disabled", "options", "stacked"]),
          c(o) && e.validation ? (w(), fe(g, { key: 0 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 1
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), gl = { class: "input-group-append" }, bl = /* @__PURE__ */ Ee({
  __name: "FormInputSelect",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    options: { default: () => [] },
    multi: { type: Boolean },
    selectSize: null
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const s = c(n.modelValue);
        if (typeof s == "string" || typeof s == "number")
          return s;
      },
      set(s) {
        t("update:modelValue", s);
        const l = c(n.validation);
        typeof (l == null ? void 0 : l.$touch) == "function" && l.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i
    } = Mt(n, t);
    return (s, l) => {
      const d = pu, g = ht, y = gt;
      return w(), fe(y, {
        description: e.hint,
        class: pe({ "form-group-required": c(a) }),
        "label-for": e.id
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          e.renderAsGroup ? (w(), E("div", {
            key: 0,
            class: pe({ "input-group": !0, "is-invalid": c(o) !== null ? !c(o) : null, "is-valid": c(o) !== null ? !!c(o) : null })
          }, [
            Re(d, {
              modelValue: c(r),
              "onUpdate:modelValue": l[0] || (l[0] = (f) => We(r) ? r.value = f : null),
              size: e.size,
              id: e.id,
              state: c(o) !== null ? !c(o) : null,
              disabled: e.disabled || e.readOnly,
              placeholder: e.placeholder,
              options: e.options,
              onChange: l[1] || (l[1] = (f) => c(i)("change")),
              onUpdate: l[2] || (l[2] = (f) => c(i)("update")),
              onBlur: l[3] || (l[3] = (f) => c(i)("blur")),
              multiple: e.multi,
              "select-size": e.multi === !0 ? e.selectSize : void 0
            }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"]),
            se("div", gl, [
              W(s.$slots, "default")
            ])
          ], 2)) : (w(), fe(d, {
            key: 1,
            modelValue: c(r),
            "onUpdate:modelValue": l[4] || (l[4] = (f) => We(r) ? r.value = f : null),
            size: e.size,
            id: e.id,
            state: c(o) !== null ? !c(o) : null,
            disabled: e.disabled || e.readOnly,
            placeholder: e.placeholder,
            options: e.options,
            onChange: l[5] || (l[5] = (f) => c(i)("change")),
            onUpdate: l[6] || (l[6] = (f) => c(i)("update")),
            onBlur: l[7] || (l[7] = (f) => c(i)("blur")),
            multiple: e.multi,
            "select-size": e.multi === !0 ? e.selectSize : void 0
          }, null, 8, ["modelValue", "size", "id", "state", "disabled", "placeholder", "options", "multiple", "select-size"])),
          c(o) && e.validation ? (w(), fe(g, { key: 2 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0)
        ]),
        _: 3
      }, 8, ["description", "class", "label-for"]);
    };
  }
}), wl = /* @__PURE__ */ Ee({
  __name: "FormInputTextarea",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    formatter: null,
    renderAsGroup: { type: Boolean, default: !1 },
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean }
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const l = c(n.modelValue);
        if (typeof l == "string" || typeof l == "number")
          return l;
      },
      set(l) {
        t("update:modelValue", l);
        const d = c(n.validation);
        typeof (d == null ? void 0 : d.$touch) == "function" && d.$touch();
      }
    }), {
      isRequired: a,
      invalid: o,
      onEvent: i,
      formatValue: s
    } = Mt(n, t);
    return (l, d) => {
      const g = vu, y = ht, f = gt;
      return w(), fe(f, {
        label: e.label,
        description: e.hint,
        "label-for": e.id,
        class: pe({ "form-group-required": c(a) })
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          Re(g, {
            modelValue: c(r),
            "onUpdate:modelValue": d[0] || (d[0] = (h) => We(r) ? r.value = h : null),
            modelModifiers: { trim: !0 },
            size: e.size,
            id: e.id,
            state: c(o) !== null ? !c(o) : null,
            disabled: e.disabled,
            formatter: c(s),
            placeholder: e.placeholder,
            "lazy-formatter": "",
            onChange: d[1] || (d[1] = (h) => c(i)("change")),
            onUpdate: d[2] || (d[2] = (h) => c(i)("update")),
            onBlur: d[3] || (d[3] = (h) => c(i)("blur")),
            readonly: e.readOnly
          }, null, 8, ["modelValue", "size", "id", "state", "disabled", "formatter", "placeholder", "readonly"]),
          c(o) && e.validation ? (w(), fe(y, { key: 0 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(l.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["label", "description", "label-for", "class"]);
    };
  }
}), _l = (e) => `${e < 10 ? "0" : ""}${e}`, hu = (e) => e instanceof Date ? `${e.getDate()}.${e.getMonth() + 1}. ${e.getFullYear()}` : e, Ol = (e) => e instanceof Date ? `${hu(e)} - ${e.getHours()}:${_l(e.getMinutes())}` : e;
function re(e) {
  if (e === null || e === !0 || e === !1)
    return NaN;
  var t = Number(e);
  return isNaN(t) ? t : t < 0 ? Math.ceil(t) : Math.floor(t);
}
function Z(e, t) {
  if (t.length < e)
    throw new TypeError(e + " argument" + (e > 1 ? "s" : "") + " required, but only " + t.length + " present");
}
function un(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? un = function(n) {
    return typeof n;
  } : un = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, un(e);
}
function le(e) {
  Z(1, arguments);
  var t = Object.prototype.toString.call(e);
  return e instanceof Date || un(e) === "object" && t === "[object Date]" ? new Date(e.getTime()) : typeof e == "number" || t === "[object Number]" ? new Date(e) : ((typeof e == "string" || t === "[object String]") && typeof console < "u" && (console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#string-arguments"), console.warn(new Error().stack)), new Date(NaN));
}
function vt(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return isNaN(r) ? new Date(NaN) : (r && n.setDate(n.getDate() + r), n);
}
function lt(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  if (isNaN(r))
    return new Date(NaN);
  if (!r)
    return n;
  var a = n.getDate(), o = new Date(n.getTime());
  o.setMonth(n.getMonth() + r + 1, 0);
  var i = o.getDate();
  return a >= i ? o : (n.setFullYear(o.getFullYear(), o.getMonth(), a), n);
}
function ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? ln = function(n) {
    return typeof n;
  } : ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, ln(e);
}
function gu(e, t) {
  if (Z(2, arguments), !t || ln(t) !== "object")
    return new Date(NaN);
  var n = t.years ? re(t.years) : 0, r = t.months ? re(t.months) : 0, a = t.weeks ? re(t.weeks) : 0, o = t.days ? re(t.days) : 0, i = t.hours ? re(t.hours) : 0, s = t.minutes ? re(t.minutes) : 0, l = t.seconds ? re(t.seconds) : 0, d = le(e), g = r || n ? lt(d, r + n * 12) : d, y = o || a ? vt(g, o + a * 7) : g, f = s + i * 60, h = l + f * 60, I = h * 1e3, Y = new Date(y.getTime() + I);
  return Y;
}
function $l(e, t) {
  Z(2, arguments);
  var n = le(e).getTime(), r = re(t);
  return new Date(n + r);
}
var Pl = {};
function ct() {
  return Pl;
}
function xt(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = ct(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.weekStartsOn) !== null && a !== void 0 ? a : g.weekStartsOn) !== null && r !== void 0 ? r : (l = g.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = le(e), h = f.getDay(), I = (h < y ? 7 : 0) + h - y;
  return f.setDate(f.getDate() - I), f.setHours(0, 0, 0, 0), f;
}
function Qn(e) {
  return Z(1, arguments), xt(e, {
    weekStartsOn: 1
  });
}
function kl(e) {
  Z(1, arguments);
  var t = le(e), n = t.getFullYear(), r = new Date(0);
  r.setFullYear(n + 1, 0, 4), r.setHours(0, 0, 0, 0);
  var a = Qn(r), o = new Date(0);
  o.setFullYear(n, 0, 4), o.setHours(0, 0, 0, 0);
  var i = Qn(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function Tl(e) {
  Z(1, arguments);
  var t = kl(e), n = new Date(0);
  n.setFullYear(t, 0, 4), n.setHours(0, 0, 0, 0);
  var r = Qn(n);
  return r;
}
function Kn(e) {
  var t = new Date(Date.UTC(e.getFullYear(), e.getMonth(), e.getDate(), e.getHours(), e.getMinutes(), e.getSeconds(), e.getMilliseconds()));
  return t.setUTCFullYear(e.getFullYear()), e.getTime() - t.getTime();
}
function Ao(e) {
  Z(1, arguments);
  var t = le(e);
  return t.setHours(0, 0, 0, 0), t;
}
var Sl = 864e5;
function Dl(e, t) {
  Z(2, arguments);
  var n = Ao(e), r = Ao(t), a = n.getTime() - Kn(n), o = r.getTime() - Kn(r);
  return Math.round((a - o) / Sl);
}
function bu(e, t) {
  Z(2, arguments);
  var n = re(t);
  return lt(e, n * 12);
}
var _o = 6e4, Oo = 36e5, xl = 1e3;
function sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? sn = function(n) {
    return typeof n;
  } : sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, sn(e);
}
function wu(e) {
  return Z(1, arguments), e instanceof Date || sn(e) === "object" && Object.prototype.toString.call(e) === "[object Date]";
}
function Gt(e) {
  if (Z(1, arguments), !wu(e) && typeof e != "number")
    return !1;
  var t = le(e);
  return !isNaN(Number(t));
}
function Bo(e, t) {
  var n;
  Z(1, arguments);
  var r = e || {}, a = le(r.start), o = le(r.end), i = o.getTime();
  if (!(a.getTime() <= i))
    throw new RangeError("Invalid interval");
  var s = [], l = a;
  l.setHours(0, 0, 0, 0);
  var d = Number((n = t == null ? void 0 : t.step) !== null && n !== void 0 ? n : 1);
  if (d < 1 || isNaN(d))
    throw new RangeError("`options.step` must be a number greater than 1");
  for (; l.getTime() <= i; )
    s.push(le(l)), l.setDate(l.getDate() + d), l.setHours(0, 0, 0, 0);
  return s;
}
function Rl(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = ct(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.weekStartsOn) !== null && a !== void 0 ? a : g.weekStartsOn) !== null && r !== void 0 ? r : (l = g.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = le(e), h = f.getDay(), I = (h < y ? -7 : 0) + 6 - (h - y);
  return f.setDate(f.getDate() + I), f.setHours(23, 59, 59, 999), f;
}
function _u(e, t) {
  Z(2, arguments);
  var n = re(t);
  return $l(e, -n);
}
var Ml = 864e5;
function Nl(e) {
  Z(1, arguments);
  var t = le(e), n = t.getTime();
  t.setUTCMonth(0, 1), t.setUTCHours(0, 0, 0, 0);
  var r = t.getTime(), a = n - r;
  return Math.floor(a / Ml) + 1;
}
function Ft(e) {
  Z(1, arguments);
  var t = 1, n = le(e), r = n.getUTCDay(), a = (r < t ? 7 : 0) + r - t;
  return n.setUTCDate(n.getUTCDate() - a), n.setUTCHours(0, 0, 0, 0), n;
}
function Ou(e) {
  Z(1, arguments);
  var t = le(e), n = t.getUTCFullYear(), r = new Date(0);
  r.setUTCFullYear(n + 1, 0, 4), r.setUTCHours(0, 0, 0, 0);
  var a = Ft(r), o = new Date(0);
  o.setUTCFullYear(n, 0, 4), o.setUTCHours(0, 0, 0, 0);
  var i = Ft(o);
  return t.getTime() >= a.getTime() ? n + 1 : t.getTime() >= i.getTime() ? n : n - 1;
}
function Cl(e) {
  Z(1, arguments);
  var t = Ou(e), n = new Date(0);
  n.setUTCFullYear(t, 0, 4), n.setUTCHours(0, 0, 0, 0);
  var r = Ft(n);
  return r;
}
var Il = 6048e5;
function $u(e) {
  Z(1, arguments);
  var t = le(e), n = Ft(t).getTime() - Cl(t).getTime();
  return Math.round(n / Il) + 1;
}
function Rt(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = ct(), y = re((n = (r = (a = (o = t == null ? void 0 : t.weekStartsOn) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.weekStartsOn) !== null && a !== void 0 ? a : g.weekStartsOn) !== null && r !== void 0 ? r : (l = g.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.weekStartsOn) !== null && n !== void 0 ? n : 0);
  if (!(y >= 0 && y <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var f = le(e), h = f.getUTCDay(), I = (h < y ? 7 : 0) + h - y;
  return f.setUTCDate(f.getUTCDate() - I), f.setUTCHours(0, 0, 0, 0), f;
}
function $o(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = le(e), y = g.getUTCFullYear(), f = ct(), h = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.firstWeekContainsDate) !== null && a !== void 0 ? a : f.firstWeekContainsDate) !== null && r !== void 0 ? r : (l = f.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1);
  if (!(h >= 1 && h <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var I = new Date(0);
  I.setUTCFullYear(y + 1, 0, h), I.setUTCHours(0, 0, 0, 0);
  var Y = Rt(I, t), H = new Date(0);
  H.setUTCFullYear(y, 0, h), H.setUTCHours(0, 0, 0, 0);
  var X = Rt(H, t);
  return g.getTime() >= Y.getTime() ? y + 1 : g.getTime() >= X.getTime() ? y : y - 1;
}
function Al(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = ct(), y = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.firstWeekContainsDate) !== null && a !== void 0 ? a : g.firstWeekContainsDate) !== null && r !== void 0 ? r : (l = g.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1), f = $o(e, t), h = new Date(0);
  h.setUTCFullYear(f, 0, y), h.setUTCHours(0, 0, 0, 0);
  var I = Rt(h, t);
  return I;
}
var Bl = 6048e5;
function Pu(e, t) {
  Z(1, arguments);
  var n = le(e), r = Rt(n, t).getTime() - Al(n, t).getTime();
  return Math.round(r / Bl) + 1;
}
function be(e, t) {
  for (var n = e < 0 ? "-" : "", r = Math.abs(e).toString(); r.length < t; )
    r = "0" + r;
  return n + r;
}
var El = {
  // Year
  y: function(t, n) {
    var r = t.getUTCFullYear(), a = r > 0 ? r : 1 - r;
    return be(n === "yy" ? a % 100 : a, n.length);
  },
  // Month
  M: function(t, n) {
    var r = t.getUTCMonth();
    return n === "M" ? String(r + 1) : be(r + 1, 2);
  },
  // Day of the month
  d: function(t, n) {
    return be(t.getUTCDate(), n.length);
  },
  // AM or PM
  a: function(t, n) {
    var r = t.getUTCHours() / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.toUpperCase();
      case "aaa":
        return r;
      case "aaaaa":
        return r[0];
      case "aaaa":
      default:
        return r === "am" ? "a.m." : "p.m.";
    }
  },
  // Hour [1-12]
  h: function(t, n) {
    return be(t.getUTCHours() % 12 || 12, n.length);
  },
  // Hour [0-23]
  H: function(t, n) {
    return be(t.getUTCHours(), n.length);
  },
  // Minute
  m: function(t, n) {
    return be(t.getUTCMinutes(), n.length);
  },
  // Second
  s: function(t, n) {
    return be(t.getUTCSeconds(), n.length);
  },
  // Fraction of second
  S: function(t, n) {
    var r = n.length, a = t.getUTCMilliseconds(), o = Math.floor(a * Math.pow(10, r - 3));
    return be(o, n.length);
  }
};
const pt = El;
var At = {
  am: "am",
  pm: "pm",
  midnight: "midnight",
  noon: "noon",
  morning: "morning",
  afternoon: "afternoon",
  evening: "evening",
  night: "night"
}, Yl = {
  // Era
  G: function(t, n, r) {
    var a = t.getUTCFullYear() > 0 ? 1 : 0;
    switch (n) {
      case "G":
      case "GG":
      case "GGG":
        return r.era(a, {
          width: "abbreviated"
        });
      case "GGGGG":
        return r.era(a, {
          width: "narrow"
        });
      case "GGGG":
      default:
        return r.era(a, {
          width: "wide"
        });
    }
  },
  // Year
  y: function(t, n, r) {
    if (n === "yo") {
      var a = t.getUTCFullYear(), o = a > 0 ? a : 1 - a;
      return r.ordinalNumber(o, {
        unit: "year"
      });
    }
    return pt.y(t, n);
  },
  // Local week-numbering year
  Y: function(t, n, r, a) {
    var o = $o(t, a), i = o > 0 ? o : 1 - o;
    if (n === "YY") {
      var s = i % 100;
      return be(s, 2);
    }
    return n === "Yo" ? r.ordinalNumber(i, {
      unit: "year"
    }) : be(i, n.length);
  },
  // ISO week-numbering year
  R: function(t, n) {
    var r = Ou(t);
    return be(r, n.length);
  },
  // Extended year. This is a single number designating the year of this calendar system.
  // The main difference between `y` and `u` localizers are B.C. years:
  // | Year | `y` | `u` |
  // |------|-----|-----|
  // | AC 1 |   1 |   1 |
  // | BC 1 |   1 |   0 |
  // | BC 2 |   2 |  -1 |
  // Also `yy` always returns the last two digits of a year,
  // while `uu` pads single digit years to 2 characters and returns other years unchanged.
  u: function(t, n) {
    var r = t.getUTCFullYear();
    return be(r, n.length);
  },
  // Quarter
  Q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "Q":
        return String(a);
      case "QQ":
        return be(a, 2);
      case "Qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "QQQ":
        return r.quarter(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "QQQQQ":
        return r.quarter(a, {
          width: "narrow",
          context: "formatting"
        });
      case "QQQQ":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone quarter
  q: function(t, n, r) {
    var a = Math.ceil((t.getUTCMonth() + 1) / 3);
    switch (n) {
      case "q":
        return String(a);
      case "qq":
        return be(a, 2);
      case "qo":
        return r.ordinalNumber(a, {
          unit: "quarter"
        });
      case "qqq":
        return r.quarter(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "qqqqq":
        return r.quarter(a, {
          width: "narrow",
          context: "standalone"
        });
      case "qqqq":
      default:
        return r.quarter(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Month
  M: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "M":
      case "MM":
        return pt.M(t, n);
      case "Mo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "MMM":
        return r.month(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "MMMMM":
        return r.month(a, {
          width: "narrow",
          context: "formatting"
        });
      case "MMMM":
      default:
        return r.month(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone month
  L: function(t, n, r) {
    var a = t.getUTCMonth();
    switch (n) {
      case "L":
        return String(a + 1);
      case "LL":
        return be(a + 1, 2);
      case "Lo":
        return r.ordinalNumber(a + 1, {
          unit: "month"
        });
      case "LLL":
        return r.month(a, {
          width: "abbreviated",
          context: "standalone"
        });
      case "LLLLL":
        return r.month(a, {
          width: "narrow",
          context: "standalone"
        });
      case "LLLL":
      default:
        return r.month(a, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // Local week of year
  w: function(t, n, r, a) {
    var o = Pu(t, a);
    return n === "wo" ? r.ordinalNumber(o, {
      unit: "week"
    }) : be(o, n.length);
  },
  // ISO week of year
  I: function(t, n, r) {
    var a = $u(t);
    return n === "Io" ? r.ordinalNumber(a, {
      unit: "week"
    }) : be(a, n.length);
  },
  // Day of the month
  d: function(t, n, r) {
    return n === "do" ? r.ordinalNumber(t.getUTCDate(), {
      unit: "date"
    }) : pt.d(t, n);
  },
  // Day of year
  D: function(t, n, r) {
    var a = Nl(t);
    return n === "Do" ? r.ordinalNumber(a, {
      unit: "dayOfYear"
    }) : be(a, n.length);
  },
  // Day of week
  E: function(t, n, r) {
    var a = t.getUTCDay();
    switch (n) {
      case "E":
      case "EE":
      case "EEE":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "EEEEE":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "EEEEEE":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "EEEE":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Local day of week
  e: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "e":
        return String(i);
      case "ee":
        return be(i, 2);
      case "eo":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "eee":
        return r.day(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "eeeee":
        return r.day(o, {
          width: "narrow",
          context: "formatting"
        });
      case "eeeeee":
        return r.day(o, {
          width: "short",
          context: "formatting"
        });
      case "eeee":
      default:
        return r.day(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Stand-alone local day of week
  c: function(t, n, r, a) {
    var o = t.getUTCDay(), i = (o - a.weekStartsOn + 8) % 7 || 7;
    switch (n) {
      case "c":
        return String(i);
      case "cc":
        return be(i, n.length);
      case "co":
        return r.ordinalNumber(i, {
          unit: "day"
        });
      case "ccc":
        return r.day(o, {
          width: "abbreviated",
          context: "standalone"
        });
      case "ccccc":
        return r.day(o, {
          width: "narrow",
          context: "standalone"
        });
      case "cccccc":
        return r.day(o, {
          width: "short",
          context: "standalone"
        });
      case "cccc":
      default:
        return r.day(o, {
          width: "wide",
          context: "standalone"
        });
    }
  },
  // ISO day of week
  i: function(t, n, r) {
    var a = t.getUTCDay(), o = a === 0 ? 7 : a;
    switch (n) {
      case "i":
        return String(o);
      case "ii":
        return be(o, n.length);
      case "io":
        return r.ordinalNumber(o, {
          unit: "day"
        });
      case "iii":
        return r.day(a, {
          width: "abbreviated",
          context: "formatting"
        });
      case "iiiii":
        return r.day(a, {
          width: "narrow",
          context: "formatting"
        });
      case "iiiiii":
        return r.day(a, {
          width: "short",
          context: "formatting"
        });
      case "iiii":
      default:
        return r.day(a, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM or PM
  a: function(t, n, r) {
    var a = t.getUTCHours(), o = a / 12 >= 1 ? "pm" : "am";
    switch (n) {
      case "a":
      case "aa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "aaa":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "aaaaa":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "aaaa":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // AM, PM, midnight, noon
  b: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a === 12 ? o = At.noon : a === 0 ? o = At.midnight : o = a / 12 >= 1 ? "pm" : "am", n) {
      case "b":
      case "bb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "bbb":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        }).toLowerCase();
      case "bbbbb":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "bbbb":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // in the morning, in the afternoon, in the evening, at night
  B: function(t, n, r) {
    var a = t.getUTCHours(), o;
    switch (a >= 17 ? o = At.evening : a >= 12 ? o = At.afternoon : a >= 4 ? o = At.morning : o = At.night, n) {
      case "B":
      case "BB":
      case "BBB":
        return r.dayPeriod(o, {
          width: "abbreviated",
          context: "formatting"
        });
      case "BBBBB":
        return r.dayPeriod(o, {
          width: "narrow",
          context: "formatting"
        });
      case "BBBB":
      default:
        return r.dayPeriod(o, {
          width: "wide",
          context: "formatting"
        });
    }
  },
  // Hour [1-12]
  h: function(t, n, r) {
    if (n === "ho") {
      var a = t.getUTCHours() % 12;
      return a === 0 && (a = 12), r.ordinalNumber(a, {
        unit: "hour"
      });
    }
    return pt.h(t, n);
  },
  // Hour [0-23]
  H: function(t, n, r) {
    return n === "Ho" ? r.ordinalNumber(t.getUTCHours(), {
      unit: "hour"
    }) : pt.H(t, n);
  },
  // Hour [0-11]
  K: function(t, n, r) {
    var a = t.getUTCHours() % 12;
    return n === "Ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : be(a, n.length);
  },
  // Hour [1-24]
  k: function(t, n, r) {
    var a = t.getUTCHours();
    return a === 0 && (a = 24), n === "ko" ? r.ordinalNumber(a, {
      unit: "hour"
    }) : be(a, n.length);
  },
  // Minute
  m: function(t, n, r) {
    return n === "mo" ? r.ordinalNumber(t.getUTCMinutes(), {
      unit: "minute"
    }) : pt.m(t, n);
  },
  // Second
  s: function(t, n, r) {
    return n === "so" ? r.ordinalNumber(t.getUTCSeconds(), {
      unit: "second"
    }) : pt.s(t, n);
  },
  // Fraction of second
  S: function(t, n) {
    return pt.S(t, n);
  },
  // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
  X: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    if (i === 0)
      return "Z";
    switch (n) {
      case "X":
        return Yo(i);
      case "XXXX":
      case "XX":
        return Pt(i);
      case "XXXXX":
      case "XXX":
      default:
        return Pt(i, ":");
    }
  },
  // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
  x: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "x":
        return Yo(i);
      case "xxxx":
      case "xx":
        return Pt(i);
      case "xxxxx":
      case "xxx":
      default:
        return Pt(i, ":");
    }
  },
  // Timezone (GMT)
  O: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "O":
      case "OO":
      case "OOO":
        return "GMT" + Eo(i, ":");
      case "OOOO":
      default:
        return "GMT" + Pt(i, ":");
    }
  },
  // Timezone (specific non-location)
  z: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTimezoneOffset();
    switch (n) {
      case "z":
      case "zz":
      case "zzz":
        return "GMT" + Eo(i, ":");
      case "zzzz":
      default:
        return "GMT" + Pt(i, ":");
    }
  },
  // Seconds timestamp
  t: function(t, n, r, a) {
    var o = a._originalDate || t, i = Math.floor(o.getTime() / 1e3);
    return be(i, n.length);
  },
  // Milliseconds timestamp
  T: function(t, n, r, a) {
    var o = a._originalDate || t, i = o.getTime();
    return be(i, n.length);
  }
};
function Eo(e, t) {
  var n = e > 0 ? "-" : "+", r = Math.abs(e), a = Math.floor(r / 60), o = r % 60;
  if (o === 0)
    return n + String(a);
  var i = t || "";
  return n + String(a) + i + be(o, 2);
}
function Yo(e, t) {
  if (e % 60 === 0) {
    var n = e > 0 ? "-" : "+";
    return n + be(Math.abs(e) / 60, 2);
  }
  return Pt(e, t);
}
function Pt(e, t) {
  var n = t || "", r = e > 0 ? "-" : "+", a = Math.abs(e), o = be(Math.floor(a / 60), 2), i = be(a % 60, 2);
  return r + o + n + i;
}
const Fl = Yl;
var Fo = function(t, n) {
  switch (t) {
    case "P":
      return n.date({
        width: "short"
      });
    case "PP":
      return n.date({
        width: "medium"
      });
    case "PPP":
      return n.date({
        width: "long"
      });
    case "PPPP":
    default:
      return n.date({
        width: "full"
      });
  }
}, ku = function(t, n) {
  switch (t) {
    case "p":
      return n.time({
        width: "short"
      });
    case "pp":
      return n.time({
        width: "medium"
      });
    case "ppp":
      return n.time({
        width: "long"
      });
    case "pppp":
    default:
      return n.time({
        width: "full"
      });
  }
}, Vl = function(t, n) {
  var r = t.match(/(P+)(p+)?/) || [], a = r[1], o = r[2];
  if (!o)
    return Fo(t, n);
  var i;
  switch (a) {
    case "P":
      i = n.dateTime({
        width: "short"
      });
      break;
    case "PP":
      i = n.dateTime({
        width: "medium"
      });
      break;
    case "PPP":
      i = n.dateTime({
        width: "long"
      });
      break;
    case "PPPP":
    default:
      i = n.dateTime({
        width: "full"
      });
      break;
  }
  return i.replace("{{date}}", Fo(a, n)).replace("{{time}}", ku(o, n));
}, Ul = {
  p: ku,
  P: Vl
};
const aa = Ul;
var Wl = ["D", "DD"], Ll = ["YY", "YYYY"];
function Tu(e) {
  return Wl.indexOf(e) !== -1;
}
function Su(e) {
  return Ll.indexOf(e) !== -1;
}
function Zn(e, t, n) {
  if (e === "YYYY")
    throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "YY")
    throw new RangeError("Use `yy` instead of `YY` (in `".concat(t, "`) for formatting years to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "D")
    throw new RangeError("Use `d` instead of `D` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  if (e === "DD")
    throw new RangeError("Use `dd` instead of `DD` (in `".concat(t, "`) for formatting days of the month to the input `").concat(n, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
}
var Hl = {
  lessThanXSeconds: {
    one: "less than a second",
    other: "less than {{count}} seconds"
  },
  xSeconds: {
    one: "1 second",
    other: "{{count}} seconds"
  },
  halfAMinute: "half a minute",
  lessThanXMinutes: {
    one: "less than a minute",
    other: "less than {{count}} minutes"
  },
  xMinutes: {
    one: "1 minute",
    other: "{{count}} minutes"
  },
  aboutXHours: {
    one: "about 1 hour",
    other: "about {{count}} hours"
  },
  xHours: {
    one: "1 hour",
    other: "{{count}} hours"
  },
  xDays: {
    one: "1 day",
    other: "{{count}} days"
  },
  aboutXWeeks: {
    one: "about 1 week",
    other: "about {{count}} weeks"
  },
  xWeeks: {
    one: "1 week",
    other: "{{count}} weeks"
  },
  aboutXMonths: {
    one: "about 1 month",
    other: "about {{count}} months"
  },
  xMonths: {
    one: "1 month",
    other: "{{count}} months"
  },
  aboutXYears: {
    one: "about 1 year",
    other: "about {{count}} years"
  },
  xYears: {
    one: "1 year",
    other: "{{count}} years"
  },
  overXYears: {
    one: "over 1 year",
    other: "over {{count}} years"
  },
  almostXYears: {
    one: "almost 1 year",
    other: "almost {{count}} years"
  }
}, jl = function(t, n, r) {
  var a, o = Hl[t];
  return typeof o == "string" ? a = o : n === 1 ? a = o.one : a = o.other.replace("{{count}}", n.toString()), r != null && r.addSuffix ? r.comparison && r.comparison > 0 ? "in " + a : a + " ago" : a;
};
const ql = jl;
function Hr(e) {
  return function() {
    var t = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, n = t.width ? String(t.width) : e.defaultWidth, r = e.formats[n] || e.formats[e.defaultWidth];
    return r;
  };
}
var zl = {
  full: "EEEE, MMMM do, y",
  long: "MMMM do, y",
  medium: "MMM d, y",
  short: "MM/dd/yyyy"
}, Gl = {
  full: "h:mm:ss a zzzz",
  long: "h:mm:ss a z",
  medium: "h:mm:ss a",
  short: "h:mm a"
}, Ql = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: "{{date}}, {{time}}",
  short: "{{date}}, {{time}}"
}, Kl = {
  date: Hr({
    formats: zl,
    defaultWidth: "full"
  }),
  time: Hr({
    formats: Gl,
    defaultWidth: "full"
  }),
  dateTime: Hr({
    formats: Ql,
    defaultWidth: "full"
  })
};
const Zl = Kl;
var Xl = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: "P"
}, Jl = function(t, n, r, a) {
  return Xl[t];
};
const es = Jl;
function Ht(e) {
  return function(t, n) {
    var r = n != null && n.context ? String(n.context) : "standalone", a;
    if (r === "formatting" && e.formattingValues) {
      var o = e.defaultFormattingWidth || e.defaultWidth, i = n != null && n.width ? String(n.width) : o;
      a = e.formattingValues[i] || e.formattingValues[o];
    } else {
      var s = e.defaultWidth, l = n != null && n.width ? String(n.width) : e.defaultWidth;
      a = e.values[l] || e.values[s];
    }
    var d = e.argumentCallback ? e.argumentCallback(t) : t;
    return a[d];
  };
}
var ts = {
  narrow: ["B", "A"],
  abbreviated: ["BC", "AD"],
  wide: ["Before Christ", "Anno Domini"]
}, ns = {
  narrow: ["1", "2", "3", "4"],
  abbreviated: ["Q1", "Q2", "Q3", "Q4"],
  wide: ["1st quarter", "2nd quarter", "3rd quarter", "4th quarter"]
}, rs = {
  narrow: ["J", "F", "M", "A", "M", "J", "J", "A", "S", "O", "N", "D"],
  abbreviated: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
  wide: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
}, as = {
  narrow: ["S", "M", "T", "W", "T", "F", "S"],
  short: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
  abbreviated: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  wide: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
}, os = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "morning",
    afternoon: "afternoon",
    evening: "evening",
    night: "night"
  }
}, is = {
  narrow: {
    am: "a",
    pm: "p",
    midnight: "mi",
    noon: "n",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  abbreviated: {
    am: "AM",
    pm: "PM",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  },
  wide: {
    am: "a.m.",
    pm: "p.m.",
    midnight: "midnight",
    noon: "noon",
    morning: "in the morning",
    afternoon: "in the afternoon",
    evening: "in the evening",
    night: "at night"
  }
}, us = function(t, n) {
  var r = Number(t), a = r % 100;
  if (a > 20 || a < 10)
    switch (a % 10) {
      case 1:
        return r + "st";
      case 2:
        return r + "nd";
      case 3:
        return r + "rd";
    }
  return r + "th";
}, ls = {
  ordinalNumber: us,
  era: Ht({
    values: ts,
    defaultWidth: "wide"
  }),
  quarter: Ht({
    values: ns,
    defaultWidth: "wide",
    argumentCallback: function(t) {
      return t - 1;
    }
  }),
  month: Ht({
    values: rs,
    defaultWidth: "wide"
  }),
  day: Ht({
    values: as,
    defaultWidth: "wide"
  }),
  dayPeriod: Ht({
    values: os,
    defaultWidth: "wide",
    formattingValues: is,
    defaultFormattingWidth: "wide"
  })
};
const ss = ls;
function jt(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = n.width, a = r && e.matchPatterns[r] || e.matchPatterns[e.defaultMatchWidth], o = t.match(a);
    if (!o)
      return null;
    var i = o[0], s = r && e.parsePatterns[r] || e.parsePatterns[e.defaultParseWidth], l = Array.isArray(s) ? fs(s, function(y) {
      return y.test(i);
    }) : cs(s, function(y) {
      return y.test(i);
    }), d;
    d = e.valueCallback ? e.valueCallback(l) : l, d = n.valueCallback ? n.valueCallback(d) : d;
    var g = t.slice(i.length);
    return {
      value: d,
      rest: g
    };
  };
}
function cs(e, t) {
  for (var n in e)
    if (e.hasOwnProperty(n) && t(e[n]))
      return n;
}
function fs(e, t) {
  for (var n = 0; n < e.length; n++)
    if (t(e[n]))
      return n;
}
function ds(e) {
  return function(t) {
    var n = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, r = t.match(e.matchPattern);
    if (!r)
      return null;
    var a = r[0], o = t.match(e.parsePattern);
    if (!o)
      return null;
    var i = e.valueCallback ? e.valueCallback(o[0]) : o[0];
    i = n.valueCallback ? n.valueCallback(i) : i;
    var s = t.slice(a.length);
    return {
      value: i,
      rest: s
    };
  };
}
var ys = /^(\d+)(th|st|nd|rd)?/i, ms = /\d+/i, ps = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
}, vs = {
  any: [/^b/i, /^(a|c)/i]
}, hs = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
}, gs = {
  any: [/1/i, /2/i, /3/i, /4/i]
}, bs = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
}, ws = {
  narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
  any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
}, _s = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
}, Os = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
}, $s = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
}, Ps = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
}, ks = {
  ordinalNumber: ds({
    matchPattern: ys,
    parsePattern: ms,
    valueCallback: function(t) {
      return parseInt(t, 10);
    }
  }),
  era: jt({
    matchPatterns: ps,
    defaultMatchWidth: "wide",
    parsePatterns: vs,
    defaultParseWidth: "any"
  }),
  quarter: jt({
    matchPatterns: hs,
    defaultMatchWidth: "wide",
    parsePatterns: gs,
    defaultParseWidth: "any",
    valueCallback: function(t) {
      return t + 1;
    }
  }),
  month: jt({
    matchPatterns: bs,
    defaultMatchWidth: "wide",
    parsePatterns: ws,
    defaultParseWidth: "any"
  }),
  day: jt({
    matchPatterns: _s,
    defaultMatchWidth: "wide",
    parsePatterns: Os,
    defaultParseWidth: "any"
  }),
  dayPeriod: jt({
    matchPatterns: $s,
    defaultMatchWidth: "any",
    parsePatterns: Ps,
    defaultParseWidth: "any"
  })
};
const Ts = ks;
var Ss = {
  code: "en-US",
  formatDistance: ql,
  formatLong: Zl,
  formatRelative: es,
  localize: ss,
  match: Ts,
  options: {
    weekStartsOn: 0,
    firstWeekContainsDate: 1
  }
};
const Du = Ss;
var Ds = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, xs = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, Rs = /^'([^]*?)'?$/, Ms = /''/g, Ns = /[a-zA-Z]/;
function Qt(e, t, n) {
  var r, a, o, i, s, l, d, g, y, f, h, I, Y, H, X, z, B, j;
  Z(2, arguments);
  var ae = String(t), J = ct(), D = (r = (a = n == null ? void 0 : n.locale) !== null && a !== void 0 ? a : J.locale) !== null && r !== void 0 ? r : Du, O = re((o = (i = (s = (l = n == null ? void 0 : n.firstWeekContainsDate) !== null && l !== void 0 ? l : n == null || (d = n.locale) === null || d === void 0 || (g = d.options) === null || g === void 0 ? void 0 : g.firstWeekContainsDate) !== null && s !== void 0 ? s : J.firstWeekContainsDate) !== null && i !== void 0 ? i : (y = J.locale) === null || y === void 0 || (f = y.options) === null || f === void 0 ? void 0 : f.firstWeekContainsDate) !== null && o !== void 0 ? o : 1);
  if (!(O >= 1 && O <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var A = re((h = (I = (Y = (H = n == null ? void 0 : n.weekStartsOn) !== null && H !== void 0 ? H : n == null || (X = n.locale) === null || X === void 0 || (z = X.options) === null || z === void 0 ? void 0 : z.weekStartsOn) !== null && Y !== void 0 ? Y : J.weekStartsOn) !== null && I !== void 0 ? I : (B = J.locale) === null || B === void 0 || (j = B.options) === null || j === void 0 ? void 0 : j.weekStartsOn) !== null && h !== void 0 ? h : 0);
  if (!(A >= 0 && A <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if (!D.localize)
    throw new RangeError("locale must contain localize property");
  if (!D.formatLong)
    throw new RangeError("locale must contain formatLong property");
  var V = le(e);
  if (!Gt(V))
    throw new RangeError("Invalid time value");
  var C = Kn(V), U = _u(V, C), K = {
    firstWeekContainsDate: O,
    weekStartsOn: A,
    locale: D,
    _originalDate: V
  }, oe = ae.match(xs).map(function(P) {
    var S = P[0];
    if (S === "p" || S === "P") {
      var u = aa[S];
      return u(P, D.formatLong);
    }
    return P;
  }).join("").match(Ds).map(function(P) {
    if (P === "''")
      return "'";
    var S = P[0];
    if (S === "'")
      return Cs(P);
    var u = Fl[S];
    if (u)
      return !(n != null && n.useAdditionalWeekYearTokens) && Su(P) && Zn(P, t, String(e)), !(n != null && n.useAdditionalDayOfYearTokens) && Tu(P) && Zn(P, t, String(e)), u(U, P, D.localize, K);
    if (S.match(Ns))
      throw new RangeError("Format string contains an unescaped latin alphabet character `" + S + "`");
    return P;
  }).join("");
  return oe;
}
function Cs(e) {
  var t = e.match(Rs);
  return t ? t[1].replace(Ms, "'") : e;
}
function Is(e, t) {
  if (e == null)
    throw new TypeError("assign requires that input parameter not be null or undefined");
  for (var n in t)
    Object.prototype.hasOwnProperty.call(t, n) && (e[n] = t[n]);
  return e;
}
function As(e) {
  Z(1, arguments);
  var t = le(e), n = t.getDay();
  return n;
}
function Bs(e) {
  Z(1, arguments);
  var t = le(e), n = t.getFullYear(), r = t.getMonth(), a = new Date(0);
  return a.setFullYear(n, r + 1, 0), a.setHours(0, 0, 0, 0), a.getDate();
}
function ft(e) {
  Z(1, arguments);
  var t = le(e), n = t.getHours();
  return n;
}
var Es = 6048e5;
function Ys(e) {
  Z(1, arguments);
  var t = le(e), n = Qn(t).getTime() - Tl(t).getTime();
  return Math.round(n / Es) + 1;
}
function dt(e) {
  Z(1, arguments);
  var t = le(e), n = t.getMinutes();
  return n;
}
function Pe(e) {
  Z(1, arguments);
  var t = le(e), n = t.getMonth();
  return n;
}
function Vt(e) {
  Z(1, arguments);
  var t = le(e), n = t.getSeconds();
  return n;
}
function Fs(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = le(e), y = g.getFullYear(), f = ct(), h = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.firstWeekContainsDate) !== null && a !== void 0 ? a : f.firstWeekContainsDate) !== null && r !== void 0 ? r : (l = f.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1);
  if (!(h >= 1 && h <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var I = new Date(0);
  I.setFullYear(y + 1, 0, h), I.setHours(0, 0, 0, 0);
  var Y = xt(I, t), H = new Date(0);
  H.setFullYear(y, 0, h), H.setHours(0, 0, 0, 0);
  var X = xt(H, t);
  return g.getTime() >= Y.getTime() ? y + 1 : g.getTime() >= X.getTime() ? y : y - 1;
}
function Vs(e, t) {
  var n, r, a, o, i, s, l, d;
  Z(1, arguments);
  var g = ct(), y = re((n = (r = (a = (o = t == null ? void 0 : t.firstWeekContainsDate) !== null && o !== void 0 ? o : t == null || (i = t.locale) === null || i === void 0 || (s = i.options) === null || s === void 0 ? void 0 : s.firstWeekContainsDate) !== null && a !== void 0 ? a : g.firstWeekContainsDate) !== null && r !== void 0 ? r : (l = g.locale) === null || l === void 0 || (d = l.options) === null || d === void 0 ? void 0 : d.firstWeekContainsDate) !== null && n !== void 0 ? n : 1), f = Fs(e, t), h = new Date(0);
  h.setFullYear(f, 0, y), h.setHours(0, 0, 0, 0);
  var I = xt(h, t);
  return I;
}
var Us = 6048e5;
function Ws(e, t) {
  Z(1, arguments);
  var n = le(e), r = xt(n, t).getTime() - Vs(n, t).getTime();
  return Math.round(r / Us) + 1;
}
function ke(e) {
  return Z(1, arguments), le(e).getFullYear();
}
function Po(e, t) {
  Z(2, arguments);
  var n = le(e), r = le(t);
  return n.getTime() > r.getTime();
}
function ko(e, t) {
  Z(2, arguments);
  var n = le(e), r = le(t);
  return n.getTime() < r.getTime();
}
function xu(e, t) {
  Z(2, arguments);
  var n = le(e), r = le(t);
  return n.getTime() === r.getTime();
}
function cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? cn = function(n) {
    return typeof n;
  } : cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, cn(e);
}
function Ru(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && oa(e, t);
}
function oa(e, t) {
  return oa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, oa(e, t);
}
function Mu(e) {
  var t = Hs();
  return function() {
    var r = Xn(e), a;
    if (t) {
      var o = Xn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ls(this, a);
  };
}
function Ls(e, t) {
  return t && (cn(t) === "object" || typeof t == "function") ? t : ia(e);
}
function ia(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Hs() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Xn(e) {
  return Xn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Xn(e);
}
function To(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Vo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function So(e, t, n) {
  return t && Vo(e.prototype, t), n && Vo(e, n), e;
}
function ua(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var js = 10, Nu = /* @__PURE__ */ function() {
  function e() {
    To(this, e), ua(this, "subPriority", 0);
  }
  return So(e, [{
    key: "validate",
    value: function(n, r) {
      return !0;
    }
  }]), e;
}(), qs = /* @__PURE__ */ function(e) {
  Ru(n, e);
  var t = Mu(n);
  function n(r, a, o, i, s) {
    var l;
    return To(this, n), l = t.call(this), l.value = r, l.validateValue = a, l.setValue = o, l.priority = i, s && (l.subPriority = s), l;
  }
  return So(n, [{
    key: "validate",
    value: function(a, o) {
      return this.validateValue(a, this.value, o);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return this.setValue(a, o, this.value, i);
    }
  }]), n;
}(Nu), zs = /* @__PURE__ */ function(e) {
  Ru(n, e);
  var t = Mu(n);
  function n() {
    var r;
    To(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ua(ia(r), "priority", js), ua(ia(r), "subPriority", -1), r;
  }
  return So(n, [{
    key: "set",
    value: function(a, o) {
      if (o.timestampIsSet)
        return a;
      var i = new Date(0);
      return i.setFullYear(a.getUTCFullYear(), a.getUTCMonth(), a.getUTCDate()), i.setHours(a.getUTCHours(), a.getUTCMinutes(), a.getUTCSeconds(), a.getUTCMilliseconds()), i;
    }
  }]), n;
}(Nu);
function Gs(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Uo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Qs(e, t, n) {
  return t && Uo(e.prototype, t), n && Uo(e, n), e;
}
var ge = /* @__PURE__ */ function() {
  function e() {
    Gs(this, e);
  }
  return Qs(e, [{
    key: "run",
    value: function(n, r, a, o) {
      var i = this.parse(n, r, a, o);
      return i ? {
        setter: new qs(i.value, this.validate, this.set, this.priority, this.subPriority),
        rest: i.rest
      } : null;
    }
  }, {
    key: "validate",
    value: function(n, r, a) {
      return !0;
    }
  }]), e;
}();
function fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? fn = function(n) {
    return typeof n;
  } : fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, fn(e);
}
function Ks(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Wo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Zs(e, t, n) {
  return t && Wo(e.prototype, t), n && Wo(e, n), e;
}
function Xs(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && la(e, t);
}
function la(e, t) {
  return la = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, la(e, t);
}
function Js(e) {
  var t = tc();
  return function() {
    var r = Jn(e), a;
    if (t) {
      var o = Jn(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ec(this, a);
  };
}
function ec(e, t) {
  return t && (fn(t) === "object" || typeof t == "function") ? t : sa(e);
}
function sa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function tc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Jn(e) {
  return Jn = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Jn(e);
}
function Lo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var nc = /* @__PURE__ */ function(e) {
  Xs(n, e);
  var t = Js(n);
  function n() {
    var r;
    Ks(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Lo(sa(r), "priority", 140), Lo(sa(r), "incompatibleTokens", ["R", "u", "t", "T"]), r;
  }
  return Zs(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "G":
        case "GG":
        case "GGG":
          return i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
        case "GGGGG":
          return i.era(a, {
            width: "narrow"
          });
        case "GGGG":
        default:
          return i.era(a, {
            width: "wide"
          }) || i.era(a, {
            width: "abbreviated"
          }) || i.era(a, {
            width: "narrow"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.era = i, a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge), Ce = {
  month: /^(1[0-2]|0?\d)/,
  // 0 to 12
  date: /^(3[0-1]|[0-2]?\d)/,
  // 0 to 31
  dayOfYear: /^(36[0-6]|3[0-5]\d|[0-2]?\d?\d)/,
  // 0 to 366
  week: /^(5[0-3]|[0-4]?\d)/,
  // 0 to 53
  hour23h: /^(2[0-3]|[0-1]?\d)/,
  // 0 to 23
  hour24h: /^(2[0-4]|[0-1]?\d)/,
  // 0 to 24
  hour11h: /^(1[0-1]|0?\d)/,
  // 0 to 11
  hour12h: /^(1[0-2]|0?\d)/,
  // 0 to 12
  minute: /^[0-5]?\d/,
  // 0 to 59
  second: /^[0-5]?\d/,
  // 0 to 59
  singleDigit: /^\d/,
  // 0 to 9
  twoDigits: /^\d{1,2}/,
  // 0 to 99
  threeDigits: /^\d{1,3}/,
  // 0 to 999
  fourDigits: /^\d{1,4}/,
  // 0 to 9999
  anyDigitsSigned: /^-?\d+/,
  singleDigitSigned: /^-?\d/,
  // 0 to 9, -0 to -9
  twoDigitsSigned: /^-?\d{1,2}/,
  // 0 to 99, -0 to -99
  threeDigitsSigned: /^-?\d{1,3}/,
  // 0 to 999, -0 to -999
  fourDigitsSigned: /^-?\d{1,4}/
  // 0 to 9999, -0 to -9999
}, it = {
  basicOptionalMinutes: /^([+-])(\d{2})(\d{2})?|Z/,
  basic: /^([+-])(\d{2})(\d{2})|Z/,
  basicOptionalSeconds: /^([+-])(\d{2})(\d{2})((\d{2}))?|Z/,
  extended: /^([+-])(\d{2}):(\d{2})|Z/,
  extendedOptionalSeconds: /^([+-])(\d{2}):(\d{2})(:(\d{2}))?|Z/
};
function Ie(e, t) {
  return e && {
    value: t(e.value),
    rest: e.rest
  };
}
function xe(e, t) {
  var n = t.match(e);
  return n ? {
    value: parseInt(n[0], 10),
    rest: t.slice(n[0].length)
  } : null;
}
function ut(e, t) {
  var n = t.match(e);
  if (!n)
    return null;
  if (n[0] === "Z")
    return {
      value: 0,
      rest: t.slice(1)
    };
  var r = n[1] === "+" ? 1 : -1, a = n[2] ? parseInt(n[2], 10) : 0, o = n[3] ? parseInt(n[3], 10) : 0, i = n[5] ? parseInt(n[5], 10) : 0;
  return {
    value: r * (a * Oo + o * _o + i * xl),
    rest: t.slice(n[0].length)
  };
}
function Cu(e) {
  return xe(Ce.anyDigitsSigned, e);
}
function Ne(e, t) {
  switch (e) {
    case 1:
      return xe(Ce.singleDigit, t);
    case 2:
      return xe(Ce.twoDigits, t);
    case 3:
      return xe(Ce.threeDigits, t);
    case 4:
      return xe(Ce.fourDigits, t);
    default:
      return xe(new RegExp("^\\d{1," + e + "}"), t);
  }
}
function er(e, t) {
  switch (e) {
    case 1:
      return xe(Ce.singleDigitSigned, t);
    case 2:
      return xe(Ce.twoDigitsSigned, t);
    case 3:
      return xe(Ce.threeDigitsSigned, t);
    case 4:
      return xe(Ce.fourDigitsSigned, t);
    default:
      return xe(new RegExp("^-?\\d{1," + e + "}"), t);
  }
}
function Do(e) {
  switch (e) {
    case "morning":
      return 4;
    case "evening":
      return 17;
    case "pm":
    case "noon":
    case "afternoon":
      return 12;
    case "am":
    case "midnight":
    case "night":
    default:
      return 0;
  }
}
function Iu(e, t) {
  var n = t > 0, r = n ? t : 1 - t, a;
  if (r <= 50)
    a = e || 100;
  else {
    var o = r + 50, i = Math.floor(o / 100) * 100, s = e >= o % 100;
    a = e + i - (s ? 100 : 0);
  }
  return n ? a : 1 - a;
}
function Au(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? dn = function(n) {
    return typeof n;
  } : dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, dn(e);
}
function rc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ho(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ac(e, t, n) {
  return t && Ho(e.prototype, t), n && Ho(e, n), e;
}
function oc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ca(e, t);
}
function ca(e, t) {
  return ca = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ca(e, t);
}
function ic(e) {
  var t = lc();
  return function() {
    var r = tr(e), a;
    if (t) {
      var o = tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return uc(this, a);
  };
}
function uc(e, t) {
  return t && (dn(t) === "object" || typeof t == "function") ? t : fa(e);
}
function fa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function lc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function tr(e) {
  return tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, tr(e);
}
function jo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var sc = /* @__PURE__ */ function(e) {
  oc(n, e);
  var t = ic(n);
  function n() {
    var r;
    rc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), jo(fa(r), "priority", 130), jo(fa(r), "incompatibleTokens", ["Y", "R", "u", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return ac(n, [{
    key: "parse",
    value: function(a, o, i) {
      var s = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "yy"
        };
      };
      switch (o) {
        case "y":
          return Ie(Ne(4, a), s);
        case "yo":
          return Ie(i.ordinalNumber(a, {
            unit: "year"
          }), s);
        default:
          return Ie(Ne(o.length, a), s);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var s = a.getUTCFullYear();
      if (i.isTwoDigitYear) {
        var l = Iu(i.year, s);
        return a.setUTCFullYear(l, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
      }
      var d = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(d, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? yn = function(n) {
    return typeof n;
  } : yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, yn(e);
}
function cc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function qo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function fc(e, t, n) {
  return t && qo(e.prototype, t), n && qo(e, n), e;
}
function dc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && da(e, t);
}
function da(e, t) {
  return da = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, da(e, t);
}
function yc(e) {
  var t = pc();
  return function() {
    var r = nr(e), a;
    if (t) {
      var o = nr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return mc(this, a);
  };
}
function mc(e, t) {
  return t && (yn(t) === "object" || typeof t == "function") ? t : ya(e);
}
function ya(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function pc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function nr(e) {
  return nr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, nr(e);
}
function zo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var vc = /* @__PURE__ */ function(e) {
  dc(n, e);
  var t = yc(n);
  function n() {
    var r;
    cc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), zo(ya(r), "priority", 130), zo(ya(r), "incompatibleTokens", ["y", "R", "u", "Q", "q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return fc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var s = function(d) {
        return {
          year: d,
          isTwoDigitYear: o === "YY"
        };
      };
      switch (o) {
        case "Y":
          return Ie(Ne(4, a), s);
        case "Yo":
          return Ie(i.ordinalNumber(a, {
            unit: "year"
          }), s);
        default:
          return Ie(Ne(o.length, a), s);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o.isTwoDigitYear || o.year > 0;
    }
  }, {
    key: "set",
    value: function(a, o, i, s) {
      var l = $o(a, s);
      if (i.isTwoDigitYear) {
        var d = Iu(i.year, l);
        return a.setUTCFullYear(d, 0, s.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), Rt(a, s);
      }
      var g = !("era" in o) || o.era === 1 ? i.year : 1 - i.year;
      return a.setUTCFullYear(g, 0, s.firstWeekContainsDate), a.setUTCHours(0, 0, 0, 0), Rt(a, s);
    }
  }]), n;
}(ge);
function mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? mn = function(n) {
    return typeof n;
  } : mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, mn(e);
}
function hc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Go(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function gc(e, t, n) {
  return t && Go(e.prototype, t), n && Go(e, n), e;
}
function bc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ma(e, t);
}
function ma(e, t) {
  return ma = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ma(e, t);
}
function wc(e) {
  var t = Oc();
  return function() {
    var r = rr(e), a;
    if (t) {
      var o = rr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return _c(this, a);
  };
}
function _c(e, t) {
  return t && (mn(t) === "object" || typeof t == "function") ? t : pa(e);
}
function pa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Oc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function rr(e) {
  return rr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, rr(e);
}
function Qo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var $c = /* @__PURE__ */ function(e) {
  bc(n, e);
  var t = wc(n);
  function n() {
    var r;
    hc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Qo(pa(r), "priority", 130), Qo(pa(r), "incompatibleTokens", ["G", "y", "Y", "u", "Q", "q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return gc(n, [{
    key: "parse",
    value: function(a, o) {
      return er(o === "R" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var s = new Date(0);
      return s.setUTCFullYear(i, 0, 4), s.setUTCHours(0, 0, 0, 0), Ft(s);
    }
  }]), n;
}(ge);
function pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? pn = function(n) {
    return typeof n;
  } : pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, pn(e);
}
function Pc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ko(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function kc(e, t, n) {
  return t && Ko(e.prototype, t), n && Ko(e, n), e;
}
function Tc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && va(e, t);
}
function va(e, t) {
  return va = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, va(e, t);
}
function Sc(e) {
  var t = xc();
  return function() {
    var r = ar(e), a;
    if (t) {
      var o = ar(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Dc(this, a);
  };
}
function Dc(e, t) {
  return t && (pn(t) === "object" || typeof t == "function") ? t : ha(e);
}
function ha(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function xc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ar(e) {
  return ar = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ar(e);
}
function Zo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Rc = /* @__PURE__ */ function(e) {
  Tc(n, e);
  var t = Sc(n);
  function n() {
    var r;
    Pc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Zo(ha(r), "priority", 130), Zo(ha(r), "incompatibleTokens", ["G", "y", "Y", "R", "w", "I", "i", "e", "c", "t", "T"]), r;
  }
  return kc(n, [{
    key: "parse",
    value: function(a, o) {
      return er(o === "u" ? 4 : o.length, a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCFullYear(i, 0, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? vn = function(n) {
    return typeof n;
  } : vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, vn(e);
}
function Mc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Xo(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Nc(e, t, n) {
  return t && Xo(e.prototype, t), n && Xo(e, n), e;
}
function Cc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ga(e, t);
}
function ga(e, t) {
  return ga = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ga(e, t);
}
function Ic(e) {
  var t = Bc();
  return function() {
    var r = or(e), a;
    if (t) {
      var o = or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ac(this, a);
  };
}
function Ac(e, t) {
  return t && (vn(t) === "object" || typeof t == "function") ? t : ba(e);
}
function ba(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Bc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function or(e) {
  return or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, or(e);
}
function Jo(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ec = /* @__PURE__ */ function(e) {
  Cc(n, e);
  var t = Ic(n);
  function n() {
    var r;
    Mc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Jo(ba(r), "priority", 120), Jo(ba(r), "incompatibleTokens", ["Y", "R", "q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Nc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "Q":
        case "QQ":
          return Ne(o.length, a);
        case "Qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "QQQ":
          return i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQQ":
          return i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
        case "QQQQ":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "formatting"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.quarter(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? hn = function(n) {
    return typeof n;
  } : hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, hn(e);
}
function Yc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ei(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Fc(e, t, n) {
  return t && ei(e.prototype, t), n && ei(e, n), e;
}
function Vc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && wa(e, t);
}
function wa(e, t) {
  return wa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, wa(e, t);
}
function Uc(e) {
  var t = Lc();
  return function() {
    var r = ir(e), a;
    if (t) {
      var o = ir(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Wc(this, a);
  };
}
function Wc(e, t) {
  return t && (hn(t) === "object" || typeof t == "function") ? t : _a(e);
}
function _a(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Lc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ir(e) {
  return ir = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ir(e);
}
function ti(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Hc = /* @__PURE__ */ function(e) {
  Vc(n, e);
  var t = Uc(n);
  function n() {
    var r;
    Yc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ti(_a(r), "priority", 120), ti(_a(r), "incompatibleTokens", ["Y", "R", "Q", "M", "L", "w", "I", "d", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Fc(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "q":
        case "qq":
          return Ne(o.length, a);
        case "qo":
          return i.ordinalNumber(a, {
            unit: "quarter"
          });
        case "qqq":
          return i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqqq":
          return i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
        case "qqqq":
        default:
          return i.quarter(a, {
            width: "wide",
            context: "standalone"
          }) || i.quarter(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.quarter(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 4;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth((i - 1) * 3, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function gn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? gn = function(n) {
    return typeof n;
  } : gn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, gn(e);
}
function jc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ni(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function qc(e, t, n) {
  return t && ni(e.prototype, t), n && ni(e, n), e;
}
function zc(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Oa(e, t);
}
function Oa(e, t) {
  return Oa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Oa(e, t);
}
function Gc(e) {
  var t = Kc();
  return function() {
    var r = ur(e), a;
    if (t) {
      var o = ur(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Qc(this, a);
  };
}
function Qc(e, t) {
  return t && (gn(t) === "object" || typeof t == "function") ? t : $a(e);
}
function $a(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Kc() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function ur(e) {
  return ur = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ur(e);
}
function ri(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Zc = /* @__PURE__ */ function(e) {
  zc(n, e);
  var t = Gc(n);
  function n() {
    var r;
    jc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ri($a(r), "incompatibleTokens", ["Y", "R", "q", "Q", "L", "w", "I", "D", "i", "e", "c", "t", "T"]), ri($a(r), "priority", 110), r;
  }
  return qc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var s = function(d) {
        return d - 1;
      };
      switch (o) {
        case "M":
          return Ie(xe(Ce.month, a), s);
        case "MM":
          return Ie(Ne(2, a), s);
        case "Mo":
          return Ie(i.ordinalNumber(a, {
            unit: "month"
          }), s);
        case "MMM":
          return i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMMM":
          return i.month(a, {
            width: "narrow",
            context: "formatting"
          });
        case "MMMM":
        default:
          return i.month(a, {
            width: "wide",
            context: "formatting"
          }) || i.month(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.month(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? bn = function(n) {
    return typeof n;
  } : bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, bn(e);
}
function Xc(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ai(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Jc(e, t, n) {
  return t && ai(e.prototype, t), n && ai(e, n), e;
}
function ef(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Pa(e, t);
}
function Pa(e, t) {
  return Pa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Pa(e, t);
}
function tf(e) {
  var t = rf();
  return function() {
    var r = lr(e), a;
    if (t) {
      var o = lr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return nf(this, a);
  };
}
function nf(e, t) {
  return t && (bn(t) === "object" || typeof t == "function") ? t : ka(e);
}
function ka(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function rf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function lr(e) {
  return lr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, lr(e);
}
function oi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var af = /* @__PURE__ */ function(e) {
  ef(n, e);
  var t = tf(n);
  function n() {
    var r;
    Xc(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), oi(ka(r), "priority", 110), oi(ka(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return Jc(n, [{
    key: "parse",
    value: function(a, o, i) {
      var s = function(d) {
        return d - 1;
      };
      switch (o) {
        case "L":
          return Ie(xe(Ce.month, a), s);
        case "LL":
          return Ie(Ne(2, a), s);
        case "Lo":
          return Ie(i.ordinalNumber(a, {
            unit: "month"
          }), s);
        case "LLL":
          return i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLLL":
          return i.month(a, {
            width: "narrow",
            context: "standalone"
          });
        case "LLLL":
        default:
          return i.month(a, {
            width: "wide",
            context: "standalone"
          }) || i.month(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.month(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(i, 1), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function of(e, t, n) {
  Z(2, arguments);
  var r = le(e), a = re(t), o = Pu(r, n) - a;
  return r.setUTCDate(r.getUTCDate() - o * 7), r;
}
function wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? wn = function(n) {
    return typeof n;
  } : wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, wn(e);
}
function uf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ii(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function lf(e, t, n) {
  return t && ii(e.prototype, t), n && ii(e, n), e;
}
function sf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ta(e, t);
}
function Ta(e, t) {
  return Ta = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ta(e, t);
}
function cf(e) {
  var t = df();
  return function() {
    var r = sr(e), a;
    if (t) {
      var o = sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return ff(this, a);
  };
}
function ff(e, t) {
  return t && (wn(t) === "object" || typeof t == "function") ? t : Sa(e);
}
function Sa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function df() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function sr(e) {
  return sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, sr(e);
}
function ui(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var yf = /* @__PURE__ */ function(e) {
  sf(n, e);
  var t = cf(n);
  function n() {
    var r;
    uf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ui(Sa(r), "priority", 100), ui(Sa(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "i", "t", "T"]), r;
  }
  return lf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "w":
          return xe(Ce.week, a);
        case "wo":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i, s) {
      return Rt(of(a, i, s), s);
    }
  }]), n;
}(ge);
function mf(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t), a = $u(n) - r;
  return n.setUTCDate(n.getUTCDate() - a * 7), n;
}
function _n(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? _n = function(n) {
    return typeof n;
  } : _n = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, _n(e);
}
function pf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function li(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function vf(e, t, n) {
  return t && li(e.prototype, t), n && li(e, n), e;
}
function hf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Da(e, t);
}
function Da(e, t) {
  return Da = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Da(e, t);
}
function gf(e) {
  var t = wf();
  return function() {
    var r = cr(e), a;
    if (t) {
      var o = cr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return bf(this, a);
  };
}
function bf(e, t) {
  return t && (_n(t) === "object" || typeof t == "function") ? t : xa(e);
}
function xa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function wf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function cr(e) {
  return cr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, cr(e);
}
function si(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var _f = /* @__PURE__ */ function(e) {
  hf(n, e);
  var t = gf(n);
  function n() {
    var r;
    pf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), si(xa(r), "priority", 100), si(xa(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "e", "c", "t", "T"]), r;
  }
  return vf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "I":
          return xe(Ce.week, a);
        case "Io":
          return i.ordinalNumber(a, {
            unit: "week"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 53;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return Ft(mf(a, i));
    }
  }]), n;
}(ge);
function On(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? On = function(n) {
    return typeof n;
  } : On = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, On(e);
}
function Of(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function ci(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function $f(e, t, n) {
  return t && ci(e.prototype, t), n && ci(e, n), e;
}
function Pf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ra(e, t);
}
function Ra(e, t) {
  return Ra = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ra(e, t);
}
function kf(e) {
  var t = Sf();
  return function() {
    var r = fr(e), a;
    if (t) {
      var o = fr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Tf(this, a);
  };
}
function Tf(e, t) {
  return t && (On(t) === "object" || typeof t == "function") ? t : $n(e);
}
function $n(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Sf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function fr(e) {
  return fr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, fr(e);
}
function jr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Df = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], xf = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Rf = /* @__PURE__ */ function(e) {
  Pf(n, e);
  var t = kf(n);
  function n() {
    var r;
    Of(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), jr($n(r), "priority", 90), jr($n(r), "subPriority", 1), jr($n(r), "incompatibleTokens", ["Y", "R", "q", "Q", "w", "I", "D", "i", "e", "c", "t", "T"]), r;
  }
  return $f(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "d":
          return xe(Ce.date, a);
        case "do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), s = Au(i), l = a.getUTCMonth();
      return s ? o >= 1 && o <= xf[l] : o >= 1 && o <= Df[l];
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCDate(i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Pn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Pn = function(n) {
    return typeof n;
  } : Pn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Pn(e);
}
function Mf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function fi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Nf(e, t, n) {
  return t && fi(e.prototype, t), n && fi(e, n), e;
}
function Cf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ma(e, t);
}
function Ma(e, t) {
  return Ma = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ma(e, t);
}
function If(e) {
  var t = Bf();
  return function() {
    var r = dr(e), a;
    if (t) {
      var o = dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Af(this, a);
  };
}
function Af(e, t) {
  return t && (Pn(t) === "object" || typeof t == "function") ? t : kn(e);
}
function kn(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Bf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function dr(e) {
  return dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, dr(e);
}
function qr(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ef = /* @__PURE__ */ function(e) {
  Cf(n, e);
  var t = If(n);
  function n() {
    var r;
    Mf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), qr(kn(r), "priority", 90), qr(kn(r), "subpriority", 1), qr(kn(r), "incompatibleTokens", ["Y", "R", "q", "Q", "M", "L", "w", "I", "d", "E", "i", "e", "c", "t", "T"]), r;
  }
  return Nf(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "D":
        case "DD":
          return xe(Ce.dayOfYear, a);
        case "Do":
          return i.ordinalNumber(a, {
            unit: "date"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      var i = a.getUTCFullYear(), s = Au(i);
      return s ? o >= 1 && o <= 366 : o >= 1 && o <= 365;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMonth(0, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function xo(e, t, n) {
  var r, a, o, i, s, l, d, g;
  Z(2, arguments);
  var y = ct(), f = re((r = (a = (o = (i = n == null ? void 0 : n.weekStartsOn) !== null && i !== void 0 ? i : n == null || (s = n.locale) === null || s === void 0 || (l = s.options) === null || l === void 0 ? void 0 : l.weekStartsOn) !== null && o !== void 0 ? o : y.weekStartsOn) !== null && a !== void 0 ? a : (d = y.locale) === null || d === void 0 || (g = d.options) === null || g === void 0 ? void 0 : g.weekStartsOn) !== null && r !== void 0 ? r : 0);
  if (!(f >= 0 && f <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  var h = le(e), I = re(t), Y = h.getUTCDay(), H = I % 7, X = (H + 7) % 7, z = (X < f ? 7 : 0) + I - Y;
  return h.setUTCDate(h.getUTCDate() + z), h;
}
function Tn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Tn = function(n) {
    return typeof n;
  } : Tn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Tn(e);
}
function Yf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function di(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ff(e, t, n) {
  return t && di(e.prototype, t), n && di(e, n), e;
}
function Vf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Na(e, t);
}
function Na(e, t) {
  return Na = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Na(e, t);
}
function Uf(e) {
  var t = Lf();
  return function() {
    var r = yr(e), a;
    if (t) {
      var o = yr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Wf(this, a);
  };
}
function Wf(e, t) {
  return t && (Tn(t) === "object" || typeof t == "function") ? t : Ca(e);
}
function Ca(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Lf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function yr(e) {
  return yr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, yr(e);
}
function yi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Hf = /* @__PURE__ */ function(e) {
  Vf(n, e);
  var t = Uf(n);
  function n() {
    var r;
    Yf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), yi(Ca(r), "priority", 90), yi(Ca(r), "incompatibleTokens", ["D", "i", "e", "c", "t", "T"]), r;
  }
  return Ff(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "E":
        case "EE":
        case "EEE":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEE":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEEEE":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "EEEE":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, s) {
      return a = xo(a, i, s), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Sn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Sn = function(n) {
    return typeof n;
  } : Sn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Sn(e);
}
function jf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function mi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function qf(e, t, n) {
  return t && mi(e.prototype, t), n && mi(e, n), e;
}
function zf(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ia(e, t);
}
function Ia(e, t) {
  return Ia = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ia(e, t);
}
function Gf(e) {
  var t = Kf();
  return function() {
    var r = mr(e), a;
    if (t) {
      var o = mr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Qf(this, a);
  };
}
function Qf(e, t) {
  return t && (Sn(t) === "object" || typeof t == "function") ? t : Aa(e);
}
function Aa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Kf() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function mr(e) {
  return mr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, mr(e);
}
function pi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Zf = /* @__PURE__ */ function(e) {
  zf(n, e);
  var t = Gf(n);
  function n() {
    var r;
    jf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), pi(Aa(r), "priority", 90), pi(Aa(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "c", "t", "T"]), r;
  }
  return qf(n, [{
    key: "parse",
    value: function(a, o, i, s) {
      var l = function(g) {
        var y = Math.floor((g - 1) / 7) * 7;
        return (g + s.weekStartsOn + 6) % 7 + y;
      };
      switch (o) {
        case "e":
        case "ee":
          return Ie(Ne(o.length, a), l);
        case "eo":
          return Ie(i.ordinalNumber(a, {
            unit: "day"
          }), l);
        case "eee":
          return i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeee":
          return i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeeeee":
          return i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
        case "eeee":
        default:
          return i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, s) {
      return a = xo(a, i, s), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Dn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Dn = function(n) {
    return typeof n;
  } : Dn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Dn(e);
}
function Xf(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function vi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Jf(e, t, n) {
  return t && vi(e.prototype, t), n && vi(e, n), e;
}
function ed(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ba(e, t);
}
function Ba(e, t) {
  return Ba = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ba(e, t);
}
function td(e) {
  var t = rd();
  return function() {
    var r = pr(e), a;
    if (t) {
      var o = pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return nd(this, a);
  };
}
function nd(e, t) {
  return t && (Dn(t) === "object" || typeof t == "function") ? t : Ea(e);
}
function Ea(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function rd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function pr(e) {
  return pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, pr(e);
}
function hi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ad = /* @__PURE__ */ function(e) {
  ed(n, e);
  var t = td(n);
  function n() {
    var r;
    Xf(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), hi(Ea(r), "priority", 90), hi(Ea(r), "incompatibleTokens", ["y", "R", "u", "q", "Q", "M", "L", "I", "d", "D", "E", "i", "e", "t", "T"]), r;
  }
  return Jf(n, [{
    key: "parse",
    value: function(a, o, i, s) {
      var l = function(g) {
        var y = Math.floor((g - 1) / 7) * 7;
        return (g + s.weekStartsOn + 6) % 7 + y;
      };
      switch (o) {
        case "c":
        case "cc":
          return Ie(Ne(o.length, a), l);
        case "co":
          return Ie(i.ordinalNumber(a, {
            unit: "day"
          }), l);
        case "ccc":
          return i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "ccccc":
          return i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccccc":
          return i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
        case "cccc":
        default:
          return i.day(a, {
            width: "wide",
            context: "standalone"
          }) || i.day(a, {
            width: "abbreviated",
            context: "standalone"
          }) || i.day(a, {
            width: "short",
            context: "standalone"
          }) || i.day(a, {
            width: "narrow",
            context: "standalone"
          });
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 6;
    }
  }, {
    key: "set",
    value: function(a, o, i, s) {
      return a = xo(a, i, s), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function od(e, t) {
  Z(2, arguments);
  var n = re(t);
  n % 7 === 0 && (n = n - 7);
  var r = 1, a = le(e), o = a.getUTCDay(), i = n % 7, s = (i + 7) % 7, l = (s < r ? 7 : 0) + n - o;
  return a.setUTCDate(a.getUTCDate() + l), a;
}
function xn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? xn = function(n) {
    return typeof n;
  } : xn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, xn(e);
}
function id(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function gi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ud(e, t, n) {
  return t && gi(e.prototype, t), n && gi(e, n), e;
}
function ld(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ya(e, t);
}
function Ya(e, t) {
  return Ya = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ya(e, t);
}
function sd(e) {
  var t = fd();
  return function() {
    var r = vr(e), a;
    if (t) {
      var o = vr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return cd(this, a);
  };
}
function cd(e, t) {
  return t && (xn(t) === "object" || typeof t == "function") ? t : Fa(e);
}
function Fa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function fd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function vr(e) {
  return vr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, vr(e);
}
function bi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var dd = /* @__PURE__ */ function(e) {
  ld(n, e);
  var t = sd(n);
  function n() {
    var r;
    id(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), bi(Fa(r), "priority", 90), bi(Fa(r), "incompatibleTokens", ["y", "Y", "u", "q", "Q", "M", "L", "w", "d", "D", "E", "e", "c", "t", "T"]), r;
  }
  return ud(n, [{
    key: "parse",
    value: function(a, o, i) {
      var s = function(d) {
        return d === 0 ? 7 : d;
      };
      switch (o) {
        case "i":
        case "ii":
          return Ne(o.length, a);
        case "io":
          return i.ordinalNumber(a, {
            unit: "day"
          });
        case "iii":
          return Ie(i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), s);
        case "iiiii":
          return Ie(i.day(a, {
            width: "narrow",
            context: "formatting"
          }), s);
        case "iiiiii":
          return Ie(i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), s);
        case "iiii":
        default:
          return Ie(i.day(a, {
            width: "wide",
            context: "formatting"
          }) || i.day(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.day(a, {
            width: "short",
            context: "formatting"
          }) || i.day(a, {
            width: "narrow",
            context: "formatting"
          }), s);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 7;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a = od(a, i), a.setUTCHours(0, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Rn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Rn = function(n) {
    return typeof n;
  } : Rn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Rn(e);
}
function yd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function wi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function md(e, t, n) {
  return t && wi(e.prototype, t), n && wi(e, n), e;
}
function pd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Va(e, t);
}
function Va(e, t) {
  return Va = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Va(e, t);
}
function vd(e) {
  var t = gd();
  return function() {
    var r = hr(e), a;
    if (t) {
      var o = hr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return hd(this, a);
  };
}
function hd(e, t) {
  return t && (Rn(t) === "object" || typeof t == "function") ? t : Ua(e);
}
function Ua(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function gd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function hr(e) {
  return hr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, hr(e);
}
function _i(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var bd = /* @__PURE__ */ function(e) {
  pd(n, e);
  var t = vd(n);
  function n() {
    var r;
    yd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), _i(Ua(r), "priority", 80), _i(Ua(r), "incompatibleTokens", ["b", "B", "H", "k", "t", "T"]), r;
  }
  return md(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "a":
        case "aa":
        case "aaa":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaaa":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "aaaa":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Do(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Mn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Mn = function(n) {
    return typeof n;
  } : Mn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Mn(e);
}
function wd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Oi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function _d(e, t, n) {
  return t && Oi(e.prototype, t), n && Oi(e, n), e;
}
function Od(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Wa(e, t);
}
function Wa(e, t) {
  return Wa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Wa(e, t);
}
function $d(e) {
  var t = kd();
  return function() {
    var r = gr(e), a;
    if (t) {
      var o = gr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Pd(this, a);
  };
}
function Pd(e, t) {
  return t && (Mn(t) === "object" || typeof t == "function") ? t : La(e);
}
function La(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function kd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function gr(e) {
  return gr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, gr(e);
}
function $i(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Td = /* @__PURE__ */ function(e) {
  Od(n, e);
  var t = $d(n);
  function n() {
    var r;
    wd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), $i(La(r), "priority", 80), $i(La(r), "incompatibleTokens", ["a", "B", "H", "k", "t", "T"]), r;
  }
  return _d(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "b":
        case "bb":
        case "bbb":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbbb":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "bbbb":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Do(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Nn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Nn = function(n) {
    return typeof n;
  } : Nn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Nn(e);
}
function Sd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Pi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Dd(e, t, n) {
  return t && Pi(e.prototype, t), n && Pi(e, n), e;
}
function xd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ha(e, t);
}
function Ha(e, t) {
  return Ha = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ha(e, t);
}
function Rd(e) {
  var t = Nd();
  return function() {
    var r = br(e), a;
    if (t) {
      var o = br(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Md(this, a);
  };
}
function Md(e, t) {
  return t && (Nn(t) === "object" || typeof t == "function") ? t : ja(e);
}
function ja(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Nd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function br(e) {
  return br = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, br(e);
}
function ki(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Cd = /* @__PURE__ */ function(e) {
  xd(n, e);
  var t = Rd(n);
  function n() {
    var r;
    Sd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ki(ja(r), "priority", 80), ki(ja(r), "incompatibleTokens", ["a", "b", "t", "T"]), r;
  }
  return Dd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "B":
        case "BB":
        case "BBB":
          return i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBBB":
          return i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
        case "BBBB":
        default:
          return i.dayPeriod(a, {
            width: "wide",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "abbreviated",
            context: "formatting"
          }) || i.dayPeriod(a, {
            width: "narrow",
            context: "formatting"
          });
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(Do(i), 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Cn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Cn = function(n) {
    return typeof n;
  } : Cn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Cn(e);
}
function Id(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ti(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ad(e, t, n) {
  return t && Ti(e.prototype, t), n && Ti(e, n), e;
}
function Bd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && qa(e, t);
}
function qa(e, t) {
  return qa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, qa(e, t);
}
function Ed(e) {
  var t = Fd();
  return function() {
    var r = wr(e), a;
    if (t) {
      var o = wr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Yd(this, a);
  };
}
function Yd(e, t) {
  return t && (Cn(t) === "object" || typeof t == "function") ? t : za(e);
}
function za(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Fd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function wr(e) {
  return wr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, wr(e);
}
function Si(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Vd = /* @__PURE__ */ function(e) {
  Bd(n, e);
  var t = Ed(n);
  function n() {
    var r;
    Id(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Si(za(r), "priority", 70), Si(za(r), "incompatibleTokens", ["H", "K", "k", "t", "T"]), r;
  }
  return Ad(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "h":
          return xe(Ce.hour12h, a);
        case "ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 12;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var s = a.getUTCHours() >= 12;
      return s && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : !s && i === 12 ? a.setUTCHours(0, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function In(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? In = function(n) {
    return typeof n;
  } : In = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, In(e);
}
function Ud(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Di(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Wd(e, t, n) {
  return t && Di(e.prototype, t), n && Di(e, n), e;
}
function Ld(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ga(e, t);
}
function Ga(e, t) {
  return Ga = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ga(e, t);
}
function Hd(e) {
  var t = qd();
  return function() {
    var r = _r(e), a;
    if (t) {
      var o = _r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return jd(this, a);
  };
}
function jd(e, t) {
  return t && (In(t) === "object" || typeof t == "function") ? t : Qa(e);
}
function Qa(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function qd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function _r(e) {
  return _r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, _r(e);
}
function xi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var zd = /* @__PURE__ */ function(e) {
  Ld(n, e);
  var t = Hd(n);
  function n() {
    var r;
    Ud(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), xi(Qa(r), "priority", 70), xi(Qa(r), "incompatibleTokens", ["a", "b", "h", "K", "k", "t", "T"]), r;
  }
  return Wd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "H":
          return xe(Ce.hour23h, a);
        case "Ho":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 23;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function An(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? An = function(n) {
    return typeof n;
  } : An = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, An(e);
}
function Gd(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ri(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Qd(e, t, n) {
  return t && Ri(e.prototype, t), n && Ri(e, n), e;
}
function Kd(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Ka(e, t);
}
function Ka(e, t) {
  return Ka = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Ka(e, t);
}
function Zd(e) {
  var t = Jd();
  return function() {
    var r = Or(e), a;
    if (t) {
      var o = Or(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Xd(this, a);
  };
}
function Xd(e, t) {
  return t && (An(t) === "object" || typeof t == "function") ? t : Za(e);
}
function Za(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Jd() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Or(e) {
  return Or = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Or(e);
}
function Mi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var ey = /* @__PURE__ */ function(e) {
  Kd(n, e);
  var t = Zd(n);
  function n() {
    var r;
    Gd(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Mi(Za(r), "priority", 70), Mi(Za(r), "incompatibleTokens", ["h", "H", "k", "t", "T"]), r;
  }
  return Qd(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "K":
          return xe(Ce.hour11h, a);
        case "Ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 11;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var s = a.getUTCHours() >= 12;
      return s && i < 12 ? a.setUTCHours(i + 12, 0, 0, 0) : a.setUTCHours(i, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function Bn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Bn = function(n) {
    return typeof n;
  } : Bn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Bn(e);
}
function ty(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ni(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function ny(e, t, n) {
  return t && Ni(e.prototype, t), n && Ni(e, n), e;
}
function ry(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && Xa(e, t);
}
function Xa(e, t) {
  return Xa = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, Xa(e, t);
}
function ay(e) {
  var t = iy();
  return function() {
    var r = $r(e), a;
    if (t) {
      var o = $r(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return oy(this, a);
  };
}
function oy(e, t) {
  return t && (Bn(t) === "object" || typeof t == "function") ? t : Ja(e);
}
function Ja(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function iy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function $r(e) {
  return $r = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, $r(e);
}
function Ci(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var uy = /* @__PURE__ */ function(e) {
  ry(n, e);
  var t = ay(n);
  function n() {
    var r;
    ty(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ci(Ja(r), "priority", 70), Ci(Ja(r), "incompatibleTokens", ["a", "b", "h", "H", "K", "t", "T"]), r;
  }
  return ny(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "k":
          return xe(Ce.hour24h, a);
        case "ko":
          return i.ordinalNumber(a, {
            unit: "hour"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 1 && o <= 24;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      var s = i <= 24 ? i % 24 : i;
      return a.setUTCHours(s, 0, 0, 0), a;
    }
  }]), n;
}(ge);
function En(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? En = function(n) {
    return typeof n;
  } : En = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, En(e);
}
function ly(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Ii(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function sy(e, t, n) {
  return t && Ii(e.prototype, t), n && Ii(e, n), e;
}
function cy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && eo(e, t);
}
function eo(e, t) {
  return eo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, eo(e, t);
}
function fy(e) {
  var t = yy();
  return function() {
    var r = Pr(e), a;
    if (t) {
      var o = Pr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return dy(this, a);
  };
}
function dy(e, t) {
  return t && (En(t) === "object" || typeof t == "function") ? t : to(e);
}
function to(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function yy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Pr(e) {
  return Pr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Pr(e);
}
function Ai(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var my = /* @__PURE__ */ function(e) {
  cy(n, e);
  var t = fy(n);
  function n() {
    var r;
    ly(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ai(to(r), "priority", 60), Ai(to(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return sy(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "m":
          return xe(Ce.minute, a);
        case "mo":
          return i.ordinalNumber(a, {
            unit: "minute"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMinutes(i, 0, 0), a;
    }
  }]), n;
}(ge);
function Yn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Yn = function(n) {
    return typeof n;
  } : Yn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Yn(e);
}
function py(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Bi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function vy(e, t, n) {
  return t && Bi(e.prototype, t), n && Bi(e, n), e;
}
function hy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && no(e, t);
}
function no(e, t) {
  return no = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, no(e, t);
}
function gy(e) {
  var t = wy();
  return function() {
    var r = kr(e), a;
    if (t) {
      var o = kr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return by(this, a);
  };
}
function by(e, t) {
  return t && (Yn(t) === "object" || typeof t == "function") ? t : ro(e);
}
function ro(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function wy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function kr(e) {
  return kr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, kr(e);
}
function Ei(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var _y = /* @__PURE__ */ function(e) {
  hy(n, e);
  var t = gy(n);
  function n() {
    var r;
    py(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ei(ro(r), "priority", 50), Ei(ro(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return vy(n, [{
    key: "parse",
    value: function(a, o, i) {
      switch (o) {
        case "s":
          return xe(Ce.second, a);
        case "so":
          return i.ordinalNumber(a, {
            unit: "second"
          });
        default:
          return Ne(o.length, a);
      }
    }
  }, {
    key: "validate",
    value: function(a, o) {
      return o >= 0 && o <= 59;
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCSeconds(i, 0), a;
    }
  }]), n;
}(ge);
function Fn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Fn = function(n) {
    return typeof n;
  } : Fn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Fn(e);
}
function Oy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Yi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function $y(e, t, n) {
  return t && Yi(e.prototype, t), n && Yi(e, n), e;
}
function Py(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && ao(e, t);
}
function ao(e, t) {
  return ao = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, ao(e, t);
}
function ky(e) {
  var t = Sy();
  return function() {
    var r = Tr(e), a;
    if (t) {
      var o = Tr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Ty(this, a);
  };
}
function Ty(e, t) {
  return t && (Fn(t) === "object" || typeof t == "function") ? t : oo(e);
}
function oo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Sy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Tr(e) {
  return Tr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Tr(e);
}
function Fi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Dy = /* @__PURE__ */ function(e) {
  Py(n, e);
  var t = ky(n);
  function n() {
    var r;
    Oy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Fi(oo(r), "priority", 30), Fi(oo(r), "incompatibleTokens", ["t", "T"]), r;
  }
  return $y(n, [{
    key: "parse",
    value: function(a, o) {
      var i = function(l) {
        return Math.floor(l * Math.pow(10, -o.length + 3));
      };
      return Ie(Ne(o.length, a), i);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return a.setUTCMilliseconds(i), a;
    }
  }]), n;
}(ge);
function Vn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Vn = function(n) {
    return typeof n;
  } : Vn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Vn(e);
}
function xy(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Vi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ry(e, t, n) {
  return t && Vi(e.prototype, t), n && Vi(e, n), e;
}
function My(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && io(e, t);
}
function io(e, t) {
  return io = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, io(e, t);
}
function Ny(e) {
  var t = Iy();
  return function() {
    var r = Sr(e), a;
    if (t) {
      var o = Sr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Cy(this, a);
  };
}
function Cy(e, t) {
  return t && (Vn(t) === "object" || typeof t == "function") ? t : uo(e);
}
function uo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Iy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Sr(e) {
  return Sr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Sr(e);
}
function Ui(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Ay = /* @__PURE__ */ function(e) {
  My(n, e);
  var t = Ny(n);
  function n() {
    var r;
    xy(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Ui(uo(r), "priority", 10), Ui(uo(r), "incompatibleTokens", ["t", "T", "x"]), r;
  }
  return Ry(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "X":
          return ut(it.basicOptionalMinutes, a);
        case "XX":
          return ut(it.basic, a);
        case "XXXX":
          return ut(it.basicOptionalSeconds, a);
        case "XXXXX":
          return ut(it.extendedOptionalSeconds, a);
        case "XXX":
        default:
          return ut(it.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Un(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Un = function(n) {
    return typeof n;
  } : Un = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Un(e);
}
function By(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Wi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Ey(e, t, n) {
  return t && Wi(e.prototype, t), n && Wi(e, n), e;
}
function Yy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && lo(e, t);
}
function lo(e, t) {
  return lo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, lo(e, t);
}
function Fy(e) {
  var t = Uy();
  return function() {
    var r = Dr(e), a;
    if (t) {
      var o = Dr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return Vy(this, a);
  };
}
function Vy(e, t) {
  return t && (Un(t) === "object" || typeof t == "function") ? t : so(e);
}
function so(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Uy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Dr(e) {
  return Dr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Dr(e);
}
function Li(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Wy = /* @__PURE__ */ function(e) {
  Yy(n, e);
  var t = Fy(n);
  function n() {
    var r;
    By(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), Li(so(r), "priority", 10), Li(so(r), "incompatibleTokens", ["t", "T", "X"]), r;
  }
  return Ey(n, [{
    key: "parse",
    value: function(a, o) {
      switch (o) {
        case "x":
          return ut(it.basicOptionalMinutes, a);
        case "xx":
          return ut(it.basic, a);
        case "xxxx":
          return ut(it.basicOptionalSeconds, a);
        case "xxxxx":
          return ut(it.extendedOptionalSeconds, a);
        case "xxx":
        default:
          return ut(it.extended, a);
      }
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return o.timestampIsSet ? a : new Date(a.getTime() - i);
    }
  }]), n;
}(ge);
function Wn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Wn = function(n) {
    return typeof n;
  } : Wn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Wn(e);
}
function Ly(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function Hi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Hy(e, t, n) {
  return t && Hi(e.prototype, t), n && Hi(e, n), e;
}
function jy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && co(e, t);
}
function co(e, t) {
  return co = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, co(e, t);
}
function qy(e) {
  var t = Gy();
  return function() {
    var r = xr(e), a;
    if (t) {
      var o = xr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return zy(this, a);
  };
}
function zy(e, t) {
  return t && (Wn(t) === "object" || typeof t == "function") ? t : fo(e);
}
function fo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function Gy() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function xr(e) {
  return xr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, xr(e);
}
function ji(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var Qy = /* @__PURE__ */ function(e) {
  jy(n, e);
  var t = qy(n);
  function n() {
    var r;
    Ly(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), ji(fo(r), "priority", 40), ji(fo(r), "incompatibleTokens", "*"), r;
  }
  return Hy(n, [{
    key: "parse",
    value: function(a) {
      return Cu(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i * 1e3), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge);
function Ln(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Ln = function(n) {
    return typeof n;
  } : Ln = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Ln(e);
}
function Ky(e, t) {
  if (!(e instanceof t))
    throw new TypeError("Cannot call a class as a function");
}
function qi(e, t) {
  for (var n = 0; n < t.length; n++) {
    var r = t[n];
    r.enumerable = r.enumerable || !1, r.configurable = !0, "value" in r && (r.writable = !0), Object.defineProperty(e, r.key, r);
  }
}
function Zy(e, t, n) {
  return t && qi(e.prototype, t), n && qi(e, n), e;
}
function Xy(e, t) {
  if (typeof t != "function" && t !== null)
    throw new TypeError("Super expression must either be null or a function");
  e.prototype = Object.create(t && t.prototype, { constructor: { value: e, writable: !0, configurable: !0 } }), t && yo(e, t);
}
function yo(e, t) {
  return yo = Object.setPrototypeOf || function(r, a) {
    return r.__proto__ = a, r;
  }, yo(e, t);
}
function Jy(e) {
  var t = tm();
  return function() {
    var r = Rr(e), a;
    if (t) {
      var o = Rr(this).constructor;
      a = Reflect.construct(r, arguments, o);
    } else
      a = r.apply(this, arguments);
    return em(this, a);
  };
}
function em(e, t) {
  return t && (Ln(t) === "object" || typeof t == "function") ? t : mo(e);
}
function mo(e) {
  if (e === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return e;
}
function tm() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Rr(e) {
  return Rr = Object.setPrototypeOf ? Object.getPrototypeOf : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, Rr(e);
}
function zi(e, t, n) {
  return t in e ? Object.defineProperty(e, t, { value: n, enumerable: !0, configurable: !0, writable: !0 }) : e[t] = n, e;
}
var nm = /* @__PURE__ */ function(e) {
  Xy(n, e);
  var t = Jy(n);
  function n() {
    var r;
    Ky(this, n);
    for (var a = arguments.length, o = new Array(a), i = 0; i < a; i++)
      o[i] = arguments[i];
    return r = t.call.apply(t, [this].concat(o)), zi(mo(r), "priority", 20), zi(mo(r), "incompatibleTokens", "*"), r;
  }
  return Zy(n, [{
    key: "parse",
    value: function(a) {
      return Cu(a);
    }
  }, {
    key: "set",
    value: function(a, o, i) {
      return [new Date(i), {
        timestampIsSet: !0
      }];
    }
  }]), n;
}(ge), rm = {
  G: new nc(),
  y: new sc(),
  Y: new vc(),
  R: new $c(),
  u: new Rc(),
  Q: new Ec(),
  q: new Hc(),
  M: new Zc(),
  L: new af(),
  w: new yf(),
  I: new _f(),
  d: new Rf(),
  D: new Ef(),
  E: new Hf(),
  e: new Zf(),
  c: new ad(),
  i: new dd(),
  a: new bd(),
  b: new Td(),
  B: new Cd(),
  h: new Vd(),
  H: new zd(),
  K: new ey(),
  k: new uy(),
  m: new my(),
  s: new _y(),
  S: new Dy(),
  X: new Ay(),
  x: new Wy(),
  t: new Qy(),
  T: new nm()
};
function Hn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Hn = function(n) {
    return typeof n;
  } : Hn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, Hn(e);
}
function Gi(e, t) {
  var n;
  if (typeof Symbol > "u" || e[Symbol.iterator] == null) {
    if (Array.isArray(e) || (n = am(e)) || t && e && typeof e.length == "number") {
      n && (e = n);
      var r = 0, a = function() {
      };
      return { s: a, n: function() {
        return r >= e.length ? { done: !0 } : { done: !1, value: e[r++] };
      }, e: function(d) {
        throw d;
      }, f: a };
    }
    throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  var o = !0, i = !1, s;
  return { s: function() {
    n = e[Symbol.iterator]();
  }, n: function() {
    var d = n.next();
    return o = d.done, d;
  }, e: function(d) {
    i = !0, s = d;
  }, f: function() {
    try {
      !o && n.return != null && n.return();
    } finally {
      if (i)
        throw s;
    }
  } };
}
function am(e, t) {
  if (e) {
    if (typeof e == "string")
      return Qi(e, t);
    var n = Object.prototype.toString.call(e).slice(8, -1);
    if (n === "Object" && e.constructor && (n = e.constructor.name), n === "Map" || n === "Set")
      return Array.from(e);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return Qi(e, t);
  }
}
function Qi(e, t) {
  (t == null || t > e.length) && (t = e.length);
  for (var n = 0, r = new Array(t); n < t; n++)
    r[n] = e[n];
  return r;
}
var om = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g, im = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g, um = /^'([^]*?)'?$/, lm = /''/g, sm = /\S/, cm = /[a-zA-Z]/;
function po(e, t, n, r) {
  var a, o, i, s, l, d, g, y, f, h, I, Y, H, X, z, B, j, ae;
  Z(3, arguments);
  var J = String(e), D = String(t), O = ct(), A = (a = (o = r == null ? void 0 : r.locale) !== null && o !== void 0 ? o : O.locale) !== null && a !== void 0 ? a : Du;
  if (!A.match)
    throw new RangeError("locale must contain match property");
  var V = re((i = (s = (l = (d = r == null ? void 0 : r.firstWeekContainsDate) !== null && d !== void 0 ? d : r == null || (g = r.locale) === null || g === void 0 || (y = g.options) === null || y === void 0 ? void 0 : y.firstWeekContainsDate) !== null && l !== void 0 ? l : O.firstWeekContainsDate) !== null && s !== void 0 ? s : (f = O.locale) === null || f === void 0 || (h = f.options) === null || h === void 0 ? void 0 : h.firstWeekContainsDate) !== null && i !== void 0 ? i : 1);
  if (!(V >= 1 && V <= 7))
    throw new RangeError("firstWeekContainsDate must be between 1 and 7 inclusively");
  var C = re((I = (Y = (H = (X = r == null ? void 0 : r.weekStartsOn) !== null && X !== void 0 ? X : r == null || (z = r.locale) === null || z === void 0 || (B = z.options) === null || B === void 0 ? void 0 : B.weekStartsOn) !== null && H !== void 0 ? H : O.weekStartsOn) !== null && Y !== void 0 ? Y : (j = O.locale) === null || j === void 0 || (ae = j.options) === null || ae === void 0 ? void 0 : ae.weekStartsOn) !== null && I !== void 0 ? I : 0);
  if (!(C >= 0 && C <= 6))
    throw new RangeError("weekStartsOn must be between 0 and 6 inclusively");
  if (D === "")
    return J === "" ? le(n) : new Date(NaN);
  var U = {
    firstWeekContainsDate: V,
    weekStartsOn: C,
    locale: A
  }, K = [new zs()], oe = D.match(im).map(function(ve) {
    var de = ve[0];
    if (de in aa) {
      var De = aa[de];
      return De(ve, A.formatLong);
    }
    return ve;
  }).join("").match(om), P = [], S = Gi(oe), u;
  try {
    var v = function() {
      var de = u.value;
      !(r != null && r.useAdditionalWeekYearTokens) && Su(de) && Zn(de, D, e), !(r != null && r.useAdditionalDayOfYearTokens) && Tu(de) && Zn(de, D, e);
      var De = de[0], Qe = rm[De];
      if (Qe) {
        var ce = Qe.incompatibleTokens;
        if (Array.isArray(ce)) {
          var nt = P.find(function(ee) {
            return ce.includes(ee.token) || ee.token === De;
          });
          if (nt)
            throw new RangeError("The format string mustn't contain `".concat(nt.fullToken, "` and `").concat(de, "` at the same time"));
        } else if (Qe.incompatibleTokens === "*" && P.length > 0)
          throw new RangeError("The format string mustn't contain `".concat(de, "` and any other token at the same time"));
        P.push({
          token: De,
          fullToken: de
        });
        var Ke = Qe.run(J, de, A.match, U);
        if (!Ke)
          return {
            v: new Date(NaN)
          };
        K.push(Ke.setter), J = Ke.rest;
      } else {
        if (De.match(cm))
          throw new RangeError("Format string contains an unescaped latin alphabet character `" + De + "`");
        if (de === "''" ? de = "'" : De === "'" && (de = fm(de)), J.indexOf(de) === 0)
          J = J.slice(de.length);
        else
          return {
            v: new Date(NaN)
          };
      }
    };
    for (S.s(); !(u = S.n()).done; ) {
      var $ = v();
      if (Hn($) === "object")
        return $.v;
    }
  } catch (ve) {
    S.e(ve);
  } finally {
    S.f();
  }
  if (J.length > 0 && sm.test(J))
    return new Date(NaN);
  var _ = K.map(function(ve) {
    return ve.priority;
  }).sort(function(ve, de) {
    return de - ve;
  }).filter(function(ve, de, De) {
    return De.indexOf(ve) === de;
  }).map(function(ve) {
    return K.filter(function(de) {
      return de.priority === ve;
    }).sort(function(de, De) {
      return De.subPriority - de.subPriority;
    });
  }).map(function(ve) {
    return ve[0];
  }), N = le(n);
  if (isNaN(N.getTime()))
    return new Date(NaN);
  var G = _u(N, Kn(N)), ne = {}, b = Gi(_), p;
  try {
    for (b.s(); !(p = b.n()).done; ) {
      var k = p.value;
      if (!k.validate(G, U))
        return new Date(NaN);
      var we = k.set(G, ne, U);
      Array.isArray(we) ? (G = we[0], Is(ne, we[1])) : G = we;
    }
  } catch (ve) {
    b.e(ve);
  } finally {
    b.f();
  }
  return G;
}
function fm(e) {
  return e.match(um)[1].replace(lm, "'");
}
function dm(e, t) {
  Z(2, arguments);
  var n = re(t);
  return vt(e, -n);
}
function ym(e, t) {
  var n;
  Z(1, arguments);
  var r = re((n = t == null ? void 0 : t.additionalDigits) !== null && n !== void 0 ? n : 2);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = hm(e), o;
  if (a.date) {
    var i = gm(a.date, r);
    o = bm(i.restDateString, i.year);
  }
  if (!o || isNaN(o.getTime()))
    return new Date(NaN);
  var s = o.getTime(), l = 0, d;
  if (a.time && (l = wm(a.time), isNaN(l)))
    return new Date(NaN);
  if (a.timezone) {
    if (d = _m(a.timezone), isNaN(d))
      return new Date(NaN);
  } else {
    var g = new Date(s + l), y = new Date(0);
    return y.setFullYear(g.getUTCFullYear(), g.getUTCMonth(), g.getUTCDate()), y.setHours(g.getUTCHours(), g.getUTCMinutes(), g.getUTCSeconds(), g.getUTCMilliseconds()), y;
  }
  return new Date(s + l + d);
}
var nn = {
  dateTimeDelimiter: /[T ]/,
  timeZoneDelimiter: /[Z ]/i,
  timezone: /([Z+-].*)$/
}, mm = /^-?(?:(\d{3})|(\d{2})(?:-?(\d{2}))?|W(\d{2})(?:-?(\d{1}))?|)$/, pm = /^(\d{2}(?:[.,]\d*)?)(?::?(\d{2}(?:[.,]\d*)?))?(?::?(\d{2}(?:[.,]\d*)?))?$/, vm = /^([+-])(\d{2})(?::?(\d{2}))?$/;
function hm(e) {
  var t = {}, n = e.split(nn.dateTimeDelimiter), r;
  if (n.length > 2)
    return t;
  if (/:/.test(n[0]) ? r = n[0] : (t.date = n[0], r = n[1], nn.timeZoneDelimiter.test(t.date) && (t.date = e.split(nn.timeZoneDelimiter)[0], r = e.substr(t.date.length, e.length))), r) {
    var a = nn.timezone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timezone = a[1]) : t.time = r;
  }
  return t;
}
function gm(e, t) {
  var n = new RegExp("^(?:(\\d{4}|[+-]\\d{" + (4 + t) + "})|(\\d{2}|[+-]\\d{" + (2 + t) + "})$)"), r = e.match(n);
  if (!r)
    return {
      year: NaN,
      restDateString: ""
    };
  var a = r[1] ? parseInt(r[1]) : null, o = r[2] ? parseInt(r[2]) : null;
  return {
    year: o === null ? a : o * 100,
    restDateString: e.slice((r[1] || r[2]).length)
  };
}
function bm(e, t) {
  if (t === null)
    return new Date(NaN);
  var n = e.match(mm);
  if (!n)
    return new Date(NaN);
  var r = !!n[4], a = qt(n[1]), o = qt(n[2]) - 1, i = qt(n[3]), s = qt(n[4]), l = qt(n[5]) - 1;
  if (r)
    return Tm(t, s, l) ? Om(t, s, l) : new Date(NaN);
  var d = new Date(0);
  return !Pm(t, o, i) || !km(t, a) ? new Date(NaN) : (d.setUTCFullYear(t, o, Math.max(a, i)), d);
}
function qt(e) {
  return e ? parseInt(e) : 1;
}
function wm(e) {
  var t = e.match(pm);
  if (!t)
    return NaN;
  var n = zr(t[1]), r = zr(t[2]), a = zr(t[3]);
  return Sm(n, r, a) ? n * Oo + r * _o + a * 1e3 : NaN;
}
function zr(e) {
  return e && parseFloat(e.replace(",", ".")) || 0;
}
function _m(e) {
  if (e === "Z")
    return 0;
  var t = e.match(vm);
  if (!t)
    return 0;
  var n = t[1] === "+" ? -1 : 1, r = parseInt(t[2]), a = t[3] && parseInt(t[3]) || 0;
  return Dm(r, a) ? n * (r * Oo + a * _o) : NaN;
}
function Om(e, t, n) {
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = (t - 1) * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var $m = [31, null, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function Bu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function Pm(e, t, n) {
  return t >= 0 && t <= 11 && n >= 1 && n <= ($m[t] || (Bu(e) ? 29 : 28));
}
function km(e, t) {
  return t >= 1 && t <= (Bu(e) ? 366 : 365);
}
function Tm(e, t, n) {
  return t >= 1 && t <= 53 && n >= 0 && n <= 6;
}
function Sm(e, t, n) {
  return e === 24 ? t === 0 && n === 0 : n >= 0 && n < 60 && t >= 0 && t < 60 && e >= 0 && e < 25;
}
function Dm(e, t) {
  return t >= 0 && t <= 59;
}
function Kt(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t), a = n.getFullYear(), o = n.getDate(), i = new Date(0);
  i.setFullYear(a, r, 15), i.setHours(0, 0, 0, 0);
  var s = Bs(i);
  return n.setMonth(r, Math.min(o, s)), n;
}
function jn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? jn = function(n) {
    return typeof n;
  } : jn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, jn(e);
}
function qe(e, t) {
  if (Z(2, arguments), jn(t) !== "object" || t === null)
    throw new RangeError("values parameter must be an object");
  var n = le(e);
  return isNaN(n.getTime()) ? new Date(NaN) : (t.year != null && n.setFullYear(t.year), t.month != null && (n = Kt(n, t.month)), t.date != null && n.setDate(re(t.date)), t.hours != null && n.setHours(re(t.hours)), t.minutes != null && n.setMinutes(re(t.minutes)), t.seconds != null && n.setSeconds(re(t.seconds)), t.milliseconds != null && n.setMilliseconds(re(t.milliseconds)), n);
}
function Eu(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return n.setHours(r), n;
}
function Ro(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return n.setMilliseconds(r), n;
}
function Yu(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return n.setMinutes(r), n;
}
function Fu(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return n.setSeconds(r), n;
}
function St(e, t) {
  Z(2, arguments);
  var n = le(e), r = re(t);
  return isNaN(n.getTime()) ? new Date(NaN) : (n.setFullYear(r), n);
}
function Et(e, t) {
  Z(2, arguments);
  var n = re(t);
  return lt(e, -n);
}
function qn(e) {
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? qn = function(n) {
    return typeof n;
  } : qn = function(n) {
    return n && typeof Symbol == "function" && n.constructor === Symbol && n !== Symbol.prototype ? "symbol" : typeof n;
  }, qn(e);
}
function xm(e, t) {
  if (Z(2, arguments), !t || qn(t) !== "object")
    return new Date(NaN);
  var n = t.years ? re(t.years) : 0, r = t.months ? re(t.months) : 0, a = t.weeks ? re(t.weeks) : 0, o = t.days ? re(t.days) : 0, i = t.hours ? re(t.hours) : 0, s = t.minutes ? re(t.minutes) : 0, l = t.seconds ? re(t.seconds) : 0, d = Et(e, r + n * 12), g = dm(d, o + a * 7), y = s + i * 60, f = l + y * 60, h = f * 1e3, I = new Date(g.getTime() - h);
  return I;
}
function Rm(e, t) {
  Z(2, arguments);
  var n = re(t);
  return bu(e, -n);
}
const Ct = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, a] of t)
    n[r] = a;
  return n;
}, Mm = {}, Nm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Cm = /* @__PURE__ */ se("path", { d: "M29.333 8c0-2.208-1.792-4-4-4h-18.667c-2.208 0-4 1.792-4 4v18.667c0 2.208 1.792 4 4 4h18.667c2.208 0 4-1.792 4-4v-18.667zM26.667 8v18.667c0 0.736-0.597 1.333-1.333 1.333 0 0-18.667 0-18.667 0-0.736 0-1.333-0.597-1.333-1.333 0 0 0-18.667 0-18.667 0-0.736 0.597-1.333 1.333-1.333 0 0 18.667 0 18.667 0 0.736 0 1.333 0.597 1.333 1.333z" }, null, -1), Im = /* @__PURE__ */ se("path", { d: "M20 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Am = /* @__PURE__ */ se("path", { d: "M9.333 2.667v5.333c0 0.736 0.597 1.333 1.333 1.333s1.333-0.597 1.333-1.333v-5.333c0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), Bm = /* @__PURE__ */ se("path", { d: "M4 14.667h24c0.736 0 1.333-0.597 1.333-1.333s-0.597-1.333-1.333-1.333h-24c-0.736 0-1.333 0.597-1.333 1.333s0.597 1.333 1.333 1.333z" }, null, -1), Em = [
  Cm,
  Im,
  Am,
  Bm
];
function Ym(e, t) {
  return w(), E("svg", Nm, Em);
}
const Br = /* @__PURE__ */ Ct(Mm, [["render", Ym]]), Fm = {}, Vm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Um = /* @__PURE__ */ se("path", { d: "M23.057 7.057l-16 16c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l16-16c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0z" }, null, -1), Wm = /* @__PURE__ */ se("path", { d: "M7.057 8.943l16 16c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885l-16-16c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), Lm = [
  Um,
  Wm
];
function Hm(e, t) {
  return w(), E("svg", Vm, Lm);
}
const jm = /* @__PURE__ */ Ct(Fm, [["render", Hm]]), qm = {}, zm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Gm = /* @__PURE__ */ se("path", { d: "M20.943 23.057l-7.057-7.057c0 0 7.057-7.057 7.057-7.057 0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-8 8c-0.521 0.521-0.521 1.365 0 1.885l8 8c0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), Qm = [
  Gm
];
function Km(e, t) {
  return w(), E("svg", zm, Qm);
}
const Ki = /* @__PURE__ */ Ct(qm, [["render", Km]]), Zm = {}, Xm = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, Jm = /* @__PURE__ */ se("path", { d: "M12.943 24.943l8-8c0.521-0.521 0.521-1.365 0-1.885l-8-8c-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885l7.057 7.057c0 0-7.057 7.057-7.057 7.057-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0z" }, null, -1), ep = [
  Jm
];
function tp(e, t) {
  return w(), E("svg", Xm, ep);
}
const Zi = /* @__PURE__ */ Ct(Zm, [["render", tp]]), np = {}, rp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, ap = /* @__PURE__ */ se("path", { d: "M16 1.333c-8.095 0-14.667 6.572-14.667 14.667s6.572 14.667 14.667 14.667c8.095 0 14.667-6.572 14.667-14.667s-6.572-14.667-14.667-14.667zM16 4c6.623 0 12 5.377 12 12s-5.377 12-12 12c-6.623 0-12-5.377-12-12s5.377-12 12-12z" }, null, -1), op = /* @__PURE__ */ se("path", { d: "M14.667 8v8c0 0.505 0.285 0.967 0.737 1.193l5.333 2.667c0.658 0.329 1.46 0.062 1.789-0.596s0.062-1.46-0.596-1.789l-4.596-2.298c0 0 0-7.176 0-7.176 0-0.736-0.597-1.333-1.333-1.333s-1.333 0.597-1.333 1.333z" }, null, -1), ip = [
  ap,
  op
];
function up(e, t) {
  return w(), E("svg", rp, ip);
}
const Vu = /* @__PURE__ */ Ct(np, [["render", up]]), lp = {}, sp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, cp = /* @__PURE__ */ se("path", { d: "M24.943 19.057l-8-8c-0.521-0.521-1.365-0.521-1.885 0l-8 8c-0.52 0.52-0.52 1.365 0 1.885s1.365 0.52 1.885 0l7.057-7.057c0 0 7.057 7.057 7.057 7.057 0.52 0.52 1.365 0.52 1.885 0s0.52-1.365 0-1.885z" }, null, -1), fp = [
  cp
];
function dp(e, t) {
  return w(), E("svg", sp, fp);
}
const Uu = /* @__PURE__ */ Ct(lp, [["render", dp]]), yp = {}, mp = {
  version: "1.1",
  xmlns: "http://www.w3.org/2000/svg",
  width: "32",
  height: "32",
  viewBox: "0 0 32 32",
  class: "dp__icon"
}, pp = /* @__PURE__ */ se("path", { d: "M7.057 12.943l8 8c0.521 0.521 1.365 0.521 1.885 0l8-8c0.52-0.52 0.52-1.365 0-1.885s-1.365-0.52-1.885 0l-7.057 7.057c0 0-7.057-7.057-7.057-7.057-0.52-0.52-1.365-0.52-1.885 0s-0.52 1.365 0 1.885z" }, null, -1), vp = [
  pp
];
function hp(e, t) {
  return w(), E("svg", mp, vp);
}
const Wu = /* @__PURE__ */ Ct(yp, [["render", hp]]), Xi = (e, t) => {
  const n = po(e, t.slice(0, e.length), new Date());
  return Gt(n) && wu(n) ? n : null;
}, gp = (e, t) => {
  if (typeof t == "string")
    return Xi(e, t);
  if (Array.isArray(t)) {
    let n = null;
    for (const r of t)
      if (n = Xi(e, r), n)
        break;
    return n;
  }
  return typeof t == "function" ? t(e) : null;
}, M = (e) => e ? new Date(e) : new Date(), bp = (e, t) => {
  if (t) {
    const r = (e.getMonth() + 1).toString().padStart(2, "0"), a = e.getDate().toString().padStart(2, "0"), o = e.getHours().toString().padStart(2, "0"), i = e.getMinutes().toString().padStart(2, "0");
    return `${e.getFullYear()}-${r}-${a}T${o}:${i}:00.000Z`;
  }
  const n = Date.UTC(
    e.getUTCFullYear(),
    e.getUTCMonth(),
    e.getUTCDate(),
    e.getUTCHours(),
    e.getUTCMinutes(),
    e.getUTCSeconds()
  );
  return new Date(n).toISOString();
}, st = (e) => {
  let t = M(JSON.parse(JSON.stringify(e)));
  return t = Eu(t, 0), t = Yu(t, 0), t = Fu(t, 0), t = Ro(t, 0), t;
}, tt = (e, t, n, r) => {
  let a = e ? M(e) : M();
  return (t || t === 0) && (a = Eu(a, +t)), (n || n === 0) && (a = Yu(a, +n)), (r || r === 0) && (a = Fu(a, +r)), Ro(a, 0);
}, Le = (e, t) => !e || !t ? !1 : ko(st(e), st(t)), Se = (e, t) => !e || !t ? !1 : xu(st(e), st(t)), Ge = (e, t) => !e || !t ? !1 : Po(st(e), st(t)), Lu = (e, t, n) => e && e[0] && e[1] ? Ge(n, e[0]) && Le(n, e[1]) : e && e[0] && t ? Ge(n, e[0]) && Le(n, t) || Le(n, e[0]) && Ge(n, t) : !1, zt = Xt({
  menuFocused: !1,
  shiftKeyInMenu: !1
}), Hu = () => {
  const e = (n) => {
    zt.menuFocused = n;
  }, t = (n) => {
    zt.shiftKeyInMenu !== n && (zt.shiftKeyInMenu = n);
  };
  return {
    control: F(() => ({ shiftKeyInMenu: zt.shiftKeyInMenu, menuFocused: zt.menuFocused })),
    setMenuFocused: e,
    setShiftKey: t
  };
};
function Mo(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var Mr = {}, wp = {
  get exports() {
    return Mr;
  },
  set exports(e) {
    Mr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    if (r === null || r === !0 || r === !1)
      return NaN;
    var a = Number(r);
    return isNaN(a) ? a : a < 0 ? Math.ceil(a) : Math.floor(a);
  }
  e.exports = t.default;
})(wp, Mr);
const _p = /* @__PURE__ */ Mo(Mr);
var Nr = {}, Op = {
  get exports() {
    return Nr;
  },
  set exports(e) {
    Nr = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r) {
    var a = new Date(Date.UTC(r.getFullYear(), r.getMonth(), r.getDate(), r.getHours(), r.getMinutes(), r.getSeconds(), r.getMilliseconds()));
    return a.setUTCFullYear(r.getFullYear()), r.getTime() - a.getTime();
  }
  e.exports = t.default;
})(Op, Nr);
const Ji = /* @__PURE__ */ Mo(Nr);
function $p(e, t) {
  var n = Sp(t);
  return n.formatToParts ? kp(n, e) : Tp(n, e);
}
var Pp = {
  year: 0,
  month: 1,
  day: 2,
  hour: 3,
  minute: 4,
  second: 5
};
function kp(e, t) {
  try {
    for (var n = e.formatToParts(t), r = [], a = 0; a < n.length; a++) {
      var o = Pp[n[a].type];
      o >= 0 && (r[o] = parseInt(n[a].value, 10));
    }
    return r;
  } catch (i) {
    if (i instanceof RangeError)
      return [NaN];
    throw i;
  }
}
function Tp(e, t) {
  var n = e.format(t).replace(/\u200E/g, ""), r = /(\d+)\/(\d+)\/(\d+),? (\d+):(\d+):(\d+)/.exec(n);
  return [r[3], r[1], r[2], r[4], r[5], r[6]];
}
var Gr = {};
function Sp(e) {
  if (!Gr[e]) {
    var t = new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: "America/New_York",
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }).format(new Date("2014-06-25T04:00:00.123Z")), n = t === "06/25/2014, 00:00:00" || t === "‎06‎/‎25‎/‎2014‎ ‎00‎:‎00‎:‎00";
    Gr[e] = n ? new Intl.DateTimeFormat("en-US", {
      hour12: !1,
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    }) : new Intl.DateTimeFormat("en-US", {
      hourCycle: "h23",
      timeZone: e,
      year: "numeric",
      month: "numeric",
      day: "2-digit",
      hour: "2-digit",
      minute: "2-digit",
      second: "2-digit"
    });
  }
  return Gr[e];
}
function No(e, t, n, r, a, o, i) {
  var s = new Date(0);
  return s.setUTCFullYear(e, t, n), s.setUTCHours(r, a, o, i), s;
}
var eu = 36e5, Dp = 6e4, Qr = {
  timezone: /([Z+-].*)$/,
  timezoneZ: /^(Z)$/,
  timezoneHH: /^([+-]\d{2})$/,
  timezoneHHMM: /^([+-]\d{2}):?(\d{2})$/
};
function Co(e, t, n) {
  var r, a;
  if (!e || (r = Qr.timezoneZ.exec(e), r))
    return 0;
  var o;
  if (r = Qr.timezoneHH.exec(e), r)
    return o = parseInt(r[1], 10), tu(o) ? -(o * eu) : NaN;
  if (r = Qr.timezoneHHMM.exec(e), r) {
    o = parseInt(r[1], 10);
    var i = parseInt(r[2], 10);
    return tu(o, i) ? (a = Math.abs(o) * eu + i * Dp, o > 0 ? -a : a) : NaN;
  }
  if (Mp(e)) {
    t = new Date(t || Date.now());
    var s = n ? t : xp(t), l = vo(s, e), d = n ? l : Rp(t, l, e);
    return -d;
  }
  return NaN;
}
function xp(e) {
  return No(
    e.getFullYear(),
    e.getMonth(),
    e.getDate(),
    e.getHours(),
    e.getMinutes(),
    e.getSeconds(),
    e.getMilliseconds()
  );
}
function vo(e, t) {
  var n = $p(e, t), r = No(
    n[0],
    n[1] - 1,
    n[2],
    n[3] % 24,
    n[4],
    n[5],
    0
  ).getTime(), a = e.getTime(), o = a % 1e3;
  return a -= o >= 0 ? o : 1e3 + o, r - a;
}
function Rp(e, t, n) {
  var r = e.getTime(), a = r - t, o = vo(new Date(a), n);
  if (t === o)
    return t;
  a -= o - t;
  var i = vo(new Date(a), n);
  return o === i ? o : Math.max(o, i);
}
function tu(e, t) {
  return -23 <= e && e <= 23 && (t == null || 0 <= t && t <= 59);
}
var nu = {};
function Mp(e) {
  if (nu[e])
    return !0;
  try {
    return new Intl.DateTimeFormat(void 0, { timeZone: e }), nu[e] = !0, !0;
  } catch {
    return !1;
  }
}
var Np = /(Z|[+-]\d{2}(?::?\d{2})?| UTC| [a-zA-Z]+\/[a-zA-Z_]+(?:\/[a-zA-Z_]+)?)$/;
const ju = Np;
var Kr = 36e5, ru = 6e4, Cp = 2, ze = {
  dateTimePattern: /^([0-9W+-]+)(T| )(.*)/,
  datePattern: /^([0-9W+-]+)(.*)/,
  plainTime: /:/,
  // year tokens
  YY: /^(\d{2})$/,
  YYY: [
    /^([+-]\d{2})$/,
    // 0 additional digits
    /^([+-]\d{3})$/,
    // 1 additional digit
    /^([+-]\d{4})$/
    // 2 additional digits
  ],
  YYYY: /^(\d{4})/,
  YYYYY: [
    /^([+-]\d{4})/,
    // 0 additional digits
    /^([+-]\d{5})/,
    // 1 additional digit
    /^([+-]\d{6})/
    // 2 additional digits
  ],
  // date tokens
  MM: /^-(\d{2})$/,
  DDD: /^-?(\d{3})$/,
  MMDD: /^-?(\d{2})-?(\d{2})$/,
  Www: /^-?W(\d{2})$/,
  WwwD: /^-?W(\d{2})-?(\d{1})$/,
  HH: /^(\d{2}([.,]\d*)?)$/,
  HHMM: /^(\d{2}):?(\d{2}([.,]\d*)?)$/,
  HHMMSS: /^(\d{2}):?(\d{2}):?(\d{2}([.,]\d*)?)$/,
  // time zone tokens (to identify the presence of a tz)
  timeZone: ju
};
function ho(e, t) {
  if (arguments.length < 1)
    throw new TypeError("1 argument required, but only " + arguments.length + " present");
  if (e === null)
    return new Date(NaN);
  var n = t || {}, r = n.additionalDigits == null ? Cp : _p(n.additionalDigits);
  if (r !== 2 && r !== 1 && r !== 0)
    throw new RangeError("additionalDigits must be 0, 1 or 2");
  if (e instanceof Date || typeof e == "object" && Object.prototype.toString.call(e) === "[object Date]")
    return new Date(e.getTime());
  if (typeof e == "number" || Object.prototype.toString.call(e) === "[object Number]")
    return new Date(e);
  if (!(typeof e == "string" || Object.prototype.toString.call(e) === "[object String]"))
    return new Date(NaN);
  var a = Ip(e), o = Ap(a.date, r), i = o.year, s = o.restDateString, l = Bp(s, i);
  if (isNaN(l))
    return new Date(NaN);
  if (l) {
    var d = l.getTime(), g = 0, y;
    if (a.time && (g = Ep(a.time), isNaN(g)))
      return new Date(NaN);
    if (a.timeZone || n.timeZone) {
      if (y = Co(a.timeZone || n.timeZone, new Date(d + g)), isNaN(y))
        return new Date(NaN);
    } else
      y = Ji(new Date(d + g)), y = Ji(new Date(d + g + y));
    return new Date(d + g + y);
  } else
    return new Date(NaN);
}
function Ip(e) {
  var t = {}, n = ze.dateTimePattern.exec(e), r;
  if (n ? (t.date = n[1], r = n[3]) : (n = ze.datePattern.exec(e), n ? (t.date = n[1], r = n[2]) : (t.date = null, r = e)), r) {
    var a = ze.timeZone.exec(r);
    a ? (t.time = r.replace(a[1], ""), t.timeZone = a[1].trim()) : t.time = r;
  }
  return t;
}
function Ap(e, t) {
  var n = ze.YYY[t], r = ze.YYYYY[t], a;
  if (a = ze.YYYY.exec(e) || r.exec(e), a) {
    var o = a[1];
    return {
      year: parseInt(o, 10),
      restDateString: e.slice(o.length)
    };
  }
  if (a = ze.YY.exec(e) || n.exec(e), a) {
    var i = a[1];
    return {
      year: parseInt(i, 10) * 100,
      restDateString: e.slice(i.length)
    };
  }
  return {
    year: null
  };
}
function Bp(e, t) {
  if (t === null)
    return null;
  var n, r, a, o;
  if (e.length === 0)
    return r = new Date(0), r.setUTCFullYear(t), r;
  if (n = ze.MM.exec(e), n)
    return r = new Date(0), a = parseInt(n[1], 10) - 1, ou(t, a) ? (r.setUTCFullYear(t, a), r) : new Date(NaN);
  if (n = ze.DDD.exec(e), n) {
    r = new Date(0);
    var i = parseInt(n[1], 10);
    return Vp(t, i) ? (r.setUTCFullYear(t, 0, i), r) : new Date(NaN);
  }
  if (n = ze.MMDD.exec(e), n) {
    r = new Date(0), a = parseInt(n[1], 10) - 1;
    var s = parseInt(n[2], 10);
    return ou(t, a, s) ? (r.setUTCFullYear(t, a, s), r) : new Date(NaN);
  }
  if (n = ze.Www.exec(e), n)
    return o = parseInt(n[1], 10) - 1, iu(t, o) ? au(t, o) : new Date(NaN);
  if (n = ze.WwwD.exec(e), n) {
    o = parseInt(n[1], 10) - 1;
    var l = parseInt(n[2], 10) - 1;
    return iu(t, o, l) ? au(t, o, l) : new Date(NaN);
  }
  return null;
}
function Ep(e) {
  var t, n, r;
  if (t = ze.HH.exec(e), t)
    return n = parseFloat(t[1].replace(",", ".")), Zr(n) ? n % 24 * Kr : NaN;
  if (t = ze.HHMM.exec(e), t)
    return n = parseInt(t[1], 10), r = parseFloat(t[2].replace(",", ".")), Zr(n, r) ? n % 24 * Kr + r * ru : NaN;
  if (t = ze.HHMMSS.exec(e), t) {
    n = parseInt(t[1], 10), r = parseInt(t[2], 10);
    var a = parseFloat(t[3].replace(",", "."));
    return Zr(n, r, a) ? n % 24 * Kr + r * ru + a * 1e3 : NaN;
  }
  return null;
}
function au(e, t, n) {
  t = t || 0, n = n || 0;
  var r = new Date(0);
  r.setUTCFullYear(e, 0, 4);
  var a = r.getUTCDay() || 7, o = t * 7 + n + 1 - a;
  return r.setUTCDate(r.getUTCDate() + o), r;
}
var Yp = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], Fp = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function qu(e) {
  return e % 400 === 0 || e % 4 === 0 && e % 100 !== 0;
}
function ou(e, t, n) {
  if (t < 0 || t > 11)
    return !1;
  if (n != null) {
    if (n < 1)
      return !1;
    var r = qu(e);
    if (r && n > Fp[t] || !r && n > Yp[t])
      return !1;
  }
  return !0;
}
function Vp(e, t) {
  if (t < 1)
    return !1;
  var n = qu(e);
  return !(n && t > 366 || !n && t > 365);
}
function iu(e, t, n) {
  return !(t < 0 || t > 52 || n != null && (n < 0 || n > 6));
}
function Zr(e, t, n) {
  return !(e != null && (e < 0 || e >= 25) || t != null && (t < 0 || t >= 60) || n != null && (n < 0 || n >= 60));
}
var Cr = {}, Up = {
  get exports() {
    return Cr;
  },
  set exports(e) {
    Cr = e;
  }
}, Ir = {}, Wp = {
  get exports() {
    return Ir;
  },
  set exports(e) {
    Ir = e;
  }
};
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = n;
  function n(r, a) {
    if (r == null)
      throw new TypeError("assign requires that input parameter not be null or undefined");
    for (var o in a)
      Object.prototype.hasOwnProperty.call(a, o) && (r[o] = a[o]);
    return r;
  }
  e.exports = t.default;
})(Wp, Ir);
(function(e, t) {
  Object.defineProperty(t, "__esModule", {
    value: !0
  }), t.default = a;
  var n = r(Ir);
  function r(o) {
    return o && o.__esModule ? o : { default: o };
  }
  function a(o) {
    return (0, n.default)({}, o);
  }
  e.exports = t.default;
})(Up, Cr);
const Lp = /* @__PURE__ */ Mo(Cr);
function Hp(e, t, n) {
  var r = ho(e, n), a = Co(t, r, !0), o = new Date(r.getTime() - a), i = new Date(0);
  return i.setFullYear(o.getUTCFullYear(), o.getUTCMonth(), o.getUTCDate()), i.setHours(o.getUTCHours(), o.getUTCMinutes(), o.getUTCSeconds(), o.getUTCMilliseconds()), i;
}
function jp(e, t, n) {
  if (typeof e == "string" && !e.match(ju)) {
    var r = Lp(n);
    return r.timeZone = t, ho(e, r);
  }
  var a = ho(e, n), o = No(
    a.getFullYear(),
    a.getMonth(),
    a.getDate(),
    a.getHours(),
    a.getMinutes(),
    a.getSeconds(),
    a.getMilliseconds()
  ).getTime(), i = Co(t, new Date(o));
  return new Date(o + i);
}
const qp = (e, t = 3) => {
  const n = [];
  for (let r = 0; r < e.length; r += t)
    n.push([e[r], e[r + 1], e[r + 2]]);
  return n;
}, zp = (e, t) => {
  const n = [1, 2, 3, 4, 5, 6, 7].map((o) => new Intl.DateTimeFormat(e, { weekday: "short", timeZone: "UTC" }).format(new Date(`2017-01-0${o}T00:00:00+00:00`)).slice(0, 2)), r = n.slice(0, t), a = n.slice(t + 1, n.length);
  return [n[t]].concat(...a).concat(...r);
}, Gp = (e) => {
  const t = [];
  for (let n = +e[0]; n <= +e[1]; n++)
    t.push({ value: +n, text: `${n}` });
  return t;
}, Qp = (e, t) => {
  const n = new Intl.DateTimeFormat(e, { month: t, timeZone: "UTC" });
  return [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((r) => {
    const a = r < 10 ? `0${r}` : r;
    return new Date(`2017-${a}-01T00:00:00+00:00`);
  }).map((r, a) => ({
    text: n.format(r),
    value: a
  }));
}, Kp = (e) => [12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11][e], Be = (e) => {
  const t = c(e);
  return t != null && t.$el ? t == null ? void 0 : t.$el : t;
}, Zp = (e) => Object.assign({ type: "dot" }, e), zu = (e) => Array.isArray(e) ? !!e[0] && !!e[1] : !1, Ar = {
  prop: (e) => `"${e}" prop must be enabled!`,
  dateArr: (e) => `You need to use array as "model-value" binding in order to support "${e}"`
}, Ue = (e) => e, uu = (e) => e === 0 ? e : !e || isNaN(+e) ? null : +e, lu = (e) => Object.assign(
  {
    menuAppear: "dp-menu-appear",
    open: "dp-slide-down",
    close: "dp-slide-up",
    next: "calendar-next",
    previous: "calendar-prev",
    vNext: "dp-slide-up",
    vPrevious: "dp-slide-down"
  },
  e
), Xp = (e) => Object.assign(
  {
    toggleOverlay: "Toggle overlay",
    menu: "Datepicker menu",
    input: "Datepicker input",
    calendarWrap: "Calendar wrapper",
    calendarDays: "Calendar days",
    openTimePicker: "Open time picker",
    closeTimePicker: "Close time Picker",
    incrementValue: (t) => `Increment ${t}`,
    decrementValue: (t) => `Decrement ${t}`,
    openTpOverlay: (t) => `Open ${t} overlay`,
    amPmButton: "Switch AM/PM mode",
    openYearsOverlay: "Open years overlay",
    openMonthsOverlay: "Open months overlay",
    nextMonth: "Next month",
    prevMonth: "Previous month",
    day: () => ""
  },
  e
), Jp = (e) => e === null ? 0 : typeof e == "boolean" ? e ? 2 : 0 : +e >= 2 ? +e : 2, ev = (e, t, n) => e || (typeof n == "string" ? n : t), tv = (e) => typeof e == "boolean" ? e ? lu({}) : !1 : lu(e), nv = () => ({
  enterSubmit: !0,
  tabSubmit: !0,
  openMenu: !0,
  rangeSeparator: " - "
}), rv = (e) => Object.assign({ months: [], years: [], times: { hours: [], minutes: [], seconds: [] } }, e), et = (e) => {
  const t = () => {
    if (e.partialRange)
      return null;
    throw new Error(Ar.prop("partial-range"));
  }, n = F(() => ({
    ariaLabels: Xp(e.ariaLabels),
    textInputOptions: Object.assign(nv(), e.textInputOptions),
    multiCalendars: Jp(e.multiCalendars),
    previewFormat: ev(e.previewFormat, e.format, o()),
    filters: rv(e.filters),
    transitions: tv(e.transitions),
    startTime: f()
  })), r = (u) => {
    if (e.range)
      return u();
    throw new Error(Ar.prop("range"));
  }, a = () => {
    const u = e.enableSeconds ? ":ss" : "";
    return e.is24 ? `HH:mm${u}` : `hh:mm${u} aa`;
  }, o = () => e.format ? e.format : e.monthPicker ? "MM/yyyy" : e.timePicker ? a() : e.weekPicker ? "MM/dd/yyyy" : e.yearPicker ? "yyyy" : e.enableTimePicker ? `MM/dd/yyyy, ${a()}` : "MM/dd/yyyy", i = (u, v) => {
    if (typeof e.format == "function")
      return e.format(u);
    const $ = v || o(), _ = e.formatLocale ? { locale: e.formatLocale } : void 0;
    return Array.isArray(u) ? `${Qt(u[0], $, _)} ${e.modelAuto && !u[1] ? "" : n.value.textInputOptions.rangeSeparator || "-"} ${u[1] ? Qt(u[1], $, _) : ""}` : Qt(u, $, _);
  }, s = (u) => e.timezone ? Hp(u, e.timezone) : u, l = (u) => e.timezone ? jp(u, e.timezone) : u, d = F(() => (u) => {
    var v;
    return (v = e.hideNavigation) == null ? void 0 : v.includes(u);
  }), g = (u) => {
    const v = e.maxDate ? Ge(s(u), s(M(e.maxDate))) : !1, $ = e.minDate ? Le(s(u), s(M(e.minDate))) : !1, _ = X(u, e.disabledDates), N = n.value.filters.months.map((k) => +k).includes(Pe(u)), G = e.disabledWeekDays.length ? e.disabledWeekDays.some((k) => +k === As(u)) : !1, ne = e.allowedDates.length ? !e.allowedDates.some((k) => Se(s(M(k)), s(u))) : !1, b = ke(u), p = b < +e.yearRange[0] || b > +e.yearRange[1];
    return !(v || $ || _ || N || p || G || ne);
  }, y = (u) => {
    const v = {
      hours: ft(M()),
      minutes: dt(M()),
      seconds: Vt(M())
    };
    return Object.assign(v, u);
  }, f = () => e.range ? e.startTime && Array.isArray(e.startTime) ? [y(e.startTime[0]), y(e.startTime[1])] : null : e.startTime && !Array.isArray(e.startTime) ? y(e.startTime) : null, h = (u) => !g(u), I = (u) => Array.isArray(u) ? Gt(u[0]) && (u[1] ? Gt(u[1]) : !0) : u ? Gt(u) : !1, Y = (u) => u instanceof Date ? u : ym(u), H = (u) => {
    const v = xt(s(u), { weekStartsOn: +e.weekStart }), $ = Rl(s(u), { weekStartsOn: +e.weekStart });
    return [v, $];
  }, X = (u, v) => Array.isArray(v) ? v.some(($) => Se(s(M($)), s(u))) : v(u), z = (u, v, $) => {
    let _ = u ? M(u) : M();
    return (v || v === 0) && (_ = Kt(_, v)), $ && (_ = St(_, $)), _;
  }, B = (u) => qe(M(), { hours: ft(u), minutes: dt(u), seconds: Vt(u) }), j = (u) => qe(M(), {
    hours: +u.hours || 0,
    minutes: +u.minutes || 0,
    seconds: +u.seconds || 0
  }), ae = (u, v, $, _) => {
    if (!u)
      return !0;
    if (_) {
      const N = $ === "max" ? ko(u, v) : Po(u, v), G = { seconds: 0, milliseconds: 0 };
      return N || xu(qe(u, G), qe(v, G));
    }
    return $ === "max" ? u.getTime() <= v.getTime() : u.getTime() >= v.getTime();
  }, J = () => !e.enableTimePicker || e.monthPicker || e.yearPicker || e.ignoreTimeValidation, D = (u) => Array.isArray(u) ? [u[0] ? B(u[0]) : null, u[1] ? B(u[1]) : null] : B(u), O = (u) => {
    const v = e.maxTime ? j(e.maxTime) : M(e.maxDate);
    return Array.isArray(u) ? ae(u[0], v, "max", !!e.maxDate) && ae(u[1], v, "max", !!e.maxDate) : ae(u, v, "max", !!e.maxDate);
  }, A = (u, v) => {
    const $ = e.minTime ? j(e.minTime) : M(e.minDate);
    return Array.isArray(u) ? ae(u[0], $, "min", !!e.minDate) && ae(u[1], $, "min", !!e.minDate) && v : ae(u, $, "min", !!e.minDate) && v;
  }, V = (u) => {
    let v = !0;
    if (!u || J())
      return !0;
    const $ = !e.minDate && !e.maxDate ? D(u) : u;
    return (e.maxTime || e.maxDate) && (v = O(Ue($))), (e.minTime || e.minDate) && (v = A(Ue($), v)), v;
  }, C = (u, v) => {
    const $ = M(JSON.parse(JSON.stringify(u))), _ = [];
    for (let N = 0; N < 7; N++) {
      const G = vt($, N), ne = Pe(G) !== v;
      _.push({
        text: e.hideOffsetDates && ne ? "" : G.getDate(),
        value: G,
        current: !ne,
        classData: {}
      });
    }
    return _;
  }, U = (u, v) => {
    const $ = [], _ = M(s(new Date(v, u))), N = M(s(new Date(v, u + 1, 0))), G = xt(_, { weekStartsOn: e.weekStart }), ne = (b) => {
      const p = C(b, u);
      if ($.push({ days: p }), !$[$.length - 1].days.some(
        (k) => Se(st(k.value), st(N))
      )) {
        const k = vt(b, 7);
        ne(k);
      }
    };
    if (ne(G), e.sixWeeks && $.length < 6) {
      const b = 6 - $.length;
      for (let p = 1; p <= b; p++) {
        const k = $[$.length - 1], we = k.days[k.days.length - 1], ve = C(vt(we.value, 1), Pe(_));
        $.push({ days: ve });
      }
    }
    return $;
  }, K = (u, v, $) => [qe(M(u), { date: 1 }), qe(M(), { month: v, year: $, date: 1 })], oe = (u, v) => Le(...K(e.minDate, u, v)) || Se(...K(e.minDate, u, v)), P = (u, v) => Ge(...K(e.maxDate, u, v)) || Se(...K(e.maxDate, u, v)), S = (u, v, $) => {
    let _ = !1;
    return e.maxDate && $ && P(u, v) && (_ = !0), e.minDate && !$ && oe(u, v) && (_ = !0), _;
  };
  return {
    checkPartialRangeValue: t,
    checkRangeEnabled: r,
    getZonedDate: s,
    getZonedToUtc: l,
    formatDate: i,
    getDefaultPattern: o,
    validateDate: g,
    getDefaultStartTime: f,
    isDisabled: h,
    isValidDate: I,
    sanitizeDate: Y,
    getWeekFromDate: H,
    matchDate: X,
    setDateMonthOrYear: z,
    isValidTime: V,
    getCalendarDays: U,
    validateMonthYearInRange: (u, v, $, _) => {
      let N = !1;
      return _ ? e.minDate && e.maxDate ? N = S(u, v, $) : (e.minDate && oe(u, v) || e.maxDate && P(u, v)) && (N = !0) : N = !0, N;
    },
    validateMaxDate: P,
    validateMinDate: oe,
    defaults: n,
    hideNavigationButtons: d
  };
}, $e = Xt({
  monthYear: [],
  calendar: [],
  time: [],
  actionRow: [],
  selectionGrid: [],
  timePicker: {
    0: [],
    1: []
  },
  monthPicker: []
}), Xr = L(null), rn = L(!1), Jr = L(!1), ea = L(!1), ta = L(!1), je = L(0), Ye = L(0), bt = () => {
  const e = F(() => rn.value ? [...$e.selectionGrid, $e.actionRow].filter((y) => y.length) : Jr.value ? [
    ...$e.timePicker[0],
    ...$e.timePicker[1],
    ta.value ? [] : [Xr.value],
    $e.actionRow
  ].filter((y) => y.length) : ea.value ? [...$e.monthPicker, $e.actionRow] : [$e.monthYear, ...$e.calendar, $e.time, $e.actionRow].filter((y) => y.length)), t = (y) => {
    je.value = y ? je.value + 1 : je.value - 1;
    let f = null;
    e.value[Ye.value] && (f = e.value[Ye.value][je.value]), f || (je.value = y ? je.value - 1 : je.value + 1);
  }, n = (y) => {
    Ye.value === 0 && !y || Ye.value === e.value.length && y || (Ye.value = y ? Ye.value + 1 : Ye.value - 1, e.value[Ye.value] ? e.value[Ye.value] && !e.value[Ye.value][je.value] && je.value !== 0 && (je.value = e.value[Ye.value].length - 1) : Ye.value = y ? Ye.value - 1 : Ye.value + 1);
  }, r = (y) => {
    let f = null;
    e.value[Ye.value] && (f = e.value[Ye.value][je.value]), f ? f.focus({ preventScroll: !rn.value }) : je.value = y ? je.value - 1 : je.value + 1;
  }, a = () => {
    t(!0), r(!0);
  }, o = () => {
    t(!1), r(!1);
  }, i = () => {
    n(!1), r(!0);
  }, s = () => {
    n(!0), r(!0);
  }, l = (y, f) => {
    $e[f] = y;
  }, d = (y, f) => {
    $e[f] = y;
  }, g = () => {
    je.value = 0, Ye.value = 0;
  };
  return {
    buildMatrix: l,
    buildMultiLevelMatrix: d,
    setTimePickerBackRef: (y) => {
      Xr.value = y;
    },
    setSelectionGrid: (y) => {
      rn.value = y, g(), y || ($e.selectionGrid = []);
    },
    setTimePicker: (y, f = !1) => {
      Jr.value = y, ta.value = f, g(), y || ($e.timePicker[0] = [], $e.timePicker[1] = []);
    },
    setTimePickerElements: (y, f = 0) => {
      $e.timePicker[f] = y;
    },
    arrowRight: a,
    arrowLeft: o,
    arrowUp: i,
    arrowDown: s,
    clearArrowNav: () => {
      $e.monthYear = [], $e.calendar = [], $e.time = [], $e.actionRow = [], $e.selectionGrid = [], $e.timePicker[0] = [], $e.timePicker[1] = [], rn.value = !1, Jr.value = !1, ta.value = !1, ea.value = !1, g(), Xr.value = null;
    },
    setMonthPicker: (y) => {
      ea.value = y, g();
    },
    refSets: $e
    // exposed for testing
  };
}, su = (e) => Array.isArray(e), $t = (e) => Array.isArray(e), cu = (e) => Array.isArray(e) && e.length === 2, av = (e, t, n, r, a) => {
  const {
    getDefaultStartTime: o,
    isDisabled: i,
    sanitizeDate: s,
    getWeekFromDate: l,
    setDateMonthOrYear: d,
    validateMonthYearInRange: g,
    defaults: y
  } = et(e), f = F({
    get: () => e.internalModelValue,
    set: (m) => {
      !e.readonly && !e.disabled && t("update:internal-model-value", m);
    }
  }), h = L([]);
  Dt(f, () => {
    e.multiCalendars || ae();
  });
  const I = L([{ month: Pe(M()), year: ke(M()) }]), Y = Xt({
    hours: e.range ? [ft(M()), ft(M())] : ft(M()),
    minutes: e.range ? [dt(M()), dt(M())] : dt(M()),
    seconds: e.range ? [0, 0] : 0
  }), H = F(
    () => (m) => I.value[m] ? I.value[m].month : 0
  ), X = F(
    () => (m) => I.value[m] ? I.value[m].year : 0
  ), z = F(() => e.flow && e.flow.length ? a.value === e.flow.length : !0), B = (m, R, te) => {
    var ie, Oe;
    I.value[m] || (I.value[m] = { month: 0, year: 0 }), I.value[m].month = R === null ? (ie = I.value[m]) == null ? void 0 : ie.month : R, I.value[m].year = te === null ? (Oe = I.value[m]) == null ? void 0 : Oe.year : te;
  }, j = (m, R) => {
    Y[m] = R;
  };
  at(() => {
    f.value || (e.startDate && (B(0, Pe(M(e.startDate)), ke(M(e.startDate))), y.value.multiCalendars && _t(0)), y.value.startTime && P()), ae(!0);
  });
  const ae = (m = !1) => {
    if (f.value)
      return Array.isArray(f.value) ? (h.value = f.value, V(m)) : D(f.value);
    if (e.timePicker)
      return C();
    if (e.monthPicker && !e.range)
      return U();
    if (e.yearPicker && !e.range)
      return K();
    if (y.value.multiCalendars && m && !e.startDate)
      return J(M(), m);
  }, J = (m, R = !1) => {
    if ((!y.value.multiCalendars || !e.multiStatic || R) && B(0, Pe(m), ke(m)), y.value.multiCalendars)
      for (let te = 1; te < y.value.multiCalendars; te++) {
        const ie = qe(M(), { month: H.value(te - 1), year: X.value(te - 1) }), Oe = gu(ie, { months: 1 });
        I.value[te] = { month: Pe(Oe), year: ke(Oe) };
      }
  }, D = (m) => {
    J(m), j("hours", ft(m)), j("minutes", dt(m)), j("seconds", Vt(m));
  }, O = (m, R) => {
    J(m[0], R);
    const te = (ie, Oe) => [
      ie(m[0]),
      m[1] ? ie(m[1]) : Y[Oe][1]
    ];
    j("hours", te(ft, "hours")), j("minutes", te(dt, "minutes")), j("seconds", te(Vt, "seconds"));
  }, A = (m, R) => {
    if ((e.range || e.weekPicker) && !e.multiDates)
      return O(m, R);
    if (e.multiDates) {
      const te = m[m.length - 1];
      return D(te);
    }
  }, V = (m) => {
    const R = f.value;
    A(R, m), y.value.multiCalendars && e.multiCalendarsSolo && u();
  }, C = () => {
    if (P(), !e.range)
      f.value = tt(M(), Y.hours, Y.minutes, oe());
    else {
      const m = Y.hours, R = Y.minutes;
      f.value = [
        tt(M(), m[0], R[0], oe()),
        tt(M(), m[1], R[1], oe(!1))
      ];
    }
  }, U = () => {
    f.value = d(M(), H.value(0), X.value(0));
  }, K = () => {
    f.value = M();
  }, oe = (m = !0) => e.enableSeconds ? Array.isArray(Y.seconds) ? m ? Y.seconds[0] : Y.seconds[1] : Y.seconds : 0, P = () => {
    const m = o();
    if (m) {
      const R = Array.isArray(m), te = R ? [+m[0].hours, +m[1].hours] : +m.hours, ie = R ? [+m[0].minutes, +m[1].minutes] : +m.minutes, Oe = R ? [+m[0].seconds, +m[1].seconds] : +m.seconds;
      j("hours", te), j("minutes", ie), e.enableSeconds && j("seconds", Oe);
    }
  }, S = () => Array.isArray(f.value) && f.value.length ? f.value[f.value.length - 1] : null, u = () => {
    if (Array.isArray(f.value) && f.value.length === 2) {
      const m = M(
        M(f.value[1] ? f.value[1] : lt(f.value[0], 1))
      ), [R, te] = [Pe(f.value[0]), ke(f.value[0])], [ie, Oe] = [Pe(f.value[1]), ke(f.value[1])];
      (R !== ie || R === ie && te !== Oe) && e.multiCalendarsSolo && B(1, Pe(m), ke(m));
    }
  }, v = (m) => {
    const R = lt(m, 1);
    return { month: Pe(R), year: ke(R) };
  }, $ = (m) => {
    const R = Pe(M(m)), te = ke(M(m));
    if (B(0, R, te), y.value.multiCalendars > 0)
      for (let ie = 1; ie < y.value.multiCalendars; ie++) {
        const Oe = v(
          qe(M(m), { year: H.value(ie - 1), month: X.value(ie - 1) })
        );
        B(ie, Oe.month, Oe.year);
      }
  }, _ = (m) => {
    if (f.value && Array.isArray(f.value))
      if (f.value.some((R) => Se(m, R))) {
        const R = f.value.filter((te) => !Se(te, m));
        f.value = R.length ? R : null;
      } else
        (e.multiDatesLimit && +e.multiDatesLimit > f.value.length || !e.multiDatesLimit) && f.value.push(m);
    else
      f.value = [m];
  }, N = (m, R) => {
    const te = Ge(m, R) ? R : m, ie = Ge(R, m) ? R : m;
    return Bo({ start: te, end: ie });
  }, G = (m) => {
    if (Array.isArray(f.value) && f.value[0]) {
      const R = Dl(m, f.value[0]), te = N(f.value[0], m), ie = te.length === 1 ? 0 : te.filter((ot) => i(ot)).length, Oe = Math.abs(R) - ie;
      if (e.minRange && e.maxRange)
        return Oe >= +e.minRange && Oe <= +e.maxRange;
      if (e.minRange)
        return Oe >= +e.minRange;
      if (e.maxRange)
        return Oe <= +e.maxRange;
    }
    return !0;
  }, ne = (m) => Array.isArray(f.value) && f.value.length === 2 ? e.fixedStart && (Ge(m, f.value[0]) || Se(m, f.value[0])) ? [f.value[0], m] : e.fixedEnd && (Le(m, f.value[1]) || Se(m, f.value[1])) ? [m, f.value[1]] : (t("invalid-fixed-range", m), f.value) : [], b = () => {
    e.autoApply && z.value && t("auto-apply");
  }, p = () => {
    e.autoApply && t("select-date");
  }, k = (m) => !Bo({ start: m[0], end: m[1] }).some((R) => i(R)), we = (m) => (f.value = l(M(m.value)), b()), ve = (m) => {
    const R = tt(M(m.value), Y.hours, Y.minutes, oe());
    e.multiDates ? _(R) : f.value = R, n(), b();
  }, de = () => {
    h.value = f.value ? f.value.slice() : [], h.value.length === 2 && !(e.fixedStart || e.fixedEnd) && (h.value = []);
  }, De = (m, R) => {
    const te = [M(m.value), vt(M(m.value), +e.autoRange)];
    k(te) && (R && $(m.value), h.value = te);
  }, Qe = (m) => {
    ce(m.value) || (h.value = ne(M(m.value)));
  }, ce = (m) => e.noDisabledRange ? N(h.value[0], m).some((R) => i(R)) : !1, nt = (m, R) => {
    if (de(), e.autoRange)
      return De(m, R);
    if (e.fixedStart || e.fixedEnd)
      return Qe(m);
    h.value[0] ? G(M(m.value)) && !ce(m.value) && (Le(M(m.value), M(h.value[0])) ? h.value.unshift(M(m.value)) : h.value[1] = M(m.value)) : h.value[0] = M(m.value);
  }, Ke = (m) => {
    h.value[m] = tt(
      h.value[m],
      Y.hours[m],
      Y.minutes[m],
      oe(m !== 1)
    );
  }, ee = () => {
    h.value.length && (h.value[0] && !h.value[1] ? Ke(0) : (Ke(0), Ke(1), n()), f.value = h.value.slice(), h.value[0] && h.value[1] && e.autoApply && t("auto-apply"), h.value[0] && !h.value[1] && e.modelAuto && e.autoApply && t("auto-apply"));
  }, Me = (m, R = !1) => {
    if (!(i(m.value) || !m.current && e.hideOffsetDates)) {
      if (e.weekPicker)
        return we(m);
      if (!e.range)
        return ve(m);
      $t(Y.hours) && $t(Y.minutes) && !e.multiDates && (nt(m, R), ee());
    }
  }, _e = (m) => {
    const R = m[0];
    return e.weekNumbers === "local" ? Ws(R.value, { weekStartsOn: +e.weekStart }) : e.weekNumbers === "iso" ? Ys(R.value) : typeof e.weekNumbers == "function" ? e.weekNumbers(R.value) : "";
  }, _t = (m) => {
    for (let R = m - 1; R >= 0; R--) {
      const te = Et(qe(M(), { month: H.value(R + 1), year: X.value(R + 1) }), 1);
      B(R, Pe(te), ke(te));
    }
    for (let R = m + 1; R <= y.value.multiCalendars - 1; R++) {
      const te = lt(qe(M(), { month: H.value(R - 1), year: X.value(R - 1) }), 1);
      B(R, Pe(te), ke(te));
    }
  }, rt = (m) => d(M(), H.value(m), X.value(m)), Wt = (m) => tt(m, Y.hours, Y.minutes, oe()), Yr = (m, R) => {
    const te = e.monthPicker ? H.value(m) !== R.month || !R.fromNav : X.value(m) !== R.year;
    if (B(m, R.month, R.year), y.value.multiCalendars && !e.multiCalendarsSolo && _t(m), e.monthPicker || e.yearPicker)
      if (e.range) {
        if (te) {
          let ie = f.value ? f.value.slice() : [];
          ie.length === 2 && ie[1] !== null && (ie = []), ie.length ? Le(rt(m), ie[0]) ? ie.unshift(rt(m)) : ie[1] = rt(m) : ie = [rt(m)], f.value = ie;
        }
      } else
        f.value = rt(m);
    t("update-month-year", { instance: m, month: R.month, year: R.year }), r(e.multiCalendarsSolo ? m : void 0);
  }, Fr = async (m = !1) => {
    if (e.autoApply && (e.monthPicker || e.yearPicker)) {
      await Yt();
      const R = e.monthPicker ? m : !1;
      e.range ? t("auto-apply", R || !f.value || f.value.length === 1) : t("auto-apply", R);
    }
    n();
  }, Jt = (m, R) => {
    const te = qe(M(), { month: H.value(R), year: X.value(R) }), ie = m < 0 ? lt(te, 1) : Et(te, 1);
    g(Pe(ie), ke(ie), m < 0, e.preventMinMaxNavigation) && (B(R, Pe(ie), ke(ie)), y.value.multiCalendars && !e.multiCalendarsSolo && _t(R), t("update-month-year", { instance: R, month: Pe(ie), year: ke(ie) }), r());
  }, Lt = (m) => {
    su(m) && su(f.value) && $t(Y.hours) && $t(Y.minutes) ? (m[0] && f.value[0] && (f.value[0] = tt(m[0], Y.hours[0], Y.minutes[0], oe())), m[1] && f.value[1] && (f.value[1] = tt(m[1], Y.hours[1], Y.minutes[1], oe(!1)))) : e.multiDates && Array.isArray(f.value) ? f.value[f.value.length - 1] = Wt(m) : !e.range && !cu(m) && (f.value = Wt(m)), t("time-update");
  }, Vr = (m, R = !0, te = !1) => {
    const ie = R ? m : Y.hours, Oe = !R && !te ? m : Y.minutes, ot = te ? m : Y.seconds;
    if (e.range && cu(f.value) && $t(ie) && $t(Oe) && $t(ot) && !e.disableTimeRangeValidation) {
      const Ot = (q) => tt(f.value[q], ie[q], Oe[q], ot[q]), T = (q) => Ro(f.value[q], 0);
      if (Se(f.value[0], f.value[1]) && (Po(Ot(0), T(1)) || ko(Ot(1), T(0))))
        return;
    }
    if (j("hours", ie), j("minutes", Oe), j("seconds", ot), f.value)
      if (e.multiDates) {
        const Ot = S();
        Ot && Lt(Ot);
      } else
        Lt(f.value);
    else
      e.timePicker && Lt(e.range ? [M(), M()] : M());
    n();
  }, Ur = (m, R) => {
    e.monthChangeOnScroll && Jt(e.monthChangeOnScroll !== "inverse" ? -m.deltaY : m.deltaY, R);
  }, Wr = (m, R, te = !1) => {
    e.monthChangeOnArrows && e.vertical === te && en(m, R);
  }, en = (m, R) => {
    Jt(m === "right" ? -1 : 1, R);
  };
  return {
    time: Y,
    month: H,
    year: X,
    modelValue: f,
    calendars: I,
    monthYearSelect: Fr,
    isDisabled: i,
    updateTime: Vr,
    getWeekNum: _e,
    selectDate: Me,
    updateMonthYear: Yr,
    handleScroll: Ur,
    getMarker: (m) => e.markers.find((R) => Se(s(m.value), s(R.date))),
    handleArrow: Wr,
    handleSwipe: en,
    selectCurrentDate: () => {
      e.range ? f.value && Array.isArray(f.value) && f.value[0] ? f.value = Le(M(), f.value[0]) ? [M(), f.value[0]] : [f.value[0], M()] : f.value = [M()] : f.value = M(), p();
    },
    presetDateRange: (m, R) => {
      R || m.length && m.length <= 2 && e.range && (f.value = m.map((te) => M(te)), p(), e.multiCalendars && Yt().then(() => ae(!0)));
    }
  };
}, ov = (e, t, n) => {
  const r = L(), {
    getZonedToUtc: a,
    getZonedDate: o,
    formatDate: i,
    getDefaultPattern: s,
    checkRangeEnabled: l,
    checkPartialRangeValue: d,
    isValidDate: g,
    setDateMonthOrYear: y,
    defaults: f
  } = et(t), h = L(""), I = Gn(t, "format");
  Dt(r, () => {
    e("internal-model-change", r.value);
  }), Dt(I, () => {
    v();
  });
  const Y = (b) => {
    const p = b || M();
    return t.modelType ? _(p) : {
      hours: ft(p),
      minutes: dt(p),
      seconds: t.enableSeconds ? Vt(p) : 0
    };
  }, H = (b) => t.modelType ? _(b) : { month: Pe(b), year: ke(b) }, X = (b) => Array.isArray(b) ? l(() => [
    St(M(), b[0]),
    b[1] ? St(M(), b[1]) : d()
  ]) : St(M(), +b), z = (b, p) => (typeof b == "string" || typeof b == "number") && t.modelType ? $(b) : p, B = (b) => Array.isArray(b) ? [
    z(
      b[0],
      tt(null, +b[0].hours, +b[0].minutes, b[0].seconds)
    ),
    z(
      b[1],
      tt(null, +b[1].hours, +b[1].minutes, b[1].seconds)
    )
  ] : z(b, tt(null, b.hours, b.minutes, b.seconds)), j = (b) => Array.isArray(b) ? l(() => [
    z(b[0], y(null, +b[0].month, +b[0].year)),
    z(
      b[1],
      b[1] ? y(null, +b[1].month, +b[1].year) : d()
    )
  ]) : z(b, y(null, +b.month, +b.year)), ae = (b) => {
    if (Array.isArray(b))
      return b.map((p) => $(p));
    throw new Error(Ar.dateArr("multi-dates"));
  }, J = (b) => {
    if (Array.isArray(b))
      return [M(b[0]), M(b[1])];
    throw new Error(Ar.dateArr("week-picker"));
  }, D = (b) => t.modelAuto ? Array.isArray(b) ? [$(b[0]), $(b[1])] : t.autoApply ? [$(b)] : [$(b), null] : Array.isArray(b) ? l(() => [
    $(b[0]),
    b[1] ? $(b[1]) : d()
  ]) : $(b), O = () => {
    Array.isArray(r.value) && t.range && r.value.length === 1 && r.value.push(d());
  }, A = () => {
    const b = r.value;
    return [
      _(b[0]),
      b[1] ? _(b[1]) : d()
    ];
  }, V = () => r.value[1] ? A() : _(Ue(r.value[0])), C = () => (r.value || []).map((b) => _(b)), U = () => (O(), t.modelAuto ? V() : t.multiDates ? C() : Array.isArray(r.value) ? l(() => A()) : _(Ue(r.value))), K = (b) => b ? t.timePicker ? B(Ue(b)) : t.monthPicker ? j(Ue(b)) : t.yearPicker ? X(Ue(b)) : t.multiDates ? ae(Ue(b)) : t.weekPicker ? J(Ue(b)) : D(Ue(b)) : null, oe = (b) => {
    const p = K(b);
    g(Ue(p)) ? (r.value = Ue(p), v()) : (r.value = null, h.value = "");
  }, P = () => {
    var b;
    const p = (k) => {
      var we;
      return Qt(k, (we = f.value.textInputOptions) == null ? void 0 : we.format);
    };
    return `${p(r.value[0])} ${(b = f.value.textInputOptions) == null ? void 0 : b.rangeSeparator} ${r.value[1] ? p(r.value[1]) : ""}`;
  }, S = () => {
    var b;
    return n.value && r.value ? Array.isArray(r.value) ? P() : Qt(r.value, (b = f.value.textInputOptions) == null ? void 0 : b.format) : i(r.value);
  }, u = () => {
    var b;
    return r.value ? t.multiDates ? r.value.map((p) => i(p)).join("; ") : t.textInput && typeof ((b = f.value.textInputOptions) == null ? void 0 : b.format) == "string" ? S() : i(r.value) : "";
  }, v = () => {
    !t.format || typeof t.format == "string" ? h.value = u() : h.value = t.format(r.value);
  }, $ = (b) => {
    if (t.utc) {
      const p = new Date(b);
      return t.utc === "preserve" ? new Date(p.getTime() + p.getTimezoneOffset() * 6e4) : p;
    }
    return t.modelType ? t.modelType === "date" || t.modelType === "timestamp" ? o(new Date(b)) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? po(b, s(), new Date()) : o(po(b, t.modelType, new Date())) : o(new Date(b));
  }, _ = (b) => t.utc ? bp(b, t.utc === "preserve") : t.modelType ? t.modelType === "timestamp" ? +a(b) : t.modelType === "format" && (typeof t.format == "string" || !t.format) ? i(a(b)) : i(a(b), t.modelType) : a(b), N = (b) => {
    e("update:model-value", b);
  }, G = (b) => Array.isArray(r.value) ? [
    b(r.value[0]),
    r.value[1] ? b(r.value[1]) : d()
  ] : b(Ue(r.value)), ne = (b) => N(Ue(G(b)));
  return {
    inputValue: h,
    internalModelValue: r,
    checkBeforeEmit: () => r.value ? t.range ? t.partialRange ? r.value.length >= 1 : r.value.length === 2 : !!r.value : !1,
    parseExternalModelValue: oe,
    formatInputValue: v,
    emitModelValue: () => (v(), t.monthPicker ? ne(H) : t.timePicker ? ne(Y) : t.yearPicker ? ne(ke) : t.weekPicker ? N(r.value) : N(U()))
  };
}, iv = (e, t) => {
  const { validateMonthYearInRange: n, validateMaxDate: r, validateMinDate: a, defaults: o } = et(e), i = (y, f) => {
    let h = y;
    return o.value.filters.months.includes(Pe(h)) ? (h = f ? lt(y, 1) : Et(y, 1), i(h, f)) : h;
  }, s = (y, f) => {
    let h = y;
    return o.value.filters.years.includes(ke(h)) ? (h = f ? bu(y, 1) : Rm(y, 1), s(h, f)) : h;
  }, l = (y) => {
    const f = qe(new Date(), { month: e.month, year: e.year });
    let h = y ? lt(f, 1) : Et(f, 1), I = Pe(h), Y = ke(h);
    o.value.filters.months.includes(I) && (h = i(h, y), I = Pe(h), Y = ke(h)), o.value.filters.years.includes(Y) && (h = s(h, y), Y = ke(h)), n(I, Y, y, e.preventMinMaxNavigation) && d(I, Y);
  }, d = (y, f) => {
    t("update-month-year", { month: y, year: f });
  }, g = F(() => (y) => {
    if (!e.preventMinMaxNavigation || y && !e.maxDate || !y && !e.minDate)
      return !1;
    const f = qe(new Date(), { month: e.month, year: e.year }), h = y ? lt(f, 1) : Et(f, 1), I = [Pe(h), ke(h)];
    return y ? !r(...I) : !a(...I);
  });
  return { handleMonthYearChange: l, isDisabled: g, updateMonthYear: d };
};
var zn = /* @__PURE__ */ ((e) => (e.center = "center", e.left = "left", e.right = "right", e))(zn || {});
const uv = (e, t, n, r) => {
  const a = L({
    top: "0",
    left: "0",
    transform: "none"
  }), o = L(!1), i = Gn(r, "teleportCenter");
  Dt(i, () => {
    Y();
  });
  const s = () => ({ top: 0, left: 0 }), l = (O, A) => {
    a.value.left = `${O + A}px`, a.value.transform = "translateX(-100%)";
  }, d = (O) => {
    a.value.left = `${O}px`, a.value.transform = "translateX(0)";
  }, g = (O, A, V = !1) => {
    r.position === zn.left && d(O), r.position === zn.right && l(O, A), r.position === zn.center && (a.value.left = `${O + A / 2}px`, a.value.transform = V ? "translate(-50%, -50%)" : "translateX(-50%)");
  }, y = (O) => {
    const { width: A, height: V } = O.getBoundingClientRect(), { top: C, left: U } = r.altPosition ? r.altPosition(O) : s();
    return { top: +C, left: +U, width: A, height: V };
  }, f = () => {
    const O = Be(t);
    if (O) {
      const { top: A, left: V, width: C, height: U } = y(O);
      a.value.top = `${A + U / 2}px`, a.value.transform = "translateY(-50%)", g(V, C, !0);
    }
  }, h = () => {
    a.value.left = "50%", a.value.top = "50%", a.value.transform = "translate(-50%, -50%)", a.value.position = "fixed";
  }, I = () => {
    const O = Be(t), { top: A, left: V, transform: C } = r.altPosition(O);
    a.value = { top: `${A}px`, left: `${V}px`, transform: C || "" };
  }, Y = (O = !0) => {
    if (!r.inline)
      return i.value ? h() : r.altPosition !== null ? I() : (O && n("recalculate-position"), ae());
  }, H = ({
    inputEl: O,
    menuEl: A,
    left: V,
    width: C
  }) => {
    window.screen.width > 768 && g(V, C), B(O, A);
  }, X = (O, A) => {
    const { top: V, left: C, height: U, width: K } = y(O);
    a.value.top = `${U + V + +r.offset}px`, H({ inputEl: O, menuEl: A, left: C, width: K }), o.value = !1;
  }, z = (O, A) => {
    const { top: V, left: C, width: U } = y(O), { height: K } = A.getBoundingClientRect();
    a.value.top = `${V - K - +r.offset}px`, H({ inputEl: O, menuEl: A, left: C, width: U }), o.value = !0;
  }, B = (O, A) => {
    if (r.autoPosition) {
      const { left: V, width: C } = y(O), { left: U, right: K } = A.getBoundingClientRect();
      return U <= 0 || U <= V ? d(V) : K >= document.documentElement.clientWidth ? l(V, C) : g(V, C);
    }
  }, j = (O, A) => {
    const { height: V } = A.getBoundingClientRect(), { top: C, height: U } = O.getBoundingClientRect(), K = window.innerHeight - C - U, oe = C;
    return V <= K ? X(O, A) : V > K && V <= oe ? z(O, A) : K >= oe ? X(O, A) : z(O, A);
  }, ae = () => {
    const O = Be(t), A = Be(e);
    if (O && A)
      return r.autoPosition ? j(O, A) : X(O, A);
  }, J = function(O) {
    if (O) {
      const A = O.scrollHeight > O.clientHeight, V = window.getComputedStyle(O).overflowY.indexOf("hidden") !== -1;
      return A && !V;
    }
    return !0;
  }, D = function(O) {
    return !O || O === document.body ? window : J(O) ? O : D(O.parentNode);
  };
  return { openOnTop: o, menuPosition: a, setMenuPosition: Y, setInitialPosition: f, getScrollableParent: D };
}, Bt = [
  { name: "clock-icon", use: ["time", "calendar"] },
  { name: "arrow-left", use: ["month-year", "calendar"] },
  { name: "arrow-right", use: ["month-year", "calendar"] },
  { name: "arrow-up", use: ["time", "calendar"] },
  { name: "arrow-down", use: ["time", "calendar"] },
  { name: "calendar-icon", use: ["month-year", "time", "calendar"] },
  { name: "day", use: ["calendar"] },
  { name: "month-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay-value", use: ["calendar", "month-year"] },
  { name: "year-overlay", use: ["month-year"] },
  { name: "month-overlay", use: ["month-year"] },
  { name: "month-overlay-header", use: ["month-year"] },
  { name: "year-overlay-header", use: ["month-year"] },
  { name: "hours-overlay-value", use: ["calendar", "time"] },
  { name: "minutes-overlay-value", use: ["calendar", "time"] },
  { name: "seconds-overlay-value", use: ["calendar", "time"] },
  { name: "hours", use: ["calendar", "time"] },
  { name: "minutes", use: ["calendar", "time"] },
  { name: "month", use: ["calendar", "month-year"] },
  { name: "year", use: ["calendar", "month-year"] },
  { name: "action-select", use: ["action"] },
  { name: "action-preview", use: ["action"] },
  { name: "calendar-header", use: ["calendar"] },
  { name: "marker-tooltip", use: ["calendar"] },
  { name: "now-button", use: [] },
  { name: "time-picker-overlay", use: ["calendar", "time"] },
  { name: "am-pm-button", use: ["calendar", "time"] },
  { name: "left-sidebar", use: ["menu"] },
  { name: "right-sidebar", use: ["menu"] },
  { name: "month-year", use: ["month-year"] },
  { name: "time-picker", use: ["menu"] },
  { name: "action-row", use: ["action"] }
], lv = [{ name: "trigger" }, { name: "input-icon" }, { name: "clear-icon" }, { name: "dp-input" }], sv = {
  all: () => Bt,
  monthYear: () => Bt.filter((e) => e.use.includes("month-year")),
  input: () => lv,
  timePicker: () => Bt.filter((e) => e.use.includes("time")),
  action: () => Bt.filter((e) => e.use.includes("action")),
  calendar: () => Bt.filter((e) => e.use.includes("calendar")),
  menu: () => Bt.filter((e) => e.use.includes("menu"))
}, Tt = (e, t, n) => {
  const r = [];
  return sv[t]().forEach((a) => {
    e[a.name] && r.push(a.name);
  }), n && n.length && n.forEach((a) => {
    a.slot && r.push(a.slot);
  }), r;
}, Er = (e) => ({ transitionName: F(() => (t) => e && typeof e != "boolean" ? t ? e.open : e.close : ""), showTransition: !!e }), wt = {
  multiCalendars: { type: [Boolean, Number, String], default: null },
  modelValue: { type: [String, Date, Array, Object, Number], default: null },
  modelType: { type: String, default: null },
  position: { type: String, default: "center" },
  dark: { type: Boolean, default: !1 },
  format: {
    type: [String, Function],
    default: () => null
  },
  closeOnScroll: { type: Boolean, default: !1 },
  autoPosition: { type: Boolean, default: !0 },
  closeOnAutoApply: { type: Boolean, default: !0 },
  altPosition: { type: Function, default: null },
  transitions: { type: [Boolean, Object], default: !0 },
  formatLocale: { type: Object, default: null },
  utc: { type: [Boolean, String], default: !1 },
  ariaLabels: { type: Object, default: () => ({}) },
  offset: { type: [Number, String], default: 10 },
  hideNavigation: { type: Array, default: () => [] },
  timezone: { type: String, default: null },
  vertical: { type: Boolean, default: !1 },
  disableMonthYearSelect: { type: Boolean, default: !1 },
  menuClassName: { type: String, default: null },
  dayClass: { type: Function, default: null },
  yearRange: { type: Array, default: () => [1900, 2100] },
  multiCalendarsSolo: { type: Boolean, default: !1 },
  calendarCellClassName: { type: String, default: null },
  enableTimePicker: { type: Boolean, default: !0 },
  autoApply: { type: Boolean, default: !1 },
  disabledDates: { type: [Array, Function], default: () => [] },
  monthNameFormat: { type: String, default: "short" },
  startDate: { type: [Date, String], default: null },
  startTime: { type: [Object, Array], default: null },
  hideOffsetDates: { type: Boolean, default: !1 },
  autoRange: { type: [Number, String], default: null },
  noToday: { type: Boolean, default: !1 },
  disabledWeekDays: { type: Array, default: () => [] },
  allowedDates: { type: Array, default: () => [] },
  showNowButton: { type: Boolean, default: !1 },
  nowButtonLabel: { type: String, default: "Now" },
  markers: { type: Array, default: () => [] },
  modeHeight: { type: [Number, String], default: 255 },
  escClose: { type: Boolean, default: !0 },
  spaceConfirm: { type: Boolean, default: !0 },
  monthChangeOnArrows: { type: Boolean, default: !0 },
  presetRanges: { type: Array, default: () => [] },
  flow: { type: Array, default: () => [] },
  preventMinMaxNavigation: { type: Boolean, default: !1 },
  minRange: { type: [Number, String], default: null },
  maxRange: { type: [Number, String], default: null },
  multiDatesLimit: { type: [Number, String], default: null },
  reverseYears: { type: Boolean, default: !1 },
  keepActionRow: { type: Boolean, default: !1 },
  weekPicker: { type: Boolean, default: !1 },
  filters: { type: Object, default: () => ({}) },
  arrowNavigation: { type: Boolean, default: !1 },
  multiStatic: { type: Boolean, default: !0 },
  disableTimeRangeValidation: { type: Boolean, default: !1 },
  highlight: {
    type: [Array, Function],
    default: null
  },
  highlightWeekDays: {
    type: Array,
    default: null
  },
  highlightDisabledDays: { type: Boolean, default: !1 },
  teleportCenter: { type: Boolean, default: !1 },
  locale: { type: String, default: "en-Us" },
  weekNumName: { type: String, default: "W" },
  weekStart: { type: [Number, String], default: 1 },
  weekNumbers: {
    type: [String, Function],
    default: null
  },
  calendarClassName: { type: String, default: null },
  noSwipe: { type: Boolean, default: !1 },
  monthChangeOnScroll: { type: [Boolean, String], default: !0 },
  dayNames: {
    type: [Function, Array],
    default: null
  },
  monthPicker: { type: Boolean, default: !1 },
  customProps: { type: Object, default: null },
  yearPicker: { type: Boolean, default: !1 },
  modelAuto: { type: Boolean, default: !1 },
  selectText: { type: String, default: "Select" },
  cancelText: { type: String, default: "Cancel" },
  previewFormat: {
    type: [String, Function],
    default: () => ""
  },
  multiDates: { type: Boolean, default: !1 },
  partialRange: { type: Boolean, default: !0 },
  ignoreTimeValidation: { type: Boolean, default: !1 },
  minDate: { type: [Date, String], default: null },
  maxDate: { type: [Date, String], default: null },
  minTime: { type: Object, default: null },
  maxTime: { type: Object, default: null },
  name: { type: String, default: null },
  placeholder: { type: String, default: "" },
  hideInputIcon: { type: Boolean, default: !1 },
  clearable: { type: Boolean, default: !0 },
  state: { type: Boolean, default: null },
  required: { type: Boolean, default: !1 },
  autocomplete: { type: String, default: "off" },
  inputClassName: { type: String, default: null },
  inlineWithInput: { type: Boolean, default: !1 },
  textInputOptions: { type: Object, default: () => null },
  fixedStart: { type: Boolean, default: !1 },
  fixedEnd: { type: Boolean, default: !1 },
  timePicker: { type: Boolean, default: !1 },
  enableSeconds: { type: Boolean, default: !1 },
  is24: { type: Boolean, default: !0 },
  noHoursOverlay: { type: Boolean, default: !1 },
  noMinutesOverlay: { type: Boolean, default: !1 },
  noSecondsOverlay: { type: Boolean, default: !1 },
  hoursGridIncrement: { type: [String, Number], default: 1 },
  minutesGridIncrement: { type: [String, Number], default: 5 },
  secondsGridIncrement: { type: [String, Number], default: 5 },
  hoursIncrement: { type: [Number, String], default: 1 },
  minutesIncrement: { type: [Number, String], default: 1 },
  secondsIncrement: { type: [Number, String], default: 1 },
  range: { type: Boolean, default: !1 },
  uid: { type: String, default: null },
  disabled: { type: Boolean, default: !1 },
  readonly: { type: Boolean, default: !1 },
  inline: { type: Boolean, default: !1 },
  textInput: { type: Boolean, default: !1 },
  onClickOutside: { type: Function, default: null },
  noDisabledRange: { type: Boolean, default: !1 },
  sixWeeks: { type: Boolean, default: !1 }
}, cv = ["aria-label", "aria-disabled", "aria-readonly"], fv = {
  key: 1,
  class: "dp__input_wrap"
}, dv = ["id", "name", "inputmode", "placeholder", "disabled", "readonly", "required", "value", "autocomplete", "onKeydown"], yv = {
  key: 2,
  class: "dp__input_icon"
}, mv = {
  key: 4,
  class: "dp__clear_icon"
}, pv = /* @__PURE__ */ Ee({
  __name: "DatepickerInput",
  props: {
    isMenuOpen: { type: Boolean, default: !1 },
    inputValue: { type: String, default: "" },
    ...wt
  },
  emits: [
    "clear",
    "open",
    "update:input-value",
    "set-input-date",
    "close",
    "select-date",
    "set-empty-date",
    "toggle",
    "focus-prev",
    "focus",
    "blur"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { getDefaultPattern: a, isValidDate: o, defaults: i } = et(r), s = L(), l = L(null), d = L(!1), g = F(
      () => ({
        dp__pointer: !r.disabled && !r.readonly && !r.textInput,
        dp__disabled: r.disabled,
        dp__input_readonly: !r.textInput,
        dp__input: !0,
        dp__input_icon_pad: !r.hideInputIcon,
        dp__input_valid: r.state,
        dp__input_invalid: r.state === !1,
        dp__input_focus: d.value || r.isMenuOpen,
        dp__input_reg: !r.textInput,
        [r.inputClassName]: !!r.inputClassName
      })
    ), y = () => {
      n("set-input-date", null), r.autoApply && (n("set-empty-date"), s.value = null);
    }, f = (D) => {
      var O;
      return gp(D, ((O = i.value.textInputOptions) == null ? void 0 : O.format) || a());
    }, h = (D) => {
      const { rangeSeparator: O } = i.value.textInputOptions, [A, V] = D.split(`${O}`);
      if (A) {
        const C = f(A.trim()), U = V ? f(V.trim()) : null, K = C && U ? [C, U] : [C];
        s.value = C ? K : null;
      }
    }, I = (D) => {
      if (r.range)
        h(D);
      else if (r.multiDates) {
        const O = D.split(";");
        s.value = O.map((A) => f(A.trim())).filter((A) => A);
      } else
        s.value = f(D);
    }, Y = (D) => {
      var O;
      const { value: A } = D.target;
      A !== "" ? ((O = i.value.textInputOptions) != null && O.openMenu && !r.isMenuOpen && n("open"), I(A), n("set-input-date", s.value)) : y(), n("update:input-value", A);
    }, H = () => {
      var D, O;
      (D = i.value.textInputOptions) != null && D.enterSubmit && o(s.value) && r.inputValue !== "" ? (n("set-input-date", s.value, !0), s.value = null) : (O = i.value.textInputOptions) != null && O.enterSubmit && r.inputValue === "" && (s.value = null, n("clear"));
    }, X = () => {
      var D, O;
      (D = i.value.textInputOptions) != null && D.tabSubmit && o(s.value) && r.inputValue !== "" ? (n("set-input-date", s.value, !0), s.value = null) : (O = i.value.textInputOptions) != null && O.tabSubmit && r.inputValue === "" && (s.value = null, n("clear"));
    }, z = () => {
      d.value = !0, n("focus");
    }, B = (D) => {
      var O;
      D.preventDefault(), D.stopImmediatePropagation(), D.stopPropagation(), r.textInput && (O = i.value.textInputOptions) != null && O.openMenu && !r.inlineWithInput ? r.isMenuOpen ? i.value.textInputOptions.enterSubmit && n("select-date") : n("open") : r.textInput || n("toggle");
    }, j = () => {
      d.value = !1, r.isMenuOpen || n("blur"), r.autoApply && r.textInput && s.value && (n("set-input-date", s.value), n("select-date"), s.value = null);
    }, ae = () => {
      n("clear");
    }, J = (D) => {
      r.textInput || D.preventDefault();
    };
    return t({
      focusInput: () => {
        l.value && l.value.focus({ preventScroll: !0 });
      }
    }), (D, O) => {
      var A;
      return w(), E("div", {
        onClick: B,
        "aria-label": (A = c(i).ariaLabels) == null ? void 0 : A.input,
        role: "textbox",
        "aria-multiline": "false",
        "aria-disabled": D.disabled,
        "aria-readonly": D.readonly
      }, [
        D.$slots.trigger && !D.$slots["dp-input"] && !D.inline ? W(D.$slots, "trigger", { key: 0 }) : x("", !0),
        !D.$slots.trigger && (!D.inline || D.inlineWithInput) ? (w(), E("div", fv, [
          D.$slots["dp-input"] && !D.$slots.trigger && !D.inline ? W(D.$slots, "dp-input", {
            key: 0,
            value: e.inputValue,
            onInput: Y,
            onEnter: H,
            onTab: X,
            onClear: ae
          }) : x("", !0),
          D.$slots["dp-input"] ? x("", !0) : (w(), E("input", {
            key: 1,
            ref_key: "inputRef",
            ref: l,
            id: D.uid ? `dp-input-${D.uid}` : void 0,
            name: D.name,
            class: pe(c(g)),
            inputmode: D.textInput ? "text" : "none",
            placeholder: D.placeholder,
            disabled: D.disabled,
            readonly: D.readonly,
            required: D.required,
            value: e.inputValue,
            autocomplete: D.autocomplete,
            onInput: Y,
            onKeydown: [
              me(B, ["enter"]),
              me(X, ["tab"])
            ],
            onBlur: j,
            onFocus: z,
            onKeypress: J
          }, null, 42, dv)),
          D.$slots["input-icon"] && !D.hideInputIcon ? (w(), E("span", yv, [
            W(D.$slots, "input-icon")
          ])) : x("", !0),
          !D.$slots["input-icon"] && !D.hideInputIcon && !D.$slots["dp-input"] ? (w(), fe(c(Br), {
            key: 3,
            class: "dp__input_icon dp__input_icons"
          })) : x("", !0),
          D.$slots["clear-icon"] && e.inputValue && D.clearable && !D.disabled && !D.readonly ? (w(), E("span", mv, [
            W(D.$slots, "clear-icon", { clear: ae })
          ])) : x("", !0),
          D.clearable && !D.$slots["clear-icon"] && e.inputValue && !D.disabled && !D.readonly ? (w(), fe(c(jm), {
            key: 5,
            class: "dp__clear_icon dp__input_icons",
            "data-test": "clear-icon",
            onClick: mt(ae, ["stop", "prevent"])
          }, null, 8, ["onClick"])) : x("", !0)
        ])) : x("", !0)
      ], 8, cv);
    };
  }
}), vv = { class: "dp__selection_preview" }, hv = { class: "dp__action_buttons" }, gv = ["onKeydown"], bv = /* @__PURE__ */ Ee({
  __name: "ActionRow",
  props: {
    calendarWidth: { type: Number, default: 0 },
    menuMount: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...wt
  },
  emits: ["close-picker", "select-date", "invalid-select"],
  setup(e, { emit: t }) {
    const n = e, { formatDate: r, isValidTime: a, defaults: o } = et(n), { buildMatrix: i } = bt(), s = L(null), l = L(null);
    at(() => {
      n.arrowNavigation && i([Be(s), Be(l)], "actionRow");
    });
    const d = F(() => n.range && !n.partialRange && n.internalModelValue ? n.internalModelValue.length === 2 : !0), g = F(() => !f.value || !h.value || !d.value), y = F(() => ({
      dp__action: !0,
      dp__select: !0,
      dp__action_disabled: g.value
    })), f = F(() => !n.enableTimePicker || n.ignoreTimeValidation ? !0 : a(n.internalModelValue)), h = F(() => n.monthPicker ? X(n.internalModelValue) : !0), I = () => {
      const B = o.value.previewFormat;
      return n.timePicker || n.monthPicker, B(Ue(n.internalModelValue));
    }, Y = () => {
      const B = n.internalModelValue;
      return o.value.multiCalendars > 0 ? `${r(B[0])} - ${r(B[1])}` : [r(B[0]), r(B[1])];
    }, H = F(() => !n.internalModelValue || !n.menuMount ? "" : typeof o.value.previewFormat == "string" ? Array.isArray(n.internalModelValue) ? n.internalModelValue.length === 2 && n.internalModelValue[1] ? Y() : n.multiDates ? n.internalModelValue.map((B) => `${r(B)}`) : n.modelAuto ? `${r(n.internalModelValue[0])}` : `${r(n.internalModelValue[0])} -` : r(n.internalModelValue) : I()), X = (B) => {
      if (!n.monthPicker)
        return !0;
      let j = !0;
      return n.minDate && n.maxDate ? Ge(M(B), M(n.minDate)) && Le(M(B), M(n.maxDate)) : (n.minDate && (j = Ge(M(B), M(n.minDate))), n.maxDate && (j = Le(M(B), M(n.maxDate))), j);
    }, z = () => {
      f.value && h.value && d.value ? t("select-date") : t("invalid-select");
    };
    return (B, j) => (w(), E("div", {
      class: "dp__action_row",
      style: kt(e.calendarWidth ? { width: `${e.calendarWidth}px` } : {})
    }, [
      B.$slots["action-row"] ? W(B.$slots, "action-row", Je(Fe({ key: 0 }, {
        internalModelValue: e.internalModelValue,
        disabled: c(g),
        selectDate: () => B.$emit("select-date"),
        closePicker: () => B.$emit("close-picker")
      }))) : (w(), E(he, { key: 1 }, [
        se("div", vv, [
          B.$slots["action-preview"] ? W(B.$slots, "action-preview", {
            key: 0,
            value: e.internalModelValue
          }) : x("", !0),
          B.$slots["action-preview"] ? x("", !0) : (w(), E(he, { key: 1 }, [
            Array.isArray(c(H)) ? x("", !0) : (w(), E(he, { key: 0 }, [
              Ve(Te(c(H)), 1)
            ], 64)),
            Array.isArray(c(H)) ? (w(!0), E(he, { key: 1 }, Ae(c(H), (ae, J) => (w(), E("div", { key: J }, Te(ae), 1))), 128)) : x("", !0)
          ], 64))
        ]),
        se("div", hv, [
          B.$slots["action-select"] ? W(B.$slots, "action-select", {
            key: 0,
            value: e.internalModelValue
          }) : x("", !0),
          B.$slots["action-select"] ? x("", !0) : (w(), E(he, { key: 1 }, [
            B.inline ? x("", !0) : (w(), E("span", {
              key: 0,
              class: "dp__action dp__cancel",
              ref_key: "cancelButtonRef",
              ref: s,
              tabindex: "0",
              onClick: j[0] || (j[0] = (ae) => B.$emit("close-picker")),
              onKeydown: [
                j[1] || (j[1] = me((ae) => B.$emit("close-picker"), ["enter"])),
                j[2] || (j[2] = me((ae) => B.$emit("close-picker"), ["space"]))
              ]
            }, Te(B.cancelText), 545)),
            se("span", {
              class: pe(c(y)),
              tabindex: "0",
              onKeydown: [
                me(z, ["enter"]),
                me(z, ["space"])
              ],
              onClick: z,
              "data-test": "select-button",
              ref_key: "selectButtonRef",
              ref: l
            }, Te(B.selectText), 43, gv)
          ], 64))
        ])
      ], 64))
    ], 4));
  }
}), wv = ["aria-label"], _v = {
  class: "dp__calendar_header",
  role: "row"
}, Ov = {
  key: 0,
  class: "dp__calendar_header_item",
  role: "gridcell"
}, $v = /* @__PURE__ */ se("div", { class: "dp__calendar_header_separator" }, null, -1), Pv = ["aria-label"], kv = {
  key: 0,
  role: "gridcell",
  class: "dp__calendar_item dp__week_num"
}, Tv = { class: "dp__cell_inner" }, Sv = ["aria-selected", "aria-disabled", "aria-label", "data-test", "onClick", "onKeydown", "onMouseenter", "onMouseleave"], Dv = /* @__PURE__ */ se("div", { class: "dp__arrow_bottom_tp" }, null, -1), xv = /* @__PURE__ */ Ee({
  __name: "Calendar",
  props: {
    mappedDates: { type: Array, default: () => [] },
    getWeekNum: {
      type: Function,
      default: () => ""
    },
    specificMode: { type: Boolean, default: !1 },
    instance: { type: Number, default: 0 },
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    ...wt
  },
  emits: [
    "select-date",
    "set-hover-date",
    "handle-scroll",
    "mount",
    "handle-swipe",
    "handle-space",
    "tooltip-open",
    "tooltip-close"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMultiLevelMatrix: a } = bt(), { setDateMonthOrYear: o, defaults: i } = et(r), s = L(null), l = L({ bottom: "", left: "", transform: "" }), d = L([]), g = L(null), y = L(!0), f = L(""), h = L({ startX: 0, endX: 0, startY: 0, endY: 0 }), I = F(() => r.dayNames ? Array.isArray(r.dayNames) ? r.dayNames : r.dayNames(r.locale, +r.weekStart) : zp(r.locale, +r.weekStart));
    at(() => {
      n("mount", { cmp: "calendar", refs: d }), r.noSwipe || g.value && (g.value.addEventListener("touchstart", A, { passive: !1 }), g.value.addEventListener("touchend", V, { passive: !1 }), g.value.addEventListener("touchmove", C, { passive: !1 })), r.monthChangeOnScroll && g.value && g.value.addEventListener("wheel", oe, { passive: !1 });
    });
    const Y = (P) => P ? r.vertical ? "vNext" : "next" : r.vertical ? "vPrevious" : "previous", H = (P, S) => {
      if (r.transitions) {
        const u = st(o(M(), r.month, r.year));
        f.value = Ge(st(o(M(), P, S)), u) ? i.value.transitions[Y(!0)] : i.value.transitions[Y(!1)], y.value = !1, Yt(() => {
          y.value = !0;
        });
      }
    }, X = F(
      () => ({
        dp__calendar_wrap: !0,
        [r.calendarClassName]: !!r.calendarClassName
      })
    ), z = F(() => (P) => {
      const S = Zp(P);
      return {
        dp__marker_dot: S.type === "dot",
        dp__marker_line: S.type === "line"
      };
    }), B = F(() => (P) => Se(P, s.value)), j = F(() => ({
      dp__calendar: !0,
      dp__calendar_next: i.value.multiCalendars > 0 && r.instance !== 0
    })), ae = F(() => (P) => r.hideOffsetDates ? P.current : !0), J = F(() => r.specificMode ? { height: `${r.modeHeight}px` } : void 0), D = (P, S, u) => {
      var v, $;
      if (n("set-hover-date", P), ($ = (v = P.marker) == null ? void 0 : v.tooltip) != null && $.length) {
        const _ = Be(d.value[S][u]);
        if (_) {
          const { width: N, height: G } = _.getBoundingClientRect();
          l.value = {
            bottom: `${G}px`,
            left: `${N / 2}px`,
            transform: "translateX(-50%)"
          }, s.value = P.value, n("tooltip-open", P.marker);
        }
      }
    }, O = (P) => {
      s.value && (s.value = null, n("tooltip-close", P.marker));
    }, A = (P) => {
      h.value.startX = P.changedTouches[0].screenX, h.value.startY = P.changedTouches[0].screenY;
    }, V = (P) => {
      h.value.endX = P.changedTouches[0].screenX, h.value.endY = P.changedTouches[0].screenY, U();
    }, C = (P) => {
      r.vertical && !r.inline && P.preventDefault();
    }, U = () => {
      const P = r.vertical ? "Y" : "X";
      Math.abs(h.value[`start${P}`] - h.value[`end${P}`]) > 10 && n("handle-swipe", h.value[`start${P}`] > h.value[`end${P}`] ? "right" : "left");
    }, K = (P, S, u) => {
      P && (Array.isArray(d.value[S]) ? d.value[S][u] = P : d.value[S] = [P]), r.arrowNavigation && a(d.value, "calendar");
    }, oe = (P) => {
      r.monthChangeOnScroll && (P.preventDefault(), n("handle-scroll", P));
    };
    return t({ triggerTransition: H }), (P, S) => {
      var u;
      return w(), E("div", {
        class: pe(c(j))
      }, [
        se("div", {
          style: kt(c(J))
        }, [
          e.specificMode ? x("", !0) : (w(), E("div", {
            key: 0,
            ref_key: "calendarWrapRef",
            ref: g,
            class: pe(c(X)),
            role: "grid",
            "aria-label": (u = c(i).ariaLabels) == null ? void 0 : u.calendarWrap
          }, [
            se("div", _v, [
              P.weekNumbers ? (w(), E("div", Ov, Te(P.weekNumName), 1)) : x("", !0),
              (w(!0), E(he, null, Ae(c(I), (v, $) => (w(), E("div", {
                class: "dp__calendar_header_item",
                role: "gridcell",
                key: $,
                "data-test": "calendar-header"
              }, [
                P.$slots["calendar-header"] ? W(P.$slots, "calendar-header", {
                  key: 0,
                  day: v,
                  index: $
                }) : x("", !0),
                P.$slots["calendar-header"] ? x("", !0) : (w(), E(he, { key: 1 }, [
                  Ve(Te(v), 1)
                ], 64))
              ]))), 128))
            ]),
            $v,
            Re(Ut, {
              name: f.value,
              css: !!P.transitions
            }, {
              default: Q(() => {
                var v;
                return [
                  y.value ? (w(), E("div", {
                    key: 0,
                    class: "dp__calendar",
                    role: "grid",
                    "aria-label": (v = c(i).ariaLabels) == null ? void 0 : v.calendarDays
                  }, [
                    (w(!0), E(he, null, Ae(e.mappedDates, ($, _) => (w(), E("div", {
                      class: "dp__calendar_row",
                      role: "row",
                      key: _
                    }, [
                      P.weekNumbers ? (w(), E("div", kv, [
                        se("div", Tv, Te(e.getWeekNum($.days)), 1)
                      ])) : x("", !0),
                      (w(!0), E(he, null, Ae($.days, (N, G) => {
                        var ne, b, p;
                        return w(), E("div", {
                          role: "gridcell",
                          class: "dp__calendar_item",
                          ref_for: !0,
                          ref: (k) => K(k, _, G),
                          key: G + _,
                          "aria-selected": N.classData.dp__active_date || N.classData.dp__range_start || N.classData.dp__range_start,
                          "aria-disabled": N.classData.dp__cell_disabled,
                          "aria-label": (b = (ne = c(i).ariaLabels) == null ? void 0 : ne.day) == null ? void 0 : b.call(ne, N),
                          tabindex: "0",
                          "data-test": N.value,
                          onClick: mt((k) => P.$emit("select-date", N), ["stop", "prevent"]),
                          onKeydown: [
                            me((k) => P.$emit("select-date", N), ["enter"]),
                            me((k) => P.$emit("handle-space", N), ["space"])
                          ],
                          onMouseenter: (k) => D(N, _, G),
                          onMouseleave: (k) => O(N)
                        }, [
                          se("div", {
                            class: pe(["dp__cell_inner", N.classData])
                          }, [
                            P.$slots.day && c(ae)(N) ? W(P.$slots, "day", {
                              key: 0,
                              day: +N.text,
                              date: N.value
                            }) : x("", !0),
                            P.$slots.day ? x("", !0) : (w(), E(he, { key: 1 }, [
                              Ve(Te(N.text), 1)
                            ], 64)),
                            N.marker && c(ae)(N) ? (w(), E("div", {
                              key: 2,
                              class: pe(c(z)(N.marker)),
                              style: kt(N.marker.color ? { backgroundColor: N.marker.color } : {})
                            }, null, 6)) : x("", !0),
                            c(B)(N.value) ? (w(), E("div", {
                              key: 3,
                              class: "dp__marker_tooltip",
                              style: kt(l.value)
                            }, [
                              (p = N.marker) != null && p.tooltip ? (w(), E("div", {
                                key: 0,
                                class: "dp__tooltip_content",
                                onClick: S[0] || (S[0] = mt(() => {
                                }, ["stop"]))
                              }, [
                                (w(!0), E(he, null, Ae(N.marker.tooltip, (k, we) => (w(), E("div", {
                                  key: we,
                                  class: "dp__tooltip_text"
                                }, [
                                  P.$slots["marker-tooltip"] ? W(P.$slots, "marker-tooltip", {
                                    key: 0,
                                    tooltip: k,
                                    day: N.value
                                  }) : x("", !0),
                                  P.$slots["marker-tooltip"] ? x("", !0) : (w(), E(he, { key: 1 }, [
                                    se("div", {
                                      class: "dp__tooltip_mark",
                                      style: kt(k.color ? { backgroundColor: k.color } : {})
                                    }, null, 4),
                                    se("div", null, Te(k.text), 1)
                                  ], 64))
                                ]))), 128)),
                                Dv
                              ])) : x("", !0)
                            ], 4)) : x("", !0)
                          ], 2)
                        ], 40, Sv);
                      }), 128))
                    ]))), 128))
                  ], 8, Pv)) : x("", !0)
                ];
              }),
              _: 3
            }, 8, ["name", "css"])
          ], 10, wv))
        ], 4)
      ], 2);
    };
  }
}), Rv = ["aria-label", "aria-disabled"], na = /* @__PURE__ */ Ee({
  __name: "ActionIcon",
  props: {
    ariaLabel: { type: String, default: "" },
    disabled: { type: Boolean, default: !1 }
  },
  emits: ["activate", "set-ref"],
  setup(e, { emit: t }) {
    const n = L(null);
    return at(() => t("set-ref", n)), (r, a) => (w(), E("div", {
      class: "dp__month_year_col_nav",
      onClick: a[0] || (a[0] = (o) => r.$emit("activate")),
      onKeydown: [
        a[1] || (a[1] = me((o) => r.$emit("activate"), ["enter"])),
        a[2] || (a[2] = me((o) => r.$emit("activate"), ["space"]))
      ],
      tabindex: "0",
      role: "button",
      "aria-label": e.ariaLabel,
      "aria-disabled": e.disabled,
      ref_key: "elRef",
      ref: n
    }, [
      se("div", {
        class: pe(["dp__inner_nav", { dp__inner_nav_disabled: e.disabled }])
      }, [
        W(r.$slots, "default")
      ], 2)
    ], 40, Rv));
  }
}), Mv = ["onKeydown"], Nv = { class: "dp__selection_grid_header" }, Cv = ["aria-selected", "aria-disabled", "data-test", "onClick", "onKeydown", "onMouseover"], Iv = ["aria-label", "onKeydown"], Zt = /* @__PURE__ */ Ee({
  __name: "SelectionGrid",
  props: {
    items: { type: Array, default: () => [] },
    modelValue: { type: [String, Number], default: null },
    multiModelValue: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: [Number, String], default: null },
    maxValue: { type: [Number, String], default: null },
    year: { type: Number, default: 0 },
    skipActive: { type: Boolean, default: !1 },
    headerRefs: { type: Array, default: () => [] },
    skipButtonRef: { type: Boolean, default: !1 },
    monthPicker: { type: Boolean, default: !1 },
    yearPicker: { type: Boolean, default: !1 },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "selected", "toggle", "reset-flow"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setSelectionGrid: a, buildMultiLevelMatrix: o, setMonthPicker: i } = bt(), { hideNavigationButtons: s } = et(r), l = L(!1), d = L(null), g = L(null), y = L([]), f = L(), h = L(null), I = L(0), Y = L(null);
    ul(() => {
      d.value = null;
    }), at(() => {
      Yt().then(() => A()), X(), H(!0);
    }), wo(() => H(!1));
    const H = (S) => {
      var u;
      r.arrowNavigation && ((u = r.headerRefs) != null && u.length ? i(S) : a(S));
    }, X = () => {
      const S = Be(g);
      S && (r.textInput || S.focus({ preventScroll: !0 }), l.value = S.clientHeight < S.scrollHeight);
    }, z = F(
      () => ({
        dp__overlay: !0
      })
    ), B = F(() => ({
      dp__overlay_col: !0
    })), j = (S) => r.skipActive ? !1 : S.value === r.modelValue, ae = F(() => r.items.map((S) => S.filter((u) => u).map((u) => {
      var v, $, _;
      const N = r.disabledValues.some((ne) => ne === u.value) || O(u.value), G = (v = r.multiModelValue) != null && v.length ? ($ = r.multiModelValue) == null ? void 0 : $.some(
        (ne) => Se(
          ne,
          St(
            r.monthPicker ? Kt(new Date(), u.value) : new Date(),
            r.monthPicker ? r.year : u.value
          )
        )
      ) : j(u);
      return {
        ...u,
        className: {
          dp__overlay_cell_active: G,
          dp__overlay_cell: !G,
          dp__overlay_cell_disabled: N,
          dp__overlay_cell_active_disabled: N && G,
          dp__overlay_cell_pad: !0,
          dp__cell_in_between: (_ = r.multiModelValue) != null && _.length ? C(u.value) : !1
        }
      };
    }))), J = F(
      () => ({
        dp__button: !0,
        dp__overlay_action: !0,
        dp__over_action_scroll: l.value,
        dp__button_bottom: r.autoApply
      })
    ), D = F(() => {
      var S, u;
      return {
        dp__overlay_container: !0,
        dp__container_flex: ((S = r.items) == null ? void 0 : S.length) <= 6,
        dp__container_block: ((u = r.items) == null ? void 0 : u.length) > 6
      };
    }), O = (S) => {
      const u = r.maxValue || r.maxValue === 0, v = r.minValue || r.minValue === 0;
      return !u && !v ? !1 : u && v ? +S > +r.maxValue || +S < +r.minValue : u ? +S > +r.maxValue : v ? +S < +r.minValue : !1;
    }, A = () => {
      const S = Be(d), u = Be(g), v = Be(h), $ = Be(Y), _ = v ? v.getBoundingClientRect().height : 0;
      u && (I.value = u.getBoundingClientRect().height - _), S && $ && ($.scrollTop = S.offsetTop - $.offsetTop - (I.value / 2 - S.getBoundingClientRect().height) - _);
    }, V = (S) => {
      !r.disabledValues.some((u) => u === S) && !O(S) && (n("update:model-value", S), n("selected"));
    }, C = (S) => {
      const u = r.monthPicker ? r.year : S;
      return Lu(
        r.multiModelValue,
        St(
          r.monthPicker ? Kt(new Date(), f.value || 0) : new Date(),
          r.monthPicker ? u : f.value || u
        ),
        St(r.monthPicker ? Kt(new Date(), S) : new Date(), u)
      );
    }, U = () => {
      n("toggle"), n("reset-flow");
    }, K = () => {
      r.escClose && U();
    }, oe = (S, u, v, $) => {
      S && (u.value === +r.modelValue && !r.disabledValues.includes(u.value) && (d.value = S), r.arrowNavigation && (Array.isArray(y.value[v]) ? y.value[v][$] = S : y.value[v] = [S], P()));
    }, P = () => {
      var S, u;
      const v = (S = r.headerRefs) != null && S.length ? [r.headerRefs].concat(y.value) : y.value.concat([r.skipButtonRef ? [] : [h.value]]);
      o(Ue(v), (u = r.headerRefs) != null && u.length ? "monthPicker" : "selectionGrid");
    };
    return t({ focusGrid: X }), (S, u) => {
      var v;
      return w(), E("div", {
        ref_key: "gridWrapRef",
        ref: g,
        class: pe(c(z)),
        role: "dialog",
        tabindex: "0",
        onKeydown: me(K, ["esc"])
      }, [
        se("div", {
          class: pe(c(D)),
          ref_key: "containerRef",
          ref: Y,
          role: "grid",
          style: kt({ height: `${I.value}px` })
        }, [
          se("div", Nv, [
            W(S.$slots, "header")
          ]),
          S.$slots.overlay ? W(S.$slots, "overlay", { key: 0 }) : (w(!0), E(he, { key: 1 }, Ae(c(ae), ($, _) => (w(), E("div", {
            class: "dp__overlay_row",
            key: _,
            role: "row"
          }, [
            (w(!0), E(he, null, Ae($, (N, G) => (w(), E("div", {
              role: "gridcell",
              class: pe(c(B)),
              key: N.value,
              "aria-selected": N.value === e.modelValue && !e.disabledValues.includes(N.value),
              "aria-disabled": N.className.dp__overlay_cell_disabled,
              ref_for: !0,
              ref: (ne) => oe(ne, N, _, G),
              tabindex: "0",
              "data-test": N.text,
              onClick: (ne) => V(N.value),
              onKeydown: [
                me((ne) => V(N.value), ["enter"]),
                me((ne) => V(N.value), ["space"])
              ],
              onMouseover: (ne) => f.value = N.value
            }, [
              se("div", {
                class: pe(N.className)
              }, [
                S.$slots.item ? W(S.$slots, "item", {
                  key: 0,
                  item: N
                }) : x("", !0),
                S.$slots.item ? x("", !0) : (w(), E(he, { key: 1 }, [
                  Ve(Te(N.text), 1)
                ], 64))
              ], 2)
            ], 42, Cv))), 128))
          ]))), 128))
        ], 6),
        S.$slots["button-icon"] ? an((w(), E("div", {
          key: 0,
          role: "button",
          "aria-label": (v = e.ariaLabels) == null ? void 0 : v.toggleOverlay,
          class: pe(c(J)),
          tabindex: "0",
          ref_key: "toggleButton",
          ref: h,
          onClick: U,
          onKeydown: me(U, ["enter"])
        }, [
          W(S.$slots, "button-icon")
        ], 42, Iv)), [
          [on, !c(s)(e.type)]
        ]) : x("", !0)
      ], 42, Mv);
    };
  }
}), Av = ["aria-label"], fu = /* @__PURE__ */ Ee({
  __name: "RegularPicker",
  props: {
    ariaLabel: { type: String, default: "" },
    showSelectionGrid: { type: Boolean, default: !1 },
    modelValue: { type: Number, default: null },
    items: { type: Array, default: () => [] },
    disabledValues: { type: Array, default: () => [] },
    minValue: { type: Number, default: null },
    maxValue: { type: Number, default: null },
    slotName: { type: String, default: "" },
    overlaySlot: { type: String, default: "" },
    headerRefs: { type: Array, default: () => [] },
    escClose: { type: Boolean, default: !0 },
    type: { type: String, default: null },
    transitions: { type: [Object, Boolean], default: !1 },
    arrowNavigation: { type: Boolean, default: !1 },
    autoApply: { type: Boolean, default: !1 },
    textInput: { type: Boolean, default: !1 },
    ariaLabels: { type: Object, default: () => ({}) },
    hideNavigation: { type: Array, default: () => [] }
  },
  emits: ["update:model-value", "toggle", "set-ref"],
  setup(e, { emit: t }) {
    const n = e, { transitionName: r, showTransition: a } = Er(n.transitions), o = L(null);
    return at(() => t("set-ref", o)), (i, s) => (w(), E(he, null, [
      se("div", {
        class: "dp__month_year_select",
        onClick: s[0] || (s[0] = (l) => i.$emit("toggle")),
        onKeydown: [
          s[1] || (s[1] = me((l) => i.$emit("toggle"), ["enter"])),
          s[2] || (s[2] = me((l) => i.$emit("toggle"), ["space"]))
        ],
        role: "button",
        "aria-label": e.ariaLabel,
        tabindex: "0",
        ref_key: "elRef",
        ref: o
      }, [
        W(i.$slots, "default")
      ], 40, Av),
      Re(Ut, {
        name: c(r)(e.showSelectionGrid),
        css: c(a)
      }, {
        default: Q(() => [
          e.showSelectionGrid ? (w(), fe(Zt, Fe({ key: 0 }, {
            modelValue: e.modelValue,
            items: e.items,
            disabledValues: e.disabledValues,
            minValue: e.minValue,
            maxValue: e.maxValue,
            escClose: e.escClose,
            type: e.type,
            arrowNavigation: e.arrowNavigation,
            textInput: e.textInput,
            autoApply: e.autoApply,
            ariaLabels: e.ariaLabels,
            hideNavigation: e.hideNavigation
          }, {
            "header-refs": [],
            "onUpdate:modelValue": s[3] || (s[3] = (l) => i.$emit("update:model-value", l)),
            onToggle: s[4] || (s[4] = (l) => i.$emit("toggle"))
          }), Xe({
            "button-icon": Q(() => [
              i.$slots["calendar-icon"] ? W(i.$slots, "calendar-icon", { key: 0 }) : x("", !0),
              i.$slots["calendar-icon"] ? x("", !0) : (w(), fe(c(Br), { key: 1 }))
            ]),
            _: 2
          }, [
            i.$slots[e.slotName] ? {
              name: "item",
              fn: Q(({ item: l }) => [
                W(i.$slots, e.slotName, { item: l })
              ]),
              key: "0"
            } : void 0,
            i.$slots[e.overlaySlot] ? {
              name: "overlay",
              fn: Q(() => [
                W(i.$slots, e.overlaySlot)
              ]),
              key: "1"
            } : void 0,
            i.$slots[`${e.overlaySlot}-header`] ? {
              name: "header",
              fn: Q(() => [
                W(i.$slots, `${e.overlaySlot}-header`)
              ]),
              key: "2"
            } : void 0
          ]), 1040)) : x("", !0)
        ]),
        _: 3
      }, 8, ["name", "css"])
    ], 64));
  }
}), Bv = { class: "dp__month_year_row" }, Ev = { class: "dp__month_year_wrap" }, Yv = { class: "dp__month_picker_header" }, Fv = ["aria-label"], Vv = ["aria-label"], Uv = ["aria-label"], Wv = /* @__PURE__ */ Ee({
  __name: "MonthYearPicker",
  props: {
    month: { type: Number, default: 0 },
    year: { type: Number, default: 0 },
    instance: { type: Number, default: 0 },
    years: { type: Array, default: () => [] },
    months: { type: Array, default: () => [] },
    internalModelValue: { type: [Date, Array], default: null },
    ...wt
  },
  emits: ["update-month-year", "month-year-select", "mount", "reset-flow", "overlay-closed"],
  setup(e, { expose: t, emit: n }) {
    const r = e, { defaults: a } = et(r), { transitionName: o, showTransition: i } = Er(a.value.transitions), { buildMatrix: s } = bt(), { handleMonthYearChange: l, isDisabled: d, updateMonthYear: g } = iv(r, n), y = L(!1), f = L(!1), h = L([null, null, null, null]), I = L(null), Y = L(null), H = L(null);
    at(() => {
      n("mount");
    });
    const X = (p) => ({
      get: () => r[p],
      set: (k) => {
        const we = p === "month" ? "year" : "month";
        n("update-month-year", { [p]: k, [we]: r[we] }), n("month-year-select", p === "year"), p === "month" ? _(!0) : N(!0);
      }
    }), z = F(X("month")), B = F(X("year")), j = (p) => {
      const k = ke(M(p));
      return r.year === k;
    }, ae = F(() => r.monthPicker ? Array.isArray(r.disabledDates) ? r.disabledDates.map((p) => M(p)).filter((p) => j(p)).map((p) => Pe(p)) : [] : []), J = F(() => (p) => {
      const k = p === "month";
      return {
        showSelectionGrid: (k ? y : f).value,
        items: (k ? S : u).value,
        disabledValues: a.value.filters[k ? "months" : "years"].concat(ae.value),
        minValue: (k ? V : O).value,
        maxValue: (k ? C : A).value,
        headerRefs: k && r.monthPicker ? [I.value, Y.value, H.value] : [],
        escClose: r.escClose,
        transitions: a.value.transitions,
        ariaLabels: a.value.ariaLabels,
        textInput: r.textInput,
        autoApply: r.autoApply,
        arrowNavigation: r.arrowNavigation,
        hideNavigation: r.hideNavigation
      };
    }), D = F(() => (p) => ({
      month: r.month,
      year: r.year,
      items: p === "month" ? r.months : r.years,
      instance: r.instance,
      updateMonthYear: g,
      toggle: p === "month" ? _ : N
    })), O = F(() => r.minDate ? ke(M(r.minDate)) : null), A = F(() => r.maxDate ? ke(M(r.maxDate)) : null), V = F(() => {
      if (r.minDate && O.value) {
        if (O.value > r.year)
          return 12;
        if (O.value === r.year)
          return Pe(M(r.minDate));
      }
      return null;
    }), C = F(() => r.maxDate && A.value ? A.value < r.year ? -1 : A.value === r.year ? Pe(M(r.maxDate)) : null : null), U = F(() => r.range && r.internalModelValue && (r.monthPicker || r.yearPicker) ? r.internalModelValue : []), K = (p) => p.reverse(), oe = (p, k = !1) => {
      const we = [], ve = (de) => k ? K(de) : de;
      for (let de = 0; de < p.length; de += 3) {
        const De = [p[de], p[de + 1], p[de + 2]];
        we.push(ve(De));
      }
      return k ? we.reverse() : we;
    }, P = F(() => r.months.find((k) => k.value === r.month) || { text: "", value: 0 }), S = F(() => oe(r.months)), u = F(() => oe(r.years, r.reverseYears)), v = F(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === 0 : !0), $ = F(() => a.value.multiCalendars ? r.multiCalendarsSolo ? !0 : r.instance === a.value.multiCalendars - 1 : !0), _ = (p = !1) => {
      G(p), y.value = !y.value, y.value || n("overlay-closed");
    }, N = (p = !1) => {
      G(p), f.value = !f.value, f.value || n("overlay-closed");
    }, G = (p) => {
      p || n("reset-flow");
    }, ne = (p = !1) => {
      d.value(p) || n("update-month-year", {
        year: p ? r.year + 1 : r.year - 1,
        month: r.month,
        fromNav: !0
      });
    }, b = (p, k) => {
      r.arrowNavigation && (h.value[k] = Be(p), s(h.value, "monthYear"));
    };
    return t({
      toggleMonthPicker: _,
      toggleYearPicker: N
    }), (p, k) => {
      var we, ve, de, De, Qe;
      return w(), E("div", Bv, [
        p.$slots["month-year"] ? W(p.$slots, "month-year", Je(Fe({ key: 0 }, { month: e.month, year: e.year, months: e.months, years: e.years, updateMonthYear: c(g), handleMonthYearChange: c(l), instance: e.instance }))) : (w(), E(he, { key: 1 }, [
          !p.monthPicker && !p.yearPicker ? (w(), E(he, { key: 0 }, [
            c(v) && !p.vertical ? (w(), fe(na, {
              key: 0,
              "aria-label": (we = c(a).ariaLabels) == null ? void 0 : we.prevMonth,
              disabled: c(d)(!1),
              onActivate: k[0] || (k[0] = (ce) => c(l)(!1)),
              onSetRef: k[1] || (k[1] = (ce) => b(ce, 0))
            }, {
              default: Q(() => [
                p.$slots["arrow-left"] ? W(p.$slots, "arrow-left", { key: 0 }) : x("", !0),
                p.$slots["arrow-left"] ? x("", !0) : (w(), fe(c(Ki), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : x("", !0),
            se("div", Ev, [
              Re(fu, Fe({
                type: "month",
                "slot-name": "month-overlay-val",
                "overlay-slot": "overlay-month",
                "aria-label": (ve = c(a).ariaLabels) == null ? void 0 : ve.openMonthsOverlay,
                modelValue: c(z),
                "onUpdate:modelValue": k[2] || (k[2] = (ce) => We(z) ? z.value = ce : null)
              }, c(J)("month"), {
                onToggle: _,
                onSetRef: k[3] || (k[3] = (ce) => b(ce, 1))
              }), Xe({
                default: Q(() => [
                  p.$slots.month ? W(p.$slots, "month", Je(Fe({ key: 0 }, c(P)))) : x("", !0),
                  p.$slots.month ? x("", !0) : (w(), E(he, { key: 1 }, [
                    Ve(Te(c(P).text), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                p.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: Q(() => [
                    W(p.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                p.$slots["month-overlay-value"] ? {
                  name: "month-overlay-val",
                  fn: Q(({ item: ce }) => [
                    W(p.$slots, "month-overlay-value", {
                      text: ce.text,
                      value: ce.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                p.$slots["month-overlay"] ? {
                  name: "overlay-month",
                  fn: Q(() => [
                    W(p.$slots, "month-overlay", Je(yt(c(D)("month"))))
                  ]),
                  key: "2"
                } : void 0,
                p.$slots["month-overlay-header"] ? {
                  name: "overlay-month-header",
                  fn: Q(() => [
                    W(p.$slots, "month-overlay-header", { toggle: _ })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"]),
              Re(fu, Fe({
                type: "year",
                "slot-name": "year-overlay-val",
                "overlay-slot": "overlay-year",
                "aria-label": (de = c(a).ariaLabels) == null ? void 0 : de.openYearsOverlay,
                modelValue: c(B),
                "onUpdate:modelValue": k[4] || (k[4] = (ce) => We(B) ? B.value = ce : null)
              }, c(J)("year"), {
                onToggle: N,
                onSetRef: k[5] || (k[5] = (ce) => b(ce, 2))
              }), Xe({
                default: Q(() => [
                  p.$slots.year ? W(p.$slots, "year", {
                    key: 0,
                    year: e.year
                  }) : x("", !0),
                  p.$slots.year ? x("", !0) : (w(), E(he, { key: 1 }, [
                    Ve(Te(e.year), 1)
                  ], 64))
                ]),
                _: 2
              }, [
                p.$slots["calendar-icon"] ? {
                  name: "calendar-icon",
                  fn: Q(() => [
                    W(p.$slots, "calendar-icon")
                  ]),
                  key: "0"
                } : void 0,
                p.$slots["year-overlay-value"] ? {
                  name: "year-overlay-val",
                  fn: Q(({ item: ce }) => [
                    W(p.$slots, "year-overlay-value", {
                      text: ce.text,
                      value: ce.value
                    })
                  ]),
                  key: "1"
                } : void 0,
                p.$slots["year-overlay"] ? {
                  name: "overlay-year",
                  fn: Q(() => [
                    W(p.$slots, "year-overlay", Je(yt(c(D)("year"))))
                  ]),
                  key: "2"
                } : void 0,
                p.$slots["year-overlay-header"] ? {
                  name: "overlay-year-header",
                  fn: Q(() => [
                    W(p.$slots, "year-overlay-header", { toggle: N })
                  ]),
                  key: "3"
                } : void 0
              ]), 1040, ["aria-label", "modelValue"])
            ]),
            c(v) && p.vertical ? (w(), fe(na, {
              key: 1,
              "aria-label": (De = c(a).ariaLabels) == null ? void 0 : De.prevMonth,
              disabled: c(d)(!1),
              onActivate: k[6] || (k[6] = (ce) => c(l)(!1))
            }, {
              default: Q(() => [
                p.$slots["arrow-up"] ? W(p.$slots, "arrow-up", { key: 0 }) : x("", !0),
                p.$slots["arrow-up"] ? x("", !0) : (w(), fe(c(Uu), { key: 1 }))
              ]),
              _: 3
            }, 8, ["aria-label", "disabled"])) : x("", !0),
            c($) ? (w(), fe(na, {
              key: 2,
              ref: "rightIcon",
              disabled: c(d)(!0),
              "aria-label": (Qe = c(a).ariaLabels) == null ? void 0 : Qe.nextMonth,
              onActivate: k[7] || (k[7] = (ce) => c(l)(!0)),
              onSetRef: k[8] || (k[8] = (ce) => b(ce, 3))
            }, {
              default: Q(() => [
                p.$slots[p.vertical ? "arrow-down" : "arrow-right"] ? W(p.$slots, p.vertical ? "arrow-down" : "arrow-right", { key: 0 }) : x("", !0),
                p.$slots[p.vertical ? "arrow-down" : "arrow-right"] ? x("", !0) : (w(), fe(il(p.vertical ? c(Wu) : c(Zi)), { key: 1 }))
              ]),
              _: 3
            }, 8, ["disabled", "aria-label"])) : x("", !0)
          ], 64)) : x("", !0),
          p.monthPicker ? (w(), fe(Zt, Fe({ key: 1 }, c(J)("month"), {
            "skip-active": p.range,
            year: e.year,
            "multi-model-value": c(U),
            "month-picker": "",
            modelValue: c(z),
            "onUpdate:modelValue": k[17] || (k[17] = (ce) => We(z) ? z.value = ce : null),
            onToggle: _,
            onSelected: k[18] || (k[18] = (ce) => p.$emit("overlay-closed"))
          }), Xe({
            header: Q(() => {
              var ce, nt, Ke;
              return [
                se("div", Yv, [
                  se("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpPrevIconRef",
                    ref: I,
                    onClick: k[9] || (k[9] = (ee) => ne(!1)),
                    onKeydown: k[10] || (k[10] = me((ee) => ne(!1), ["enter"]))
                  }, [
                    se("div", {
                      class: pe(["dp__inner_nav", { dp__inner_nav_disabled: c(d)(!1) }]),
                      role: "button",
                      "aria-label": (ce = c(a).ariaLabels) == null ? void 0 : ce.prevMonth
                    }, [
                      p.$slots["arrow-left"] ? W(p.$slots, "arrow-left", { key: 0 }) : x("", !0),
                      p.$slots["arrow-left"] ? x("", !0) : (w(), fe(c(Ki), { key: 1 }))
                    ], 10, Fv)
                  ], 544),
                  se("div", {
                    class: "dp__pointer",
                    role: "button",
                    ref_key: "mpYearButtonRef",
                    ref: Y,
                    "aria-label": (nt = c(a).ariaLabels) == null ? void 0 : nt.openYearsOverlay,
                    tabindex: "0",
                    onClick: k[11] || (k[11] = () => N(!1)),
                    onKeydown: k[12] || (k[12] = me(() => N(!1), ["enter"]))
                  }, [
                    p.$slots.year ? W(p.$slots, "year", {
                      key: 0,
                      year: e.year
                    }) : x("", !0),
                    p.$slots.year ? x("", !0) : (w(), E(he, { key: 1 }, [
                      Ve(Te(e.year), 1)
                    ], 64))
                  ], 40, Vv),
                  se("div", {
                    class: "dp__month_year_col_nav",
                    tabindex: "0",
                    ref_key: "mpNextIconRef",
                    ref: H,
                    onClick: k[13] || (k[13] = (ee) => ne(!0)),
                    onKeydown: k[14] || (k[14] = me((ee) => ne(!0), ["enter"]))
                  }, [
                    se("div", {
                      class: pe(["dp__inner_nav", { dp__inner_nav_disabled: c(d)(!0) }]),
                      role: "button",
                      "aria-label": (Ke = c(a).ariaLabels) == null ? void 0 : Ke.nextMonth
                    }, [
                      p.$slots["arrow-right"] ? W(p.$slots, "arrow-right", { key: 0 }) : x("", !0),
                      p.$slots["arrow-right"] ? x("", !0) : (w(), fe(c(Zi), { key: 1 }))
                    ], 10, Uv)
                  ], 544)
                ]),
                Re(Ut, {
                  name: c(o)(f.value),
                  css: c(i)
                }, {
                  default: Q(() => [
                    f.value ? (w(), fe(Zt, Fe({ key: 0 }, c(J)("year"), {
                      modelValue: c(B),
                      "onUpdate:modelValue": k[15] || (k[15] = (ee) => We(B) ? B.value = ee : null),
                      onToggle: N,
                      onSelected: k[16] || (k[16] = (ee) => p.$emit("overlay-closed"))
                    }), Xe({
                      "button-icon": Q(() => [
                        p.$slots["calendar-icon"] ? W(p.$slots, "calendar-icon", { key: 0 }) : x("", !0),
                        p.$slots["calendar-icon"] ? x("", !0) : (w(), fe(c(Br), { key: 1 }))
                      ]),
                      _: 2
                    }, [
                      p.$slots["year-overlay-value"] ? {
                        name: "item",
                        fn: Q(({ item: ee }) => [
                          W(p.$slots, "year-overlay-value", {
                            text: ee.text,
                            value: ee.value
                          })
                        ]),
                        key: "0"
                      } : void 0
                    ]), 1040, ["modelValue"])) : x("", !0)
                  ]),
                  _: 3
                }, 8, ["name", "css"])
              ];
            }),
            _: 2
          }, [
            p.$slots["month-overlay-value"] ? {
              name: "item",
              fn: Q(({ item: ce }) => [
                W(p.$slots, "month-overlay-value", {
                  text: ce.text,
                  value: ce.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["skip-active", "year", "multi-model-value", "modelValue"])) : x("", !0),
          p.yearPicker ? (w(), fe(Zt, Fe({ key: 2 }, c(J)("year"), {
            modelValue: c(B),
            "onUpdate:modelValue": k[19] || (k[19] = (ce) => We(B) ? B.value = ce : null),
            "multi-model-value": c(U),
            "skip-active": p.range,
            "skip-button-ref": "",
            "year-picker": "",
            onToggle: N,
            onSelected: k[20] || (k[20] = (ce) => p.$emit("overlay-closed"))
          }), Xe({ _: 2 }, [
            p.$slots["year-overlay-value"] ? {
              name: "item",
              fn: Q(({ item: ce }) => [
                W(p.$slots, "year-overlay-value", {
                  text: ce.text,
                  value: ce.value
                })
              ]),
              key: "0"
            } : void 0
          ]), 1040, ["modelValue", "multi-model-value", "skip-active"])) : x("", !0)
        ], 64))
      ]);
    };
  }
}), Lv = {
  key: 0,
  class: "dp__time_input"
}, Hv = ["aria-label", "onKeydown", "onClick"], jv = ["aria-label", "data-test", "onKeydown", "onClick"], qv = ["aria-label", "onKeydown", "onClick"], zv = { key: 0 }, Gv = ["aria-label", "onKeydown"], Qv = /* @__PURE__ */ Ee({
  __name: "TimeInput",
  props: {
    hours: { type: Number, default: 0 },
    minutes: { type: Number, default: 0 },
    seconds: { type: Number, default: 0 },
    closeTimePickerBtn: { type: Object, default: null },
    order: { type: Number, default: 0 },
    ...wt
  },
  emits: [
    "set-hours",
    "set-minutes",
    "update:hours",
    "update:minutes",
    "update:seconds",
    "reset-flow",
    "mounted",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setTimePickerElements: a, setTimePickerBackRef: o } = bt(), { defaults: i } = et(r), { transitionName: s, showTransition: l } = Er(i.value.transitions), d = Xt({
      hours: !1,
      minutes: !1,
      seconds: !1
    }), g = L("AM"), y = L(null), f = L([]);
    at(() => {
      n("mounted");
    });
    const h = F(() => (u) => !!(r.maxTime && r.maxTime[u] && r.maxTime[u] < r[u] + +r[`${u}Increment`])), I = F(() => (u) => !!(r.minTime && r.minTime[u] && r.minTime[u] > r[u] - +r[`${u}Increment`])), Y = (u, v) => gu(qe(M(), u), v), H = (u, v) => xm(qe(M(), u), v), X = F(
      () => ({
        dp__time_col: !0,
        dp__time_col_reg: !r.enableSeconds && r.is24,
        dp__time_col_reg_with_button: !r.enableSeconds && !r.is24,
        dp__time_col_sec: r.enableSeconds && r.is24,
        dp__time_col_sec_with_button: r.enableSeconds && !r.is24
      })
    ), z = F(() => {
      const u = [{ type: "hours" }, { type: "", separator: !0 }, { type: "minutes" }];
      return r.enableSeconds ? u.concat([{ type: "", separator: !0 }, { type: "seconds" }]) : u;
    }), B = F(() => z.value.filter((u) => !u.separator)), j = F(() => (u) => {
      if (u === "hours") {
        const v = U(r.hours);
        return { text: v < 10 ? `0${v}` : `${v}`, value: v };
      }
      return { text: r[u] < 10 ? `0${r[u]}` : `${r[u]}`, value: r[u] };
    }), ae = (u) => {
      const v = r.is24 ? 24 : 12, $ = u === "hours" ? v : 60, _ = +r[`${u}GridIncrement`], N = u === "hours" && !r.is24 ? _ : 0, G = [];
      for (let ne = N; ne < $; ne += _)
        G.push({ value: ne, text: ne < 10 ? `0${ne}` : `${ne}` });
      return u === "hours" && !r.is24 && G.push({ value: 0, text: "12" }), qp(G);
    }, J = (u, v) => {
      const $ = r.minTime && r.minTime[v], _ = r.maxTime && r.maxTime[v];
      return $ && _ ? u < $ || u > _ : $ ? u < $ : _ ? u > _ : !1;
    }, D = F(() => (u) => ae(u).flat().map((v) => v.value).filter((v) => J(v, u))), O = (u) => r[`no${u[0].toUpperCase() + u.slice(1)}Overlay`], A = (u) => {
      O(u) || (d[u] = !d[u], d[u] || n("overlay-closed"));
    }, V = (u) => u === "hours" ? ft : u === "minutes" ? dt : Vt, C = (u, v = !0) => {
      const $ = v ? Y : H;
      (v ? h.value(u) : I.value(u)) || n(
        `update:${u}`,
        V(u)($({ [u]: +r[u] }, { [u]: +r[`${u}Increment`] }))
      );
    }, U = (u) => r.is24 ? u : (u >= 12 ? g.value = "PM" : g.value = "AM", Kp(u)), K = () => {
      g.value === "PM" ? (g.value = "AM", n("update:hours", r.hours - 12)) : (g.value = "PM", n("update:hours", r.hours + 12));
    }, oe = (u) => {
      d[u] = !0;
    }, P = (u, v, $) => {
      if (u && r.arrowNavigation) {
        Array.isArray(f.value[v]) ? f.value[v][$] = u : f.value[v] = [u];
        const _ = f.value.reduce(
          (N, G) => G.map((ne, b) => [...N[b] || [], G[b]]),
          []
        );
        o(r.closeTimePickerBtn), y.value && (_[1] = _[1].concat(y.value)), a(_, r.order);
      }
    }, S = (u, v) => u === "hours" && !r.is24 ? n(`update:${u}`, g.value === "PM" ? v + 12 : v) : n(`update:${u}`, v);
    return t({ openChildCmp: oe }), (u, v) => {
      var $;
      return u.disabled ? x("", !0) : (w(), E("div", Lv, [
        (w(!0), E(he, null, Ae(c(z), (_, N) => {
          var G, ne, b;
          return w(), E("div", {
            key: N,
            class: pe(c(X))
          }, [
            _.separator ? (w(), E(he, { key: 0 }, [
              Ve(" : ")
            ], 64)) : (w(), E(he, { key: 1 }, [
              se("div", {
                class: pe({
                  dp__inc_dec_button: !0,
                  dp__inc_dec_button_disabled: c(h)(_.type)
                }),
                role: "button",
                "data-test": "time-inc-btn",
                "aria-label": (G = c(i).ariaLabels) == null ? void 0 : G.incrementValue(_.type),
                tabindex: "0",
                onKeydown: [
                  me((p) => C(_.type), ["enter"]),
                  me((p) => C(_.type), ["space"])
                ],
                onClick: (p) => C(_.type),
                ref_for: !0,
                ref: (p) => P(p, N, 0)
              }, [
                u.$slots["arrow-up"] ? W(u.$slots, "arrow-up", { key: 0 }) : x("", !0),
                u.$slots["arrow-up"] ? x("", !0) : (w(), fe(c(Uu), { key: 1 }))
              ], 42, Hv),
              se("div", {
                role: "button",
                "aria-label": (ne = c(i).ariaLabels) == null ? void 0 : ne.openTpOverlay(_.type),
                class: pe(O(_.type) ? "" : "dp__time_display"),
                tabindex: "0",
                "data-test": `${_.type}-toggle-overlay-btn`,
                onKeydown: [
                  me((p) => A(_.type), ["enter"]),
                  me((p) => A(_.type), ["space"])
                ],
                onClick: (p) => A(_.type),
                ref_for: !0,
                ref: (p) => P(p, N, 1)
              }, [
                u.$slots[_.type] ? W(u.$slots, _.type, {
                  key: 0,
                  text: c(j)(_.type).text,
                  value: c(j)(_.type).value
                }) : x("", !0),
                u.$slots[_.type] ? x("", !0) : (w(), E(he, { key: 1 }, [
                  Ve(Te(c(j)(_.type).text), 1)
                ], 64))
              ], 42, jv),
              se("div", {
                class: pe({
                  dp__inc_dec_button: !0,
                  dp__inc_dec_button_disabled: c(I)(_.type)
                }),
                role: "button",
                "data-test": "time-dec-btn",
                "aria-label": (b = c(i).ariaLabels) == null ? void 0 : b.decrementValue(_.type),
                tabindex: "0",
                onKeydown: [
                  me((p) => C(_.type, !1), ["enter"]),
                  me((p) => C(_.type, !1), ["space"])
                ],
                onClick: (p) => C(_.type, !1),
                ref_for: !0,
                ref: (p) => P(p, N, 2)
              }, [
                u.$slots["arrow-down"] ? W(u.$slots, "arrow-down", { key: 0 }) : x("", !0),
                u.$slots["arrow-down"] ? x("", !0) : (w(), fe(c(Wu), { key: 1 }))
              ], 42, qv)
            ], 64))
          ], 2);
        }), 128)),
        u.is24 ? x("", !0) : (w(), E("div", zv, [
          u.$slots["am-pm-button"] ? W(u.$slots, "am-pm-button", {
            key: 0,
            toggle: K,
            value: g.value
          }) : x("", !0),
          u.$slots["am-pm-button"] ? x("", !0) : (w(), E("button", {
            key: 1,
            ref_key: "amPmButton",
            ref: y,
            type: "button",
            class: "dp__pm_am_button",
            role: "button",
            "aria-label": ($ = c(i).ariaLabels) == null ? void 0 : $.amPmButton,
            tabindex: "0",
            onClick: K,
            onKeydown: [
              me(mt(K, ["prevent"]), ["enter"]),
              me(mt(K, ["prevent"]), ["space"])
            ]
          }, Te(g.value), 41, Gv))
        ])),
        (w(!0), E(he, null, Ae(c(B), (_, N) => (w(), fe(Ut, {
          key: N,
          name: c(s)(d[_.type]),
          css: c(l)
        }, {
          default: Q(() => [
            d[_.type] ? (w(), fe(Zt, {
              key: 0,
              items: ae(_.type),
              "disabled-values": c(i).filters.times[_.type].concat(c(D)(_.type)),
              "esc-close": u.escClose,
              "aria-labels": c(i).ariaLabels,
              "hide-navigation": u.hideNavigation,
              "onUpdate:modelValue": (G) => S(_.type, G),
              onSelected: (G) => A(_.type),
              onToggle: (G) => A(_.type),
              onResetFlow: v[0] || (v[0] = (G) => u.$emit("reset-flow")),
              type: _.type
            }, Xe({
              "button-icon": Q(() => [
                u.$slots["clock-icon"] ? W(u.$slots, "clock-icon", { key: 0 }) : x("", !0),
                u.$slots["clock-icon"] ? x("", !0) : (w(), fe(c(Vu), { key: 1 }))
              ]),
              _: 2
            }, [
              u.$slots[`${_.type}-overlay-value`] ? {
                name: "item",
                fn: Q(({ item: G }) => [
                  W(u.$slots, `${_.type}-overlay-value`, {
                    text: G.text,
                    value: G.value
                  })
                ]),
                key: "0"
              } : void 0
            ]), 1032, ["items", "disabled-values", "esc-close", "aria-labels", "hide-navigation", "onUpdate:modelValue", "onSelected", "onToggle", "type"])) : x("", !0)
          ]),
          _: 2
        }, 1032, ["name", "css"]))), 128))
      ]));
    };
  }
}), Kv = ["aria-label"], Zv = { class: "dp__overlay_container dp__container_flex dp__time_picker_overlay_container" }, Xv = {
  key: 1,
  class: "dp__overlay_row"
}, Jv = ["aria-label"], eh = /* @__PURE__ */ Ee({
  __name: "TimePicker",
  props: {
    hours: { type: [Number, Array], default: 0 },
    minutes: { type: [Number, Array], default: 0 },
    seconds: { type: [Number, Array], default: 0 },
    internalModelValue: { type: [Date, Array], default: null },
    ...wt
  },
  emits: [
    "update:hours",
    "update:minutes",
    "update:seconds",
    "mount",
    "reset-flow",
    "overlay-closed"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { buildMatrix: a, setTimePicker: o } = bt(), i = bo(), { hideNavigationButtons: s, defaults: l } = et(r), { transitionName: d, showTransition: g } = Er(l.value.transitions), y = L(null), f = L(null), h = L([]), I = L(null);
    at(() => {
      n("mount"), !r.timePicker && r.arrowNavigation ? a([Be(y.value)], "time") : o(!0, r.timePicker);
    });
    const Y = F(() => r.range && r.modelAuto ? zu(r.internalModelValue) : !0), H = L(!1), X = (C) => ({
      hours: Array.isArray(r.hours) ? r.hours[C] : r.hours,
      minutes: Array.isArray(r.minutes) ? r.minutes[C] : r.minutes,
      seconds: Array.isArray(r.seconds) ? r.seconds[C] : r.seconds
    }), z = F(() => {
      const C = [];
      if (r.range)
        for (let U = 0; U < 2; U++)
          C.push(X(U));
      else
        C.push(X(0));
      return C;
    }), B = (C, U = !1, K = "") => {
      U || n("reset-flow"), H.value = C, r.arrowNavigation && (o(C), C || n("overlay-closed")), Yt(() => {
        K !== "" && h.value[0] && h.value[0].openChildCmp(K);
      });
    }, j = F(() => ({
      dp__button: !0,
      dp__button_bottom: r.autoApply
    })), ae = Tt(i, "timePicker"), J = (C, U, K) => r.range ? U === 0 ? [C, z.value[1][K]] : [z.value[0][K], C] : C, D = (C) => {
      n("update:hours", C);
    }, O = (C) => {
      n("update:minutes", C);
    }, A = (C) => {
      n("update:seconds", C);
    }, V = () => {
      I.value && r.arrowNavigation && I.value.focus({ preventScroll: !0 });
    };
    return t({ toggleTimePicker: B }), (C, U) => {
      var K;
      return w(), E("div", null, [
        C.timePicker ? x("", !0) : an((w(), E("div", {
          key: 0,
          class: pe(c(j)),
          role: "button",
          "aria-label": (K = c(l).ariaLabels) == null ? void 0 : K.openTimePicker,
          tabindex: "0",
          "data-test": "open-time-picker-btn",
          ref_key: "openTimePickerBtn",
          ref: y,
          onKeydown: [
            U[0] || (U[0] = me((oe) => B(!0), ["enter"])),
            U[1] || (U[1] = me((oe) => B(!0), ["space"]))
          ],
          onClick: U[2] || (U[2] = (oe) => B(!0))
        }, [
          C.$slots["clock-icon"] ? W(C.$slots, "clock-icon", { key: 0 }) : x("", !0),
          C.$slots["clock-icon"] ? x("", !0) : (w(), fe(c(Vu), { key: 1 }))
        ], 42, Kv)), [
          [on, !c(s)("time")]
        ]),
        Re(Ut, {
          name: c(d)(H.value),
          css: c(g)
        }, {
          default: Q(() => {
            var oe;
            return [
              H.value || C.timePicker ? (w(), E("div", {
                key: 0,
                class: "dp__overlay",
                ref_key: "overlayRef",
                ref: I,
                tabindex: "0"
              }, [
                se("div", Zv, [
                  C.$slots["time-picker-overlay"] ? W(C.$slots, "time-picker-overlay", {
                    key: 0,
                    hours: e.hours,
                    minutes: e.minutes,
                    seconds: e.seconds,
                    setHours: D,
                    setMinutes: O,
                    setSeconds: A
                  }) : x("", !0),
                  C.$slots["time-picker-overlay"] ? x("", !0) : (w(), E("div", Xv, [
                    (w(!0), E(he, null, Ae(c(z), (P, S) => an((w(), fe(Qv, Fe({ key: S }, {
                      ...C.$props,
                      order: S,
                      hours: P.hours,
                      minutes: P.minutes,
                      seconds: P.seconds,
                      closeTimePickerBtn: f.value,
                      disabled: S === 0 ? C.fixedStart : C.fixedEnd
                    }, {
                      ref_for: !0,
                      ref_key: "timeInputRefs",
                      ref: h,
                      "onUpdate:hours": (u) => D(J(u, S, "hours")),
                      "onUpdate:minutes": (u) => O(J(u, S, "minutes")),
                      "onUpdate:seconds": (u) => A(J(u, S, "seconds")),
                      onMounted: V,
                      onOverlayClosed: V
                    }), Xe({ _: 2 }, [
                      Ae(c(ae), (u, v) => ({
                        name: u,
                        fn: Q(($) => [
                          W(C.$slots, u, Je(yt($)))
                        ])
                      }))
                    ]), 1040, ["onUpdate:hours", "onUpdate:minutes", "onUpdate:seconds"])), [
                      [on, S === 0 ? !0 : c(Y)]
                    ])), 128))
                  ])),
                  C.timePicker ? x("", !0) : an((w(), E("div", {
                    key: 2,
                    ref_key: "closeTimePickerBtn",
                    ref: f,
                    class: pe(c(j)),
                    role: "button",
                    "aria-label": (oe = c(l).ariaLabels) == null ? void 0 : oe.closeTimePicker,
                    tabindex: "0",
                    onKeydown: [
                      U[3] || (U[3] = me((P) => B(!1), ["enter"])),
                      U[4] || (U[4] = me((P) => B(!1), ["space"]))
                    ],
                    onClick: U[5] || (U[5] = (P) => B(!1))
                  }, [
                    C.$slots["calendar-icon"] ? W(C.$slots, "calendar-icon", { key: 0 }) : x("", !0),
                    C.$slots["calendar-icon"] ? x("", !0) : (w(), fe(c(Br), { key: 1 }))
                  ], 42, Jv)), [
                    [on, !c(s)("time")]
                  ])
                ])
              ], 512)) : x("", !0)
            ];
          }),
          _: 3
        }, 8, ["name", "css"])
      ]);
    };
  }
}), th = (e, t) => {
  const { isDisabled: n, matchDate: r, getWeekFromDate: a } = et(t), o = L(null), i = L(M()), s = (u) => {
    !u.current && t.hideOffsetDates || (o.value = u.value);
  }, l = () => {
    o.value = null;
  }, d = (u) => Array.isArray(e.value) && t.range && e.value[0] && o.value ? u ? Ge(o.value, e.value[0]) : Le(o.value, e.value[0]) : !0, g = (u, v) => {
    const $ = () => e.value ? v ? e.value[0] || null : e.value[1] : null, _ = e.value && Array.isArray(e.value) ? $() : null;
    return Se(M(u.value), _);
  }, y = (u) => {
    const v = Array.isArray(e.value) ? e.value[0] : null;
    return u ? !Le(o.value || null, v) : !0;
  }, f = (u, v = !0) => (t.range || t.weekPicker) && Array.isArray(e.value) ? t.hideOffsetDates && !u.current ? !1 : Se(M(u.value), e.value[v ? 0 : 1]) : t.range ? g(u, v) && y(v) || Se(u.value, Array.isArray(e.value) ? e.value[0] : null) && d(v) : !1, h = (u, v, $) => Array.isArray(e.value) && e.value[0] && e.value.length === 1 ? u ? !1 : $ ? Ge(e.value[0], v.value) : Le(e.value[0], v.value) : !1, I = (u) => !e.value || t.hideOffsetDates && !u.current ? !1 : t.range ? t.modelAuto && Array.isArray(e.value) ? Se(u.value, e.value[0] ? e.value[0] : i.value) : !1 : t.multiDates && Array.isArray(e.value) ? e.value.some((v) => Se(v, u.value)) : Se(u.value, e.value ? e.value : i.value), Y = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const v = vt(o.value, +t.autoRange), $ = a(M(o.value));
        return t.weekPicker ? Se($[1], M(u.value)) : Se(v, M(u.value));
      }
      return !1;
    }
    return !1;
  }, H = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        const v = vt(o.value, +t.autoRange);
        if (t.hideOffsetDates && !u.current)
          return !1;
        const $ = a(M(o.value));
        return t.weekPicker ? Ge(u.value, $[0]) && Le(u.value, $[1]) : Ge(u.value, o.value) && Le(u.value, v);
      }
      return !1;
    }
    return !1;
  }, X = (u) => {
    if (t.autoRange || t.weekPicker) {
      if (o.value) {
        if (t.hideOffsetDates && !u.current)
          return !1;
        const v = a(M(o.value));
        return t.weekPicker ? Se(v[0], u.value) : Se(o.value, u.value);
      }
      return !1;
    }
    return !1;
  }, z = (u) => Lu(e.value, o.value, u.value), B = () => t.modelAuto && Array.isArray(t.internalModelValue) ? !!t.internalModelValue[0] : !1, j = () => t.modelAuto ? zu(t.internalModelValue) : !0, ae = (u) => {
    if (Array.isArray(e.value) && e.value.length || t.weekPicker)
      return !1;
    const v = t.range ? !f(u) && !f(u, !1) : !0;
    return !n(u.value) && !I(u) && !(!u.current && t.hideOffsetDates) && v;
  }, J = (u) => t.range ? t.modelAuto ? B() && I(u) : !1 : I(u), D = (u) => t.highlight ? r(u.value, t.highlight) : !1, O = (u) => n(u.value) && t.highlightDisabledDays === !1, A = (u) => t.highlightWeekDays && t.highlightWeekDays.includes(u.value.getDay()), V = (u) => (t.range || t.weekPicker) && (!(t.multiCalendars > 0) || u.current) && j() && !(!u.current && t.hideOffsetDates) && !I(u) ? z(u) : !1, C = (u) => ({
    dp__cell_offset: !u.current,
    dp__pointer: !t.disabled && !(!u.current && t.hideOffsetDates) && !n(u.value),
    dp__cell_disabled: n(u.value),
    dp__cell_highlight: !O(u) && (D(u) || A(u)) && !J(u),
    dp__cell_highlight_active: !O(u) && (D(u) || A(u)) && J(u),
    dp__today: !t.noToday && Se(u.value, i.value) && u.current
  }), U = (u) => ({
    dp__active_date: J(u),
    dp__date_hover: ae(u)
  }), K = (u) => ({
    ...oe(u),
    ...P(u),
    dp__range_between_week: V(u) && t.weekPicker
  }), oe = (u) => ({
    dp__range_start: t.multiCalendars > 0 ? u.current && f(u) && j() : f(u) && j(),
    dp__range_end: t.multiCalendars > 0 ? u.current && f(u, !1) && j() : f(u, !1) && j(),
    dp__range_between: V(u) && !t.weekPicker,
    dp__date_hover_start: h(ae(u), u, !0),
    dp__date_hover_end: h(ae(u), u, !1)
  }), P = (u) => ({
    ...oe(u),
    dp__cell_auto_range: H(u),
    dp__cell_auto_range_start: X(u),
    dp__cell_auto_range_end: Y(u)
  }), S = (u) => t.range ? t.autoRange ? P(u) : t.modelAuto ? { ...U(u), ...oe(u) } : oe(u) : t.weekPicker ? K(u) : U(u);
  return {
    setHoverDate: s,
    clearHoverDate: l,
    getDayClassData: (u) => ({
      ...C(u),
      ...S(u),
      [t.dayClass ? t.dayClass(u.value) : ""]: !0,
      [t.calendarCellClassName]: !!t.calendarCellClassName
    })
  };
}, nh = ["id", "onKeydown"], rh = {
  key: 0,
  class: "dp__sidebar_left"
}, ah = {
  key: 1,
  class: "dp__preset_ranges"
}, oh = ["onClick"], ih = {
  key: 2,
  class: "dp__sidebar_right"
}, uh = {
  key: 3,
  class: "dp__now_wrap"
}, lh = /* @__PURE__ */ Ee({
  __name: "DatepickerMenu",
  props: {
    openOnTop: { type: Boolean, default: !1 },
    internalModelValue: { type: [Date, Array], default: null },
    ...wt
  },
  emits: [
    "close-picker",
    "select-date",
    "auto-apply",
    "time-update",
    "flow-step",
    "update-month-year",
    "invalid-select",
    "update:internal-model-value",
    "recalculate-position",
    "invalid-fixed-range",
    "tooltip-open",
    "tooltip-close"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, { setMenuFocused: a, setShiftKey: o, control: i } = Hu(), { getCalendarDays: s, defaults: l } = et(r), d = bo(), g = L(null), y = Xt({
      timePicker: !!(!r.enableTimePicker || r.timePicker || r.monthPicker),
      monthYearInput: !!r.timePicker,
      calendar: !1
    }), f = L([]), h = L([]), I = L(null), Y = L(null), H = L(0), X = L(!1), z = L(0);
    at(() => {
      var T;
      X.value = !0, !((T = r.presetRanges) != null && T.length) && !d["left-sidebar"] && !d["right-sidebar"] && _e();
      const q = Be(Y);
      if (q && !r.textInput && !r.inline && (a(!0), O()), q) {
        const He = (Ze) => {
          Object.keys(d).length || Ze.preventDefault(), Ze.stopImmediatePropagation(), Ze.stopPropagation();
        };
        q.addEventListener("pointerdown", He), q.addEventListener("mousedown", He);
      }
      window.addEventListener("resize", _e);
    }), wo(() => {
      window.removeEventListener("resize", _e);
    });
    const { arrowRight: B, arrowLeft: j, arrowDown: ae, arrowUp: J } = bt(), D = (T) => {
      T || T === 0 ? h.value[T].triggerTransition(
        K.value(T),
        oe.value(T)
      ) : h.value.forEach(
        (q, He) => q.triggerTransition(K.value(He), oe.value(He))
      );
    }, O = () => {
      const T = Be(Y);
      T && T.focus({ preventScroll: !0 });
    }, A = () => {
      var T;
      (T = r.flow) != null && T.length && z.value !== -1 && (z.value += 1, n("flow-step", z.value), Oe());
    }, V = () => {
      z.value = -1;
    }, {
      calendars: C,
      modelValue: U,
      month: K,
      year: oe,
      time: P,
      updateTime: S,
      updateMonthYear: u,
      selectDate: v,
      getWeekNum: $,
      monthYearSelect: _,
      handleScroll: N,
      handleArrow: G,
      handleSwipe: ne,
      getMarker: b,
      selectCurrentDate: p,
      presetDateRange: k
    } = av(r, n, A, D, z), { setHoverDate: we, clearHoverDate: ve, getDayClassData: de } = th(U, r);
    Dt(
      C,
      () => {
        r.openOnTop && setTimeout(() => {
          n("recalculate-position");
        }, 0);
      },
      { deep: !0 }
    );
    const De = Tt(d, "calendar"), Qe = Tt(d, "action"), ce = Tt(d, "timePicker"), nt = Tt(d, "monthYear"), Ke = F(() => r.openOnTop ? "dp__arrow_bottom" : "dp__arrow_top"), ee = F(() => Gp(r.yearRange)), Me = F(() => Qp(r.locale, r.monthNameFormat)), _e = () => {
      const T = Be(g);
      T && (H.value = T.getBoundingClientRect().width);
    }, _t = F(() => (T) => s(K.value(T), oe.value(T))), rt = F(
      () => l.value.multiCalendars > 0 && r.range ? [...Array(l.value.multiCalendars).keys()] : [0]
    ), Wt = F(
      () => (T) => T === 1
    ), Yr = F(() => r.monthPicker || r.timePicker || r.yearPicker), Fr = F(
      () => ({
        dp__flex_display: l.value.multiCalendars > 0
      })
    ), Jt = F(() => ({
      dp__instance_calendar: l.value.multiCalendars > 0
    })), Lt = F(() => ({
      dp__menu_disabled: r.disabled,
      dp__menu_readonly: r.readonly
    })), Vr = F(
      () => (T) => Wr(_t, T)
    ), Ur = F(
      () => ({
        dp__menu: !0,
        dp__menu_index: !r.inline,
        dp__relative: r.inline,
        [r.menuClassName]: !!r.menuClassName
      })
    ), Wr = (T, q) => T.value(q).map((He) => ({
      ...He,
      days: He.days.map((Ze) => (Ze.marker = b(Ze), Ze.classData = de(Ze), Ze))
    })), en = (T) => {
      T.stopPropagation(), T.stopImmediatePropagation();
    }, m = () => {
      r.escClose && n("close-picker");
    }, R = (T, q = !1) => {
      v(T, q), r.spaceConfirm && n("select-date");
    }, te = (T) => {
      var q;
      (q = r.flow) != null && q.length && (y[T] = !0, Object.keys(y).filter((He) => !y[He]).length || Oe());
    }, ie = (T, q, He, Ze, ...tn) => {
      if (r.flow[z.value] === T) {
        const ue = Ze ? q.value[0] : q.value;
        ue && ue[He](...tn);
      }
    }, Oe = () => {
      ie("month", f, "toggleMonthPicker", !0, !0), ie("year", f, "toggleYearPicker", !0, !0), ie("calendar", I, "toggleTimePicker", !1, !1, !0), ie("time", I, "toggleTimePicker", !1, !0, !0);
      const T = r.flow[z.value];
      (T === "hours" || T === "minutes" || T === "seconds") && ie(T, I, "toggleTimePicker", !1, !0, !0, T);
    }, ot = (T) => {
      if (r.arrowNavigation) {
        if (T === "up")
          return J();
        if (T === "down")
          return ae();
        if (T === "left")
          return j();
        if (T === "right")
          return B();
      } else
        T === "left" || T === "up" ? G("left", 0, T === "up") : G("right", 0, T === "down");
    }, Ot = (T) => {
      o(T.shiftKey), !r.disableMonthYearSelect && T.code === "Tab" && T.target.classList.contains("dp__menu") && i.value.shiftKeyInMenu && (T.preventDefault(), T.stopImmediatePropagation(), n("close-picker"));
    };
    return t({
      updateMonthYear: u
    }), (T, q) => {
      var He;
      return w(), fe(Ut, {
        appear: "",
        name: (He = c(l).transitions) == null ? void 0 : He.menuAppear,
        mode: "out-in",
        css: !!T.transitions
      }, {
        default: Q(() => {
          var Ze, tn;
          return [
            se("div", {
              id: T.uid ? `dp-menu-${T.uid}` : void 0,
              tabindex: "0",
              ref_key: "dpMenuRef",
              ref: Y,
              role: "dialog",
              class: pe(c(Ur)),
              onMouseleave: q[14] || (q[14] = //@ts-ignore
              (...ue) => c(ve) && c(ve)(...ue)),
              onClick: en,
              onKeydown: [
                me(m, ["esc"]),
                q[15] || (q[15] = me(mt((ue) => ot("left"), ["prevent"]), ["left"])),
                q[16] || (q[16] = me(mt((ue) => ot("up"), ["prevent"]), ["up"])),
                q[17] || (q[17] = me(mt((ue) => ot("down"), ["prevent"]), ["down"])),
                q[18] || (q[18] = me(mt((ue) => ot("right"), ["prevent"]), ["right"])),
                Ot
              ]
            }, [
              (T.disabled || T.readonly) && T.inline ? (w(), E("div", {
                key: 0,
                class: pe(c(Lt))
              }, null, 2)) : x("", !0),
              !T.inline && !T.teleportCenter ? (w(), E("div", {
                key: 1,
                class: pe(c(Ke))
              }, null, 2)) : x("", !0),
              se("div", {
                class: pe({
                  dp__menu_content_wrapper: ((Ze = T.presetRanges) == null ? void 0 : Ze.length) || !!T.$slots["left-sidebar"] || !!T.$slots["right-sidebar"]
                })
              }, [
                T.$slots["left-sidebar"] ? (w(), E("div", rh, [
                  W(T.$slots, "left-sidebar")
                ])) : x("", !0),
                (tn = T.presetRanges) != null && tn.length ? (w(), E("div", ah, [
                  (w(!0), E(he, null, Ae(T.presetRanges, (ue, It) => (w(), E("div", {
                    key: It,
                    style: kt(ue.style || {}),
                    class: "dp__preset_range",
                    onClick: (ye) => c(k)(ue.range, !!ue.slot)
                  }, [
                    ue.slot ? W(T.$slots, ue.slot, {
                      key: 0,
                      presetDateRange: c(k),
                      label: ue.label,
                      range: ue.range
                    }) : (w(), E(he, { key: 1 }, [
                      Ve(Te(ue.label), 1)
                    ], 64))
                  ], 12, oh))), 128))
                ])) : x("", !0),
                se("div", {
                  class: "dp__instance_calendar",
                  ref_key: "calendarWrapperRef",
                  ref: g,
                  role: "document"
                }, [
                  se("div", {
                    class: pe(c(Fr))
                  }, [
                    (w(!0), E(he, null, Ae(c(rt), (ue, It) => (w(), E("div", {
                      key: ue,
                      class: pe(c(Jt))
                    }, [
                      !T.disableMonthYearSelect && !T.timePicker ? (w(), fe(Wv, Fe({
                        key: 0,
                        ref_for: !0,
                        ref: (ye) => {
                          ye && (f.value[It] = ye);
                        },
                        months: c(Me),
                        years: c(ee),
                        month: c(K)(ue),
                        year: c(oe)(ue),
                        instance: ue,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: q[0] || (q[0] = (ye) => te("monthYearInput")),
                        onResetFlow: V,
                        onUpdateMonthYear: (ye) => c(u)(ue, ye),
                        onMonthYearSelect: c(_),
                        onOverlayClosed: O
                      }), Xe({ _: 2 }, [
                        Ae(c(nt), (ye, Gu) => ({
                          name: ye,
                          fn: Q((Lr) => [
                            W(T.$slots, ye, Je(yt(Lr)))
                          ])
                        }))
                      ]), 1040, ["months", "years", "month", "year", "instance", "internal-model-value", "onUpdateMonthYear", "onMonthYearSelect"])) : x("", !0),
                      Re(xv, Fe({
                        ref_for: !0,
                        ref: (ye) => {
                          ye && (h.value[It] = ye);
                        },
                        "specific-mode": c(Yr),
                        "get-week-num": c($),
                        instance: ue,
                        "mapped-dates": c(Vr)(ue),
                        month: c(K)(ue),
                        year: c(oe)(ue)
                      }, T.$props, {
                        "flow-step": z.value,
                        "onUpdate:flowStep": q[1] || (q[1] = (ye) => z.value = ye),
                        onSelectDate: (ye) => c(v)(ye, !c(Wt)(ue)),
                        onHandleSpace: (ye) => R(ye, !c(Wt)(ue)),
                        onSetHoverDate: q[2] || (q[2] = (ye) => c(we)(ye)),
                        onHandleScroll: (ye) => c(N)(ye, ue),
                        onHandleSwipe: (ye) => c(ne)(ye, ue),
                        onMount: q[3] || (q[3] = (ye) => te("calendar")),
                        onResetFlow: V,
                        onTooltipOpen: q[4] || (q[4] = (ye) => T.$emit("tooltip-open", ye)),
                        onTooltipClose: q[5] || (q[5] = (ye) => T.$emit("tooltip-close", ye))
                      }), Xe({ _: 2 }, [
                        Ae(c(De), (ye, Gu) => ({
                          name: ye,
                          fn: Q((Lr) => [
                            W(T.$slots, ye, Je(yt({ ...Lr })))
                          ])
                        }))
                      ]), 1040, ["specific-mode", "get-week-num", "instance", "mapped-dates", "month", "year", "flow-step", "onSelectDate", "onHandleSpace", "onHandleScroll", "onHandleSwipe"])
                    ], 2))), 128))
                  ], 2),
                  se("div", null, [
                    T.$slots["time-picker"] ? W(T.$slots, "time-picker", Je(Fe({ key: 0 }, { time: c(P), updateTime: c(S) }))) : (w(), E(he, { key: 1 }, [
                      T.enableTimePicker && !T.monthPicker && !T.weekPicker ? (w(), fe(eh, Fe({
                        key: 0,
                        ref_key: "timePickerRef",
                        ref: I,
                        hours: c(P).hours,
                        minutes: c(P).minutes,
                        seconds: c(P).seconds,
                        "internal-model-value": e.internalModelValue
                      }, T.$props, {
                        onMount: q[6] || (q[6] = (ue) => te("timePicker")),
                        "onUpdate:hours": q[7] || (q[7] = (ue) => c(S)(ue)),
                        "onUpdate:minutes": q[8] || (q[8] = (ue) => c(S)(ue, !1)),
                        "onUpdate:seconds": q[9] || (q[9] = (ue) => c(S)(ue, !1, !0)),
                        onResetFlow: V,
                        onOverlayClosed: O
                      }), Xe({ _: 2 }, [
                        Ae(c(ce), (ue, It) => ({
                          name: ue,
                          fn: Q((ye) => [
                            W(T.$slots, ue, Je(yt(ye)))
                          ])
                        }))
                      ]), 1040, ["hours", "minutes", "seconds", "internal-model-value"])) : x("", !0)
                    ], 64))
                  ])
                ], 512),
                T.$slots["right-sidebar"] ? (w(), E("div", ih, [
                  W(T.$slots, "right-sidebar")
                ])) : x("", !0),
                T.showNowButton ? (w(), E("div", uh, [
                  T.$slots["now-button"] ? W(T.$slots, "now-button", {
                    key: 0,
                    selectCurrentDate: c(p)
                  }) : x("", !0),
                  T.$slots["now-button"] ? x("", !0) : (w(), E("button", {
                    key: 1,
                    type: "button",
                    role: "button",
                    class: "dp__now_button",
                    onClick: q[10] || (q[10] = //@ts-ignore
                    (...ue) => c(p) && c(p)(...ue))
                  }, Te(T.nowButtonLabel), 1))
                ])) : x("", !0)
              ], 2),
              !T.autoApply || T.keepActionRow ? (w(), fe(bv, Fe({
                key: 2,
                "menu-mount": X.value,
                "calendar-width": H.value,
                "internal-model-value": e.internalModelValue
              }, T.$props, {
                onClosePicker: q[11] || (q[11] = (ue) => T.$emit("close-picker")),
                onSelectDate: q[12] || (q[12] = (ue) => T.$emit("select-date")),
                onInvalidSelect: q[13] || (q[13] = (ue) => T.$emit("invalid-select"))
              }), Xe({ _: 2 }, [
                Ae(c(Qe), (ue, It) => ({
                  name: ue,
                  fn: Q((ye) => [
                    W(T.$slots, ue, Je(yt({ ...ye })))
                  ])
                }))
              ]), 1040, ["menu-mount", "calendar-width", "internal-model-value"])) : x("", !0)
            ], 42, nh)
          ];
        }),
        _: 3
      }, 8, ["name", "css"]);
    };
  }
}), sh = typeof window < "u" ? window : void 0, ra = () => {
}, ch = (e) => ll() ? (sl(e), !0) : !1, fh = (e, t, n, r) => {
  if (!e)
    return ra;
  let a = ra;
  const o = Dt(
    () => c(e),
    (s) => {
      a(), s && (s.addEventListener(t, n, r), a = () => {
        s.removeEventListener(t, n, r), a = ra;
      });
    },
    { immediate: !0, flush: "post" }
  ), i = () => {
    o(), a();
  };
  return ch(i), i;
}, dh = (e, t, n, r = {}) => {
  const { window: a = sh, event: o = "pointerdown" } = r;
  return a ? fh(a, o, (i) => {
    const s = Be(e), l = Be(t);
    !s || !l || s === i.target || i.composedPath().includes(s) || i.composedPath().includes(l) || n(i);
  }, { passive: !0 }) : void 0;
}, yh = /* @__PURE__ */ Ee({
  __name: "VueDatePicker",
  props: {
    ...wt
  },
  emits: [
    "update:model-value",
    "text-submit",
    "closed",
    "cleared",
    "open",
    "focus",
    "blur",
    "internal-model-change",
    "recalculate-position",
    "flow-step",
    "update-month-year",
    "invalid-select",
    "invalid-fixed-range",
    "tooltip-open",
    "tooltip-close"
  ],
  setup(e, { expose: t, emit: n }) {
    const r = e, a = bo(), o = L(!1), i = Gn(r, "modelValue"), s = Gn(r, "timezone"), l = L(null), d = L(null), g = L(!1), y = L(null), { setMenuFocused: f, setShiftKey: h } = Hu(), { clearArrowNav: I } = bt(), { validateDate: Y, isValidTime: H, defaults: X } = et(r);
    at(() => {
      C(r.modelValue), r.inline || (O(y.value).addEventListener("scroll", u), window.addEventListener("resize", v)), r.inline && (o.value = !0);
    }), wo(() => {
      if (!r.inline) {
        const ee = O(y.value);
        ee && ee.removeEventListener("scroll", u), window.removeEventListener("resize", v);
      }
    });
    const z = Tt(a, "all", r.presetRanges), B = Tt(a, "input");
    Dt(
      [i, s],
      () => {
        C(i.value);
      },
      { deep: !0 }
    );
    const { openOnTop: j, menuPosition: ae, setMenuPosition: J, setInitialPosition: D, getScrollableParent: O } = uv(
      l,
      d,
      n,
      r
    ), {
      inputValue: A,
      internalModelValue: V,
      parseExternalModelValue: C,
      emitModelValue: U,
      formatInputValue: K,
      checkBeforeEmit: oe
    } = ov(n, r, g), P = F(
      () => ({
        dp__main: !0,
        dp__theme_dark: r.dark,
        dp__theme_light: !r.dark,
        dp__flex_display: r.inline,
        dp__flex_display_with_input: r.inlineWithInput
      })
    ), S = F(() => r.dark ? "dp__theme_dark" : "dp__theme_light"), u = () => {
      o.value && (r.closeOnScroll ? k() : J());
    }, v = () => {
      o.value && J();
    }, $ = () => {
      !r.disabled && !r.readonly && (D(), o.value = !0, Yt().then(() => {
        J(), o.value && n("open");
      }), o.value || p(), C(r.modelValue));
    }, _ = () => {
      A.value = "", p(), n("update:model-value", null), n("cleared"), k();
    }, N = () => {
      const ee = V.value;
      return !ee || !Array.isArray(ee) && Y(ee) ? !0 : Array.isArray(ee) ? ee.length === 2 && Y(ee[0]) && Y(ee[1]) ? !0 : Y(ee[0]) : !1;
    }, G = () => {
      oe() && N() ? (U(), k()) : n("invalid-select", V.value);
    }, ne = (ee) => {
      U(), r.closeOnAutoApply && !ee && k();
    }, b = (ee = !1) => {
      r.autoApply && H(V.value) && N() && (r.range && Array.isArray(V.value) ? (r.partialRange || V.value.length === 2) && ne(ee) : ne(ee));
    }, p = () => {
      r.textInput || (V.value = null);
    }, k = () => {
      r.inline || (o.value && (o.value = !1, f(!1), h(!1), I(), n("closed"), D(), A.value && C(i.value)), p(), d.value && d.value.focusInput());
    }, we = (ee, Me) => {
      if (!ee) {
        V.value = null;
        return;
      }
      V.value = ee, Me && (G(), n("text-submit"));
    }, ve = () => {
      r.autoApply && H(V.value) && U();
    }, de = () => o.value ? k() : $(), De = (ee) => {
      V.value = ee;
    }, Qe = F(() => r.textInput && X.value.textInputOptions.format), ce = () => {
      Qe.value && (g.value = !0, K()), n("focus");
    }, nt = () => {
      Qe.value && (g.value = !1, K()), n("blur");
    }, Ke = (ee) => {
      l.value && l.value.updateMonthYear(0, {
        month: uu(ee.month),
        year: uu(ee.year)
      });
    };
    return dh(
      l,
      d,
      r.onClickOutside ? () => r.onClickOutside(N) : k
    ), t({
      closeMenu: k,
      selectDate: G,
      clearValue: _,
      openMenu: $,
      onScroll: u,
      formatInputValue: K,
      // exposed for testing purposes
      updateInternalModelValue: De,
      // modify internal modelValue
      setMonthYear: Ke
    }), (ee, Me) => (w(), E("div", {
      class: pe(c(P)),
      ref_key: "pickerWrapperRef",
      ref: y
    }, [
      Re(pv, Fe({
        ref_key: "inputRef",
        ref: d,
        "is-menu-open": o.value,
        "input-value": c(A),
        "onUpdate:inputValue": Me[0] || (Me[0] = (_e) => We(A) ? A.value = _e : null)
      }, ee.$props, {
        onClear: _,
        onOpen: $,
        onSetInputDate: we,
        onSetEmptyDate: c(U),
        onSelectDate: G,
        onToggle: de,
        onClose: k,
        onFocus: ce,
        onBlur: nt
      }), Xe({ _: 2 }, [
        Ae(c(B), (_e, _t) => ({
          name: _e,
          fn: Q((rt) => [
            W(ee.$slots, _e, Je(yt(rt)))
          ])
        }))
      ]), 1040, ["is-menu-open", "input-value", "onSetEmptyDate"]),
      o.value ? (w(), E(he, { key: 0 }, [
        o.value ? (w(), fe(lh, Fe({
          key: 0,
          ref_key: "dpMenuRef",
          ref: l,
          class: c(S),
          style: c(ae),
          "open-on-top": c(j)
        }, ee.$props, {
          "internal-model-value": c(V),
          "onUpdate:internalModelValue": Me[1] || (Me[1] = (_e) => We(V) ? V.value = _e : null),
          onClosePicker: k,
          onSelectDate: G,
          onAutoApply: b,
          onTimeUpdate: ve,
          onFlowStep: Me[2] || (Me[2] = (_e) => ee.$emit("flow-step", _e)),
          onUpdateMonthYear: Me[3] || (Me[3] = (_e) => ee.$emit("update-month-year", _e)),
          onInvalidSelect: Me[4] || (Me[4] = (_e) => ee.$emit("invalid-select", c(V))),
          onInvalidFixedRange: Me[5] || (Me[5] = (_e) => ee.$emit("invalid-fixed-range", _e)),
          onRecalculatePosition: c(J),
          onTooltipOpen: Me[6] || (Me[6] = (_e) => ee.$emit("tooltip-open", _e)),
          onTooltipClose: Me[7] || (Me[7] = (_e) => ee.$emit("tooltip-close", _e))
        }), Xe({ _: 2 }, [
          Ae(c(z), (_e, _t) => ({
            name: _e,
            fn: Q((rt) => [
              W(ee.$slots, _e, Je(yt({ ...rt })))
            ])
          }))
        ]), 1040, ["class", "style", "open-on-top", "internal-model-value", "onRecalculatePosition"])) : x("", !0)
      ], 64)) : x("", !0)
    ], 2));
  }
}), Io = /* @__PURE__ */ (() => {
  const e = yh;
  return e.install = (t) => {
    t.component("Vue3DatePicker", e);
  }, e;
})(), mh = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: Io
}, Symbol.toStringTag, { value: "Module" }));
Object.entries(mh).forEach(([e, t]) => {
  e !== "default" && (Io[e] = t);
});
const ph = /* @__PURE__ */ Ee({
  __name: "FormInputDatePicker",
  props: {
    label: null,
    size: null,
    validationMessages: null,
    validation: null,
    disabled: { type: Boolean, default: !1 },
    modelValue: null,
    hint: null,
    placeholder: null,
    id: null,
    readOnly: { type: Boolean, default: !1 },
    showAsRequired: { type: Boolean },
    locale: { default: "cs-CZ" },
    minDate: null,
    maxDate: null,
    enableTime: { type: Boolean, default: !1 },
    ignoreTimeValidation: { type: Boolean, default: !0 },
    dateFormat: null
  },
  emits: ["update:modelValue", "change", "update", "blur"],
  setup(e, { emit: t }) {
    const n = e, r = F({
      get() {
        const l = c(n.modelValue);
        if (!l)
          return;
        if (l instanceof Date)
          return l;
        const d = new Date(l);
        if (d && !isNaN(d.valueOf()))
          return d;
      },
      set(l) {
        let d = c(l);
        !(d instanceof Date) && (typeof d == "string" || typeof d == "number") && (d = new Date(d)), d instanceof Date && !c(n.enableTime) && (d = new Date(`${d.toISOString().split("T")[0]}T00:00:00.000Z`)), t("update:modelValue", d);
        const g = c(n.validation);
        typeof (g == null ? void 0 : g.$touch) == "function" && g.$touch();
      }
    }), a = F(() => {
      const l = c(n.dateFormat);
      return typeof l == "function" ? l : c(c(n.enableTime) ? Ol : hu);
    }), o = F(() => {
      const l = c(r);
      return l instanceof Date ? c(a)(l) : l;
    }), {
      isRequired: i,
      invalid: s
    } = Mt(n, t);
    return (l, d) => {
      const g = go, y = ht, f = gt;
      return w(), fe(f, {
        description: e.hint,
        "label-for": e.id ? `${e.id}_input` : void 0,
        class: pe({ "form-group-required": c(i) })
      }, {
        label: Q(() => [
          Ve(Te(e.label), 1)
        ]),
        default: Q(() => [
          Re(c(Io), {
            modelValue: c(r),
            "onUpdate:modelValue": d[0] || (d[0] = (h) => We(r) ? r.value = h : null),
            "text-input": "",
            "auto-apply": !0,
            "close-on-auto-apply": !e.enableTime,
            disabled: e.disabled,
            "enable-time-picker": e.enableTime,
            "min-date": e.minDate || void 0,
            "max-date": e.maxDate || void 0,
            "prevent-min-max-navigation": !!(e.minDate || e.maxDate),
            "ignore-time-validation": e.ignoreTimeValidation,
            format: c(a),
            locale: e.locale,
            uid: e.id ? `dtpkr_${e.id}` : void 0
          }, {
            "dp-input": Q(() => [
              Re(g, {
                type: "text",
                id: e.id ? `${e.id}_input` : void 0,
                placeholder: e.placeholder,
                size: e.size,
                state: c(s) !== null ? !c(s) : null,
                disabled: e.disabled,
                "model-value": c(o) ?? "",
                readonly: !0
              }, null, 8, ["id", "placeholder", "size", "state", "disabled", "model-value"])
            ]),
            _: 1
          }, 8, ["modelValue", "close-on-auto-apply", "disabled", "enable-time-picker", "min-date", "max-date", "prevent-min-max-navigation", "ignore-time-validation", "format", "locale", "uid"]),
          c(s) && e.validation ? (w(), fe(y, { key: 0 }, {
            default: Q(() => [
              Re(Nt, {
                "validation-model": e.validation,
                messages: e.validationMessages
              }, null, 8, ["validation-model", "messages"])
            ]),
            _: 1
          })) : x("", !0),
          W(l.$slots, "input-text")
        ]),
        _: 3
      }, 8, ["description", "label-for", "class"]);
    };
  }
}), vh = ml, hh = pl, gh = vl, bh = hl, wh = bl, _h = wl, Oh = ph, kh = {
  install(e) {
    e.component("BForm", Qu), e.component("BFormCheckbox", du), e.component("BFormCheckboxGroup", yu), e.component("BFormFloatingLabel", Ku), e.component("BFormGroup", gt), e.component("BFormInput", go), e.component("BFormInvalidFeedback", ht), e.component("BFormRadio", Zu), e.component("BFormRadioGroup", mu), e.component("BFormRow", Xu), e.component("BFormSelect", pu), e.component("BFormSelectOption", Ju), e.component("BFormSelectOptionGroup", el), e.component("BFormSpinButton", tl), e.component("BFormTag", nl), e.component("BFormTags", rl), e.component("BFormText", al), e.component("BFormTextarea", vu), e.component("BFormValidFeedback", ol), e.component("FormInput", vh), e.component("FormInputTextarea", _h), e.component("FormInputCheckbox", hh), e.component("FormInputCheckboxGroup", gh), e.component("FormInputRadioGroup", bh), e.component("FormInputSelect", wh), e.component("FormInputDatePicker", Oh);
  }
};
export {
  vh as FormInput,
  hh as FormInputCheckbox,
  gh as FormInputCheckboxGroup,
  Oh as FormInputDatePicker,
  bh as FormInputRadioGroup,
  wh as FormInputSelect,
  _h as FormInputTextarea,
  kh as FormInputsPlugin
};
